/* Client.c generated by valac 0.56.3, the Vala compiler
 * generated from Client.vala, do not modify */

/**/
/*  Copyright (C) 2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#define PLANK_DBUS_DOCK_INTERFACE_NAME "net.launchpad.plank"
#define PLANK_DBUS_PING_NAME "Ping"
#define PLANK_DBUS_CLIENT_INTERFACE_NAME "net.launchpad.plank.Client"

#define PLANK_TYPE_DBUS_ITEMS_IFACE (plank_dbus_items_iface_get_type ())
#define PLANK_DBUS_ITEMS_IFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_DBUS_ITEMS_IFACE, PlankDBusItemsIface))
#define PLANK_IS_DBUS_ITEMS_IFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_DBUS_ITEMS_IFACE))
#define PLANK_DBUS_ITEMS_IFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLANK_TYPE_DBUS_ITEMS_IFACE, PlankDBusItemsIfaceIface))

typedef struct _PlankDBusItemsIface PlankDBusItemsIface;
typedef struct _PlankDBusItemsIfaceIface PlankDBusItemsIfaceIface;

#define PLANK_TYPE_DBUS_ITEMS_IFACE_PROXY (plank_dbus_items_iface_proxy_get_type ())
enum  {
	PLANK_DBUS_CLIENT_0_PROPERTY,
	PLANK_DBUS_CLIENT_IS_CONNECTED_PROPERTY,
	PLANK_DBUS_CLIENT_NUM_PROPERTIES
};
static GParamSpec* plank_dbus_client_properties[PLANK_DBUS_CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	PLANK_DBUS_CLIENT_PROXY_CHANGED_SIGNAL,
	PLANK_DBUS_CLIENT_NUM_SIGNALS
};
static guint plank_dbus_client_signals[PLANK_DBUS_CLIENT_NUM_SIGNALS] = {0};

struct _PlankDBusItemsIfaceIface {
	GTypeInterface parent_iface;
	gboolean (*add) (PlankDBusItemsIface* self, const gchar* uri, GError** error);
	gboolean (*remove) (PlankDBusItemsIface* self, const gchar* uri, GError** error);
	gint (*get_count) (PlankDBusItemsIface* self, GError** error);
	gchar** (*get_persistent_applications) (PlankDBusItemsIface* self, gint* result_length1, GError** error);
	gchar** (*get_transient_applications) (PlankDBusItemsIface* self, gint* result_length1, GError** error);
	gboolean (*get_hover_position) (PlankDBusItemsIface* self, const gchar* uri, gint* x, gint* y, GtkPositionType* dock_position, GError** error);
};

struct _PlankDBusClientPrivate {
	GDBusConnection* connection;
	gchar* client_object_path;
	gchar* dock_bus_owner;
	gchar* dock_bus_name;
	gchar* dock_object_path;
	guint dbus_dock_ping_id;
	guint dbus_name_owner_changed_signal_id;
	PlankDBusItemsIface* items_proxy;
	gint items_count;
	gchar** persistent_apps_list;
	gint persistent_apps_list_length1;
	gint _persistent_apps_list_size_;
	gchar** transient_apps_list;
	gint transient_apps_list_length1;
	gint _transient_apps_list_size_;
};

static gint PlankDBusClient_private_offset;
static gpointer plank_dbus_client_parent_class = NULL;
static PlankDBusClient* plank_dbus_client_instance;
static PlankDBusClient* plank_dbus_client_instance = NULL;

VALA_EXTERN GType plank_dbus_items_iface_proxy_get_type (void) G_GNUC_CONST ;
 G_GNUC_INTERNAL guint plank_dbus_items_iface_register_object (void* object,
                                              GDBusConnection* connection,
                                              const gchar* path,
                                              GError** error);
 G_GNUC_INTERNAL GType plank_dbus_items_iface_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static PlankDBusClient* plank_dbus_client_new (void);
static PlankDBusClient* plank_dbus_client_construct (GType object_type);
static void plank_dbus_client_handle_dock_ping (GDBusConnection* connection,
                                         const gchar* sender_name,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* signal_name,
                                         GVariant* parameters,
                                         PlankDBusClient* self);
static void plank_dbus_client_connect_proxies (PlankDBusClient* self,
                                        GDBusConnection* connection,
                                        const gchar* sender_name,
                                        const gchar* object_path);
static void plank_dbus_client_handle_name_owner_changed (GDBusConnection* connection,
                                                  const gchar* sender_name,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* signal_name,
                                                  GVariant* parameters,
                                                  PlankDBusClient* self);
static void plank_dbus_client_disconnect_proxies (PlankDBusClient* self);
static void plank_dbus_client_invalidate_items_cache (PlankDBusClient* self);
static void _plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed (PlankDBusItemsIface* _sender,
                                                                               gpointer self);
 G_GNUC_INTERNAL gboolean plank_dbus_items_iface_add (PlankDBusItemsIface* self,
                                     const gchar* uri,
                                     GError** error);
 G_GNUC_INTERNAL gboolean plank_dbus_items_iface_remove (PlankDBusItemsIface* self,
                                        const gchar* uri,
                                        GError** error);
 G_GNUC_INTERNAL gint plank_dbus_items_iface_get_count (PlankDBusItemsIface* self,
                                       GError** error);
 G_GNUC_INTERNAL gchar** plank_dbus_items_iface_get_persistent_applications (PlankDBusItemsIface* self,
                                                            gint* result_length1,
                                                            GError** error);
 G_GNUC_INTERNAL gchar** plank_dbus_items_iface_get_transient_applications (PlankDBusItemsIface* self,
                                                           gint* result_length1,
                                                           GError** error);
 G_GNUC_INTERNAL gboolean plank_dbus_items_iface_get_hover_position (PlankDBusItemsIface* self,
                                                    const gchar* uri,
                                                    gint* x,
                                                    gint* y,
                                                    GtkPositionType* dock_position,
                                                    GError** error);
static GObject * plank_dbus_client_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void plank_dbus_client_finalize (GObject * obj);
static GType plank_dbus_client_get_type_once (void);
static void _vala_plank_dbus_client_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
plank_dbus_client_get_instance_private (PlankDBusClient* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDBusClient_private_offset);
}

/**
 * Get the singleton instance of {@link Plank.DBusClient}
 */
PlankDBusClient*
plank_dbus_client_get_instance (void)
{
	PlankDBusClient* _tmp0_;
	PlankDBusClient* _tmp2_;
	PlankDBusClient* result;
#line 35 "../lib/DBus/Client.vala"
	_tmp0_ = plank_dbus_client_instance;
#line 35 "../lib/DBus/Client.vala"
	if (_tmp0_ == NULL) {
#line 178 "Client.c"
		PlankDBusClient* _tmp1_;
#line 36 "../lib/DBus/Client.vala"
		_tmp1_ = plank_dbus_client_new ();
#line 36 "../lib/DBus/Client.vala"
		_g_object_unref0 (plank_dbus_client_instance);
#line 36 "../lib/DBus/Client.vala"
		plank_dbus_client_instance = _tmp1_;
#line 186 "Client.c"
	}
#line 38 "../lib/DBus/Client.vala"
	_tmp2_ = plank_dbus_client_instance;
#line 38 "../lib/DBus/Client.vala"
	result = _tmp2_;
#line 38 "../lib/DBus/Client.vala"
	return result;
#line 194 "Client.c"
}

static PlankDBusClient*
plank_dbus_client_construct (GType object_type)
{
	PlankDBusClient * self = NULL;
#line 74 "../lib/DBus/Client.vala"
	self = (PlankDBusClient*) g_object_new (object_type, NULL);
#line 72 "../lib/DBus/Client.vala"
	return self;
#line 205 "Client.c"
}

static PlankDBusClient*
plank_dbus_client_new (void)
{
#line 72 "../lib/DBus/Client.vala"
	return plank_dbus_client_construct (PLANK_TYPE_DBUS_CLIENT);
#line 213 "Client.c"
}

static void
plank_dbus_client_handle_dock_ping (GDBusConnection* connection,
                                    const gchar* sender_name,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* signal_name,
                                    GVariant* parameters,
                                    PlankDBusClient* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 124 "../lib/DBus/Client.vala"
	g_return_if_fail (self != NULL);
#line 124 "../lib/DBus/Client.vala"
	g_return_if_fail (connection != NULL);
#line 124 "../lib/DBus/Client.vala"
	g_return_if_fail (sender_name != NULL);
#line 124 "../lib/DBus/Client.vala"
	g_return_if_fail (object_path != NULL);
#line 124 "../lib/DBus/Client.vala"
	g_return_if_fail (interface_name != NULL);
#line 124 "../lib/DBus/Client.vala"
	g_return_if_fail (signal_name != NULL);
#line 124 "../lib/DBus/Client.vala"
	g_return_if_fail (parameters != NULL);
#line 127 "../lib/DBus/Client.vala"
	_tmp1_ = self->priv->dock_bus_name;
#line 127 "../lib/DBus/Client.vala"
	if (_tmp1_ == NULL) {
#line 245 "Client.c"
		const gchar* _tmp2_;
#line 127 "../lib/DBus/Client.vala"
		_tmp2_ = self->priv->dock_bus_name;
#line 127 "../lib/DBus/Client.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, sender_name) != 0;
#line 251 "Client.c"
	} else {
#line 127 "../lib/DBus/Client.vala"
		_tmp0_ = FALSE;
#line 255 "Client.c"
	}
#line 127 "../lib/DBus/Client.vala"
	if (_tmp0_) {
#line 128 "../lib/DBus/Client.vala"
		plank_dbus_client_connect_proxies (self, connection, sender_name, object_path);
#line 261 "Client.c"
	}
}

static void
plank_dbus_client_handle_name_owner_changed (GDBusConnection* connection,
                                             const gchar* sender_name,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* signal_name,
                                             GVariant* parameters,
                                             PlankDBusClient* self)
{
	gchar* name = NULL;
	gchar* before = NULL;
	gchar* after = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp14_;
	const gchar* _tmp16_;
#line 132 "../lib/DBus/Client.vala"
	g_return_if_fail (self != NULL);
#line 132 "../lib/DBus/Client.vala"
	g_return_if_fail (connection != NULL);
#line 132 "../lib/DBus/Client.vala"
	g_return_if_fail (sender_name != NULL);
#line 132 "../lib/DBus/Client.vala"
	g_return_if_fail (object_path != NULL);
#line 132 "../lib/DBus/Client.vala"
	g_return_if_fail (interface_name != NULL);
#line 132 "../lib/DBus/Client.vala"
	g_return_if_fail (signal_name != NULL);
#line 132 "../lib/DBus/Client.vala"
	g_return_if_fail (parameters != NULL);
#line 136 "../lib/DBus/Client.vala"
	g_variant_get (parameters, "(sss)", &_tmp0_, &_tmp1_, &_tmp2_, NULL);
#line 136 "../lib/DBus/Client.vala"
	_g_free0 (name);
#line 136 "../lib/DBus/Client.vala"
	name = _tmp0_;
#line 136 "../lib/DBus/Client.vala"
	_g_free0 (before);
#line 136 "../lib/DBus/Client.vala"
	before = _tmp1_;
#line 136 "../lib/DBus/Client.vala"
	_g_free0 (after);
#line 136 "../lib/DBus/Client.vala"
	after = _tmp2_;
#line 138 "../lib/DBus/Client.vala"
	_tmp4_ = self->priv->dock_bus_owner;
#line 138 "../lib/DBus/Client.vala"
	if (_tmp4_ != NULL) {
#line 320 "Client.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 138 "../lib/DBus/Client.vala"
		_tmp5_ = self->priv->dock_bus_owner;
#line 138 "../lib/DBus/Client.vala"
		_tmp6_ = after;
#line 138 "../lib/DBus/Client.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, _tmp6_) == 0;
#line 329 "Client.c"
	} else {
#line 138 "../lib/DBus/Client.vala"
		_tmp3_ = FALSE;
#line 333 "Client.c"
	}
#line 138 "../lib/DBus/Client.vala"
	if (_tmp3_) {
#line 139 "../lib/DBus/Client.vala"
		_g_free0 (after);
#line 139 "../lib/DBus/Client.vala"
		_g_free0 (before);
#line 139 "../lib/DBus/Client.vala"
		_g_free0 (name);
#line 139 "../lib/DBus/Client.vala"
		return;
#line 345 "Client.c"
	}
#line 141 "../lib/DBus/Client.vala"
	_tmp9_ = name;
#line 141 "../lib/DBus/Client.vala"
	if (_tmp9_ != NULL) {
#line 351 "Client.c"
		const gchar* _tmp10_;
#line 141 "../lib/DBus/Client.vala"
		_tmp10_ = name;
#line 141 "../lib/DBus/Client.vala"
		_tmp8_ = g_strcmp0 (_tmp10_, "") != 0;
#line 357 "Client.c"
	} else {
#line 141 "../lib/DBus/Client.vala"
		_tmp8_ = FALSE;
#line 361 "Client.c"
	}
#line 141 "../lib/DBus/Client.vala"
	if (_tmp8_) {
#line 365 "Client.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 141 "../lib/DBus/Client.vala"
		_tmp11_ = name;
#line 141 "../lib/DBus/Client.vala"
		_tmp12_ = self->priv->dock_bus_name;
#line 141 "../lib/DBus/Client.vala"
		_tmp7_ = g_strcmp0 (_tmp11_, _tmp12_) != 0;
#line 374 "Client.c"
	} else {
#line 141 "../lib/DBus/Client.vala"
		_tmp7_ = FALSE;
#line 378 "Client.c"
	}
#line 141 "../lib/DBus/Client.vala"
	if (_tmp7_) {
#line 142 "../lib/DBus/Client.vala"
		_g_free0 (after);
#line 142 "../lib/DBus/Client.vala"
		_g_free0 (before);
#line 142 "../lib/DBus/Client.vala"
		_g_free0 (name);
#line 142 "../lib/DBus/Client.vala"
		return;
#line 390 "Client.c"
	}
#line 144 "../lib/DBus/Client.vala"
	_tmp14_ = after;
#line 144 "../lib/DBus/Client.vala"
	if (_tmp14_ == NULL) {
#line 144 "../lib/DBus/Client.vala"
		_tmp13_ = TRUE;
#line 398 "Client.c"
	} else {
		const gchar* _tmp15_;
#line 144 "../lib/DBus/Client.vala"
		_tmp15_ = after;
#line 144 "../lib/DBus/Client.vala"
		_tmp13_ = g_strcmp0 (_tmp15_, "") == 0;
#line 405 "Client.c"
	}
#line 144 "../lib/DBus/Client.vala"
	if (_tmp13_) {
#line 145 "../lib/DBus/Client.vala"
		plank_dbus_client_disconnect_proxies (self);
#line 146 "../lib/DBus/Client.vala"
		_g_free0 (after);
#line 146 "../lib/DBus/Client.vala"
		_g_free0 (before);
#line 146 "../lib/DBus/Client.vala"
		_g_free0 (name);
#line 146 "../lib/DBus/Client.vala"
		return;
#line 419 "Client.c"
	}
#line 149 "../lib/DBus/Client.vala"
	_tmp16_ = name;
#line 149 "../lib/DBus/Client.vala"
	plank_dbus_client_connect_proxies (self, connection, _tmp16_, object_path);
#line 132 "../lib/DBus/Client.vala"
	_g_free0 (after);
#line 132 "../lib/DBus/Client.vala"
	_g_free0 (before);
#line 132 "../lib/DBus/Client.vala"
	_g_free0 (name);
#line 431 "Client.c"
}

static void
_plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed (PlankDBusItemsIface* _sender,
                                                                          gpointer self)
{
#line 158 "../lib/DBus/Client.vala"
	plank_dbus_client_invalidate_items_cache ((PlankDBusClient*) self);
#line 440 "Client.c"
}

static void
plank_dbus_client_connect_proxies (PlankDBusClient* self,
                                   GDBusConnection* connection,
                                   const gchar* sender_name,
                                   const gchar* object_path)
{
	GError* _inner_error0_ = NULL;
#line 152 "../lib/DBus/Client.vala"
	g_return_if_fail (self != NULL);
#line 152 "../lib/DBus/Client.vala"
	g_return_if_fail (connection != NULL);
#line 152 "../lib/DBus/Client.vala"
	g_return_if_fail (sender_name != NULL);
#line 152 "../lib/DBus/Client.vala"
	g_return_if_fail (object_path != NULL);
#line 154 "../lib/DBus/Client.vala"
	g_debug ("Client.vala:154: Connecting and create proxies for '%s' (%s)", sender_name, object_path);
#line 460 "Client.c"
	{
		PlankDBusItemsIface* _tmp0_ = NULL;
		PlankDBusItemsIface* _tmp1_;
		PlankDBusItemsIface* _tmp2_;
		PlankDBusItemsIface* _tmp3_;
		PlankDBusItemsIface* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 157 "../lib/DBus/Client.vala"
		_tmp1_ = (PlankDBusItemsIface*) g_initable_new (PLANK_TYPE_DBUS_ITEMS_IFACE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", sender_name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "net.launchpad.plank.Items", NULL);
#line 157 "../lib/DBus/Client.vala"
		_tmp0_ = (PlankDBusItemsIface*) _tmp1_;
#line 157 "../lib/DBus/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 476 "Client.c"
			goto __catch0_g_error;
		}
#line 157 "../lib/DBus/Client.vala"
		_tmp2_ = _tmp0_;
#line 157 "../lib/DBus/Client.vala"
		_tmp0_ = NULL;
#line 157 "../lib/DBus/Client.vala"
		_g_object_unref0 (self->priv->items_proxy);
#line 157 "../lib/DBus/Client.vala"
		self->priv->items_proxy = _tmp2_;
#line 158 "../lib/DBus/Client.vala"
		_tmp3_ = self->priv->items_proxy;
#line 158 "../lib/DBus/Client.vala"
		g_signal_connect_object (_tmp3_, "changed", (GCallback) _plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed, self, 0);
#line 159 "../lib/DBus/Client.vala"
		_tmp4_ = self->priv->items_proxy;
#line 159 "../lib/DBus/Client.vala"
		_tmp5_ = g_dbus_proxy_get_name_owner (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_dbus_proxy_get_type (), GDBusProxy));
#line 159 "../lib/DBus/Client.vala"
		_g_free0 (self->priv->dock_bus_owner);
#line 159 "../lib/DBus/Client.vala"
		self->priv->dock_bus_owner = _tmp5_;
#line 160 "../lib/DBus/Client.vala"
		_tmp6_ = g_strdup (sender_name);
#line 160 "../lib/DBus/Client.vala"
		_g_free0 (self->priv->dock_bus_name);
#line 160 "../lib/DBus/Client.vala"
		self->priv->dock_bus_name = _tmp6_;
#line 161 "../lib/DBus/Client.vala"
		_tmp7_ = g_strdup (object_path);
#line 161 "../lib/DBus/Client.vala"
		_g_free0 (self->priv->dock_object_path);
#line 161 "../lib/DBus/Client.vala"
		self->priv->dock_object_path = _tmp7_;
#line 156 "../lib/DBus/Client.vala"
		_g_object_unref0 (_tmp0_);
#line 513 "Client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 156 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 163 "../lib/DBus/Client.vala"
		_g_free0 (self->priv->dock_bus_owner);
#line 163 "../lib/DBus/Client.vala"
		self->priv->dock_bus_owner = NULL;
#line 164 "../lib/DBus/Client.vala"
		_g_free0 (self->priv->dock_bus_name);
#line 164 "../lib/DBus/Client.vala"
		self->priv->dock_bus_name = NULL;
#line 165 "../lib/DBus/Client.vala"
		_g_free0 (self->priv->dock_object_path);
#line 165 "../lib/DBus/Client.vala"
		self->priv->dock_object_path = NULL;
#line 167 "../lib/DBus/Client.vala"
		_g_object_unref0 (self->priv->items_proxy);
#line 167 "../lib/DBus/Client.vala"
		self->priv->items_proxy = NULL;
#line 168 "../lib/DBus/Client.vala"
		g_critical ("Client.vala:168: Failed to create items proxy for '%s' (%s)", sender_name, object_path);
#line 538 "Client.c"
	}
	__finally0:
#line 156 "../lib/DBus/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../lib/DBus/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 156 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 156 "../lib/DBus/Client.vala"
		return;
#line 549 "Client.c"
	}
#line 171 "../lib/DBus/Client.vala"
	g_signal_emit (self, plank_dbus_client_signals[PLANK_DBUS_CLIENT_PROXY_CHANGED_SIGNAL], 0);
#line 553 "Client.c"
}

static void
plank_dbus_client_disconnect_proxies (PlankDBusClient* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	PlankDBusItemsIface* _tmp2_;
	guint _tmp3_;
#line 174 "../lib/DBus/Client.vala"
	g_return_if_fail (self != NULL);
#line 176 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->dock_bus_name;
#line 176 "../lib/DBus/Client.vala"
	_tmp1_ = self->priv->dock_object_path;
#line 176 "../lib/DBus/Client.vala"
	g_debug ("Client.vala:176: Disconnecting from '%s' (%s)", _tmp0_, _tmp1_);
#line 178 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->dock_bus_owner);
#line 178 "../lib/DBus/Client.vala"
	self->priv->dock_bus_owner = NULL;
#line 179 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->dock_bus_name);
#line 179 "../lib/DBus/Client.vala"
	self->priv->dock_bus_name = NULL;
#line 180 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->dock_object_path);
#line 180 "../lib/DBus/Client.vala"
	self->priv->dock_object_path = NULL;
#line 182 "../lib/DBus/Client.vala"
	_tmp2_ = self->priv->items_proxy;
#line 182 "../lib/DBus/Client.vala"
	g_signal_parse_name ("changed", PLANK_TYPE_DBUS_ITEMS_IFACE, &_tmp3_, NULL, FALSE);
#line 182 "../lib/DBus/Client.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plank_dbus_client_invalidate_items_cache_plank_dbus_items_iface_changed, self);
#line 183 "../lib/DBus/Client.vala"
	_g_object_unref0 (self->priv->items_proxy);
#line 183 "../lib/DBus/Client.vala"
	self->priv->items_proxy = NULL;
#line 593 "Client.c"
}

static void
plank_dbus_client_invalidate_items_cache (PlankDBusClient* self)
{
#line 187 "../lib/DBus/Client.vala"
	g_return_if_fail (self != NULL);
#line 189 "../lib/DBus/Client.vala"
	self->priv->items_count = G_MININT;
#line 190 "../lib/DBus/Client.vala"
	self->priv->persistent_apps_list = (_vala_array_free (self->priv->persistent_apps_list, self->priv->persistent_apps_list_length1, (GDestroyNotify) g_free), NULL);
#line 190 "../lib/DBus/Client.vala"
	self->priv->persistent_apps_list = NULL;
#line 190 "../lib/DBus/Client.vala"
	self->priv->persistent_apps_list_length1 = 0;
#line 190 "../lib/DBus/Client.vala"
	self->priv->_persistent_apps_list_size_ = self->priv->persistent_apps_list_length1;
#line 191 "../lib/DBus/Client.vala"
	self->priv->transient_apps_list = (_vala_array_free (self->priv->transient_apps_list, self->priv->transient_apps_list_length1, (GDestroyNotify) g_free), NULL);
#line 191 "../lib/DBus/Client.vala"
	self->priv->transient_apps_list = NULL;
#line 191 "../lib/DBus/Client.vala"
	self->priv->transient_apps_list_length1 = 0;
#line 191 "../lib/DBus/Client.vala"
	self->priv->_transient_apps_list_size_ = self->priv->transient_apps_list_length1;
#line 619 "Client.c"
}

/**
 * Add a new item for the given uri to the dock
 *
 * @param uri an URI
 * @return whether it was successfully added
 */
gboolean
plank_dbus_client_add_item (PlankDBusClient* self,
                            const gchar* uri)
{
	PlankDBusItemsIface* _tmp0_;
	gboolean _tmp5_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 200 "../lib/DBus/Client.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 200 "../lib/DBus/Client.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 202 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->items_proxy;
#line 202 "../lib/DBus/Client.vala"
	if (_tmp0_ == NULL) {
#line 203 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:203: No proxy connected");
#line 204 "../lib/DBus/Client.vala"
		result = FALSE;
#line 204 "../lib/DBus/Client.vala"
		return result;
#line 650 "Client.c"
	}
	{
		gboolean _tmp1_ = FALSE;
		PlankDBusItemsIface* _tmp2_;
#line 208 "../lib/DBus/Client.vala"
		_tmp2_ = self->priv->items_proxy;
#line 208 "../lib/DBus/Client.vala"
		_tmp1_ = plank_dbus_items_iface_add (_tmp2_, uri, &_inner_error0_);
#line 208 "../lib/DBus/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 661 "Client.c"
			goto __catch0_g_error;
		}
#line 208 "../lib/DBus/Client.vala"
		result = _tmp1_;
#line 208 "../lib/DBus/Client.vala"
		return result;
#line 668 "Client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 207 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 207 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 210 "../lib/DBus/Client.vala"
		_tmp3_ = e;
#line 210 "../lib/DBus/Client.vala"
		_tmp4_ = _tmp3_->message;
#line 210 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:210: %s", _tmp4_);
#line 211 "../lib/DBus/Client.vala"
		result = FALSE;
#line 211 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 211 "../lib/DBus/Client.vala"
		return result;
#line 692 "Client.c"
	}
	__finally0:
#line 207 "../lib/DBus/Client.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "../lib/DBus/Client.vala"
	g_clear_error (&_inner_error0_);
#line 207 "../lib/DBus/Client.vala"
	return _tmp5_;
#line 701 "Client.c"
}

/**
 * Remove an existing item for the given uri from the dock
 *
 * @param uri an URI
 * @return whether it was successfully removed
 */
gboolean
plank_dbus_client_remove_item (PlankDBusClient* self,
                               const gchar* uri)
{
	PlankDBusItemsIface* _tmp0_;
	gboolean _tmp5_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 221 "../lib/DBus/Client.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 221 "../lib/DBus/Client.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 223 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->items_proxy;
#line 223 "../lib/DBus/Client.vala"
	if (_tmp0_ == NULL) {
#line 224 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:224: No proxy connected");
#line 225 "../lib/DBus/Client.vala"
		result = FALSE;
#line 225 "../lib/DBus/Client.vala"
		return result;
#line 732 "Client.c"
	}
	{
		gboolean _tmp1_ = FALSE;
		PlankDBusItemsIface* _tmp2_;
#line 229 "../lib/DBus/Client.vala"
		_tmp2_ = self->priv->items_proxy;
#line 229 "../lib/DBus/Client.vala"
		_tmp1_ = plank_dbus_items_iface_remove (_tmp2_, uri, &_inner_error0_);
#line 229 "../lib/DBus/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 743 "Client.c"
			goto __catch0_g_error;
		}
#line 229 "../lib/DBus/Client.vala"
		result = _tmp1_;
#line 229 "../lib/DBus/Client.vala"
		return result;
#line 750 "Client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 228 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 228 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 231 "../lib/DBus/Client.vala"
		_tmp3_ = e;
#line 231 "../lib/DBus/Client.vala"
		_tmp4_ = _tmp3_->message;
#line 231 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:231: %s", _tmp4_);
#line 232 "../lib/DBus/Client.vala"
		result = FALSE;
#line 232 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 232 "../lib/DBus/Client.vala"
		return result;
#line 774 "Client.c"
	}
	__finally0:
#line 228 "../lib/DBus/Client.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 228 "../lib/DBus/Client.vala"
	g_clear_error (&_inner_error0_);
#line 228 "../lib/DBus/Client.vala"
	return _tmp5_;
#line 783 "Client.c"
}

/**
 * Returns the number of currently visible items on the dock
 *
 * @return the item-count
 */
gint
plank_dbus_client_get_items_count (PlankDBusClient* self)
{
	PlankDBusItemsIface* _tmp0_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 241 "../lib/DBus/Client.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 243 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->items_proxy;
#line 243 "../lib/DBus/Client.vala"
	if (_tmp0_ == NULL) {
#line 244 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:244: No proxy connected");
#line 245 "../lib/DBus/Client.vala"
		result = -1;
#line 245 "../lib/DBus/Client.vala"
		return result;
#line 809 "Client.c"
	}
	{
#line 249 "../lib/DBus/Client.vala"
		if (self->priv->items_count == G_MININT) {
#line 814 "Client.c"
			gint _tmp1_ = 0;
			PlankDBusItemsIface* _tmp2_;
#line 250 "../lib/DBus/Client.vala"
			_tmp2_ = self->priv->items_proxy;
#line 250 "../lib/DBus/Client.vala"
			_tmp1_ = plank_dbus_items_iface_get_count (_tmp2_, &_inner_error0_);
#line 250 "../lib/DBus/Client.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 823 "Client.c"
				goto __catch0_g_error;
			}
#line 250 "../lib/DBus/Client.vala"
			self->priv->items_count = _tmp1_;
#line 828 "Client.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 248 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 248 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 252 "../lib/DBus/Client.vala"
		_tmp3_ = e;
#line 252 "../lib/DBus/Client.vala"
		_tmp4_ = _tmp3_->message;
#line 252 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:252: %s", _tmp4_);
#line 253 "../lib/DBus/Client.vala"
		result = -1;
#line 253 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 253 "../lib/DBus/Client.vala"
		return result;
#line 853 "Client.c"
	}
	__finally0:
#line 248 "../lib/DBus/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 858 "Client.c"
		gint _tmp5_ = -1;
#line 248 "../lib/DBus/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 248 "../lib/DBus/Client.vala"
		return _tmp5_;
#line 866 "Client.c"
	}
#line 256 "../lib/DBus/Client.vala"
	result = self->priv->items_count;
#line 256 "../lib/DBus/Client.vala"
	return result;
#line 872 "Client.c"
}

/**
 * Returns an array of uris of the persistent applications on the dock
 *
 * @return the array of uris
 */
gchar**
plank_dbus_client_get_persistent_applications (PlankDBusClient* self,
                                               gint* result_length1)
{
	PlankDBusItemsIface* _tmp0_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp15_;
	gint _tmp15__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 264 "../lib/DBus/Client.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 266 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->items_proxy;
#line 266 "../lib/DBus/Client.vala"
	if (_tmp0_ == NULL) {
#line 897 "Client.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 267 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:267: No proxy connected");
#line 268 "../lib/DBus/Client.vala"
		_tmp1_ = NULL;
#line 268 "../lib/DBus/Client.vala"
		_tmp1__length1 = 0;
#line 268 "../lib/DBus/Client.vala"
		if (result_length1) {
#line 268 "../lib/DBus/Client.vala"
			*result_length1 = _tmp1__length1;
#line 910 "Client.c"
		}
#line 268 "../lib/DBus/Client.vala"
		result = _tmp1_;
#line 268 "../lib/DBus/Client.vala"
		return result;
#line 916 "Client.c"
	}
#line 271 "../lib/DBus/Client.vala"
	_tmp2_ = self->priv->persistent_apps_list;
#line 271 "../lib/DBus/Client.vala"
	_tmp2__length1 = self->priv->persistent_apps_list_length1;
#line 271 "../lib/DBus/Client.vala"
	if (_tmp2_ != NULL) {
#line 924 "Client.c"
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 272 "../lib/DBus/Client.vala"
		_tmp3_ = self->priv->persistent_apps_list;
#line 272 "../lib/DBus/Client.vala"
		_tmp3__length1 = self->priv->persistent_apps_list_length1;
#line 272 "../lib/DBus/Client.vala"
		_tmp4_ = _tmp3_;
#line 272 "../lib/DBus/Client.vala"
		_tmp4__length1 = _tmp3__length1;
#line 272 "../lib/DBus/Client.vala"
		if (result_length1) {
#line 272 "../lib/DBus/Client.vala"
			*result_length1 = _tmp4__length1;
#line 941 "Client.c"
		}
#line 272 "../lib/DBus/Client.vala"
		result = _tmp4_;
#line 272 "../lib/DBus/Client.vala"
		return result;
#line 947 "Client.c"
	}
	{
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 275 "../lib/DBus/Client.vala"
		_tmp5_ = self->priv->persistent_apps_list;
#line 275 "../lib/DBus/Client.vala"
		_tmp5__length1 = self->priv->persistent_apps_list_length1;
#line 275 "../lib/DBus/Client.vala"
		if (_tmp5_ == NULL) {
#line 962 "Client.c"
			gchar** _tmp6_ = NULL;
			PlankDBusItemsIface* _tmp7_;
			gint _tmp8_ = 0;
			gchar** _tmp9_;
			gint _tmp6__length1;
			gint __tmp6__size_;
			gchar** _tmp10_;
			gint _tmp10__length1;
#line 276 "../lib/DBus/Client.vala"
			_tmp7_ = self->priv->items_proxy;
#line 276 "../lib/DBus/Client.vala"
			_tmp9_ = plank_dbus_items_iface_get_persistent_applications (_tmp7_, &_tmp8_, &_inner_error0_);
#line 276 "../lib/DBus/Client.vala"
			_tmp6_ = _tmp9_;
#line 276 "../lib/DBus/Client.vala"
			_tmp6__length1 = _tmp8_;
#line 276 "../lib/DBus/Client.vala"
			__tmp6__size_ = _tmp6__length1;
#line 276 "../lib/DBus/Client.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 983 "Client.c"
				goto __catch0_g_error;
			}
#line 276 "../lib/DBus/Client.vala"
			_tmp10_ = _tmp6_;
#line 276 "../lib/DBus/Client.vala"
			_tmp10__length1 = _tmp6__length1;
#line 276 "../lib/DBus/Client.vala"
			_tmp6_ = NULL;
#line 276 "../lib/DBus/Client.vala"
			_tmp6__length1 = 0;
#line 276 "../lib/DBus/Client.vala"
			self->priv->persistent_apps_list = (_vala_array_free (self->priv->persistent_apps_list, self->priv->persistent_apps_list_length1, (GDestroyNotify) g_free), NULL);
#line 276 "../lib/DBus/Client.vala"
			self->priv->persistent_apps_list = _tmp10_;
#line 276 "../lib/DBus/Client.vala"
			self->priv->persistent_apps_list_length1 = _tmp10__length1;
#line 276 "../lib/DBus/Client.vala"
			self->priv->_persistent_apps_list_size_ = self->priv->persistent_apps_list_length1;
#line 275 "../lib/DBus/Client.vala"
			_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 1004 "Client.c"
		}
#line 277 "../lib/DBus/Client.vala"
		_tmp11_ = self->priv->persistent_apps_list;
#line 277 "../lib/DBus/Client.vala"
		_tmp11__length1 = self->priv->persistent_apps_list_length1;
#line 277 "../lib/DBus/Client.vala"
		_tmp12_ = _tmp11_;
#line 277 "../lib/DBus/Client.vala"
		_tmp12__length1 = _tmp11__length1;
#line 277 "../lib/DBus/Client.vala"
		if (result_length1) {
#line 277 "../lib/DBus/Client.vala"
			*result_length1 = _tmp12__length1;
#line 1018 "Client.c"
		}
#line 277 "../lib/DBus/Client.vala"
		result = _tmp12_;
#line 277 "../lib/DBus/Client.vala"
		return result;
#line 1024 "Client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 274 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 274 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 279 "../lib/DBus/Client.vala"
		_tmp13_ = e;
#line 279 "../lib/DBus/Client.vala"
		_tmp14_ = _tmp13_->message;
#line 279 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:279: %s", _tmp14_);
#line 274 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 1044 "Client.c"
	}
	__finally0:
#line 274 "../lib/DBus/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "../lib/DBus/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 274 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 274 "../lib/DBus/Client.vala"
		return NULL;
#line 1055 "Client.c"
	}
#line 282 "../lib/DBus/Client.vala"
	_tmp15_ = NULL;
#line 282 "../lib/DBus/Client.vala"
	_tmp15__length1 = 0;
#line 282 "../lib/DBus/Client.vala"
	if (result_length1) {
#line 282 "../lib/DBus/Client.vala"
		*result_length1 = _tmp15__length1;
#line 1065 "Client.c"
	}
#line 282 "../lib/DBus/Client.vala"
	result = _tmp15_;
#line 282 "../lib/DBus/Client.vala"
	return result;
#line 1071 "Client.c"
}

/**
 * Returns an array of uris of the transient applications on the dock
 *
 * @return the array of uris
 */
gchar**
plank_dbus_client_get_transient_applications (PlankDBusClient* self,
                                              gint* result_length1)
{
	PlankDBusItemsIface* _tmp0_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp15_;
	gint _tmp15__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 290 "../lib/DBus/Client.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 292 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->items_proxy;
#line 292 "../lib/DBus/Client.vala"
	if (_tmp0_ == NULL) {
#line 1096 "Client.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 293 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:293: No proxy connected");
#line 294 "../lib/DBus/Client.vala"
		_tmp1_ = NULL;
#line 294 "../lib/DBus/Client.vala"
		_tmp1__length1 = 0;
#line 294 "../lib/DBus/Client.vala"
		if (result_length1) {
#line 294 "../lib/DBus/Client.vala"
			*result_length1 = _tmp1__length1;
#line 1109 "Client.c"
		}
#line 294 "../lib/DBus/Client.vala"
		result = _tmp1_;
#line 294 "../lib/DBus/Client.vala"
		return result;
#line 1115 "Client.c"
	}
#line 297 "../lib/DBus/Client.vala"
	_tmp2_ = self->priv->transient_apps_list;
#line 297 "../lib/DBus/Client.vala"
	_tmp2__length1 = self->priv->transient_apps_list_length1;
#line 297 "../lib/DBus/Client.vala"
	if (_tmp2_ != NULL) {
#line 1123 "Client.c"
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 298 "../lib/DBus/Client.vala"
		_tmp3_ = self->priv->transient_apps_list;
#line 298 "../lib/DBus/Client.vala"
		_tmp3__length1 = self->priv->transient_apps_list_length1;
#line 298 "../lib/DBus/Client.vala"
		_tmp4_ = _tmp3_;
#line 298 "../lib/DBus/Client.vala"
		_tmp4__length1 = _tmp3__length1;
#line 298 "../lib/DBus/Client.vala"
		if (result_length1) {
#line 298 "../lib/DBus/Client.vala"
			*result_length1 = _tmp4__length1;
#line 1140 "Client.c"
		}
#line 298 "../lib/DBus/Client.vala"
		result = _tmp4_;
#line 298 "../lib/DBus/Client.vala"
		return result;
#line 1146 "Client.c"
	}
	{
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 301 "../lib/DBus/Client.vala"
		_tmp5_ = self->priv->transient_apps_list;
#line 301 "../lib/DBus/Client.vala"
		_tmp5__length1 = self->priv->transient_apps_list_length1;
#line 301 "../lib/DBus/Client.vala"
		if (_tmp5_ == NULL) {
#line 1161 "Client.c"
			gchar** _tmp6_ = NULL;
			PlankDBusItemsIface* _tmp7_;
			gint _tmp8_ = 0;
			gchar** _tmp9_;
			gint _tmp6__length1;
			gint __tmp6__size_;
			gchar** _tmp10_;
			gint _tmp10__length1;
#line 302 "../lib/DBus/Client.vala"
			_tmp7_ = self->priv->items_proxy;
#line 302 "../lib/DBus/Client.vala"
			_tmp9_ = plank_dbus_items_iface_get_transient_applications (_tmp7_, &_tmp8_, &_inner_error0_);
#line 302 "../lib/DBus/Client.vala"
			_tmp6_ = _tmp9_;
#line 302 "../lib/DBus/Client.vala"
			_tmp6__length1 = _tmp8_;
#line 302 "../lib/DBus/Client.vala"
			__tmp6__size_ = _tmp6__length1;
#line 302 "../lib/DBus/Client.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1182 "Client.c"
				goto __catch0_g_error;
			}
#line 302 "../lib/DBus/Client.vala"
			_tmp10_ = _tmp6_;
#line 302 "../lib/DBus/Client.vala"
			_tmp10__length1 = _tmp6__length1;
#line 302 "../lib/DBus/Client.vala"
			_tmp6_ = NULL;
#line 302 "../lib/DBus/Client.vala"
			_tmp6__length1 = 0;
#line 302 "../lib/DBus/Client.vala"
			self->priv->transient_apps_list = (_vala_array_free (self->priv->transient_apps_list, self->priv->transient_apps_list_length1, (GDestroyNotify) g_free), NULL);
#line 302 "../lib/DBus/Client.vala"
			self->priv->transient_apps_list = _tmp10_;
#line 302 "../lib/DBus/Client.vala"
			self->priv->transient_apps_list_length1 = _tmp10__length1;
#line 302 "../lib/DBus/Client.vala"
			self->priv->_transient_apps_list_size_ = self->priv->transient_apps_list_length1;
#line 301 "../lib/DBus/Client.vala"
			_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 1203 "Client.c"
		}
#line 303 "../lib/DBus/Client.vala"
		_tmp11_ = self->priv->transient_apps_list;
#line 303 "../lib/DBus/Client.vala"
		_tmp11__length1 = self->priv->transient_apps_list_length1;
#line 303 "../lib/DBus/Client.vala"
		_tmp12_ = _tmp11_;
#line 303 "../lib/DBus/Client.vala"
		_tmp12__length1 = _tmp11__length1;
#line 303 "../lib/DBus/Client.vala"
		if (result_length1) {
#line 303 "../lib/DBus/Client.vala"
			*result_length1 = _tmp12__length1;
#line 1217 "Client.c"
		}
#line 303 "../lib/DBus/Client.vala"
		result = _tmp12_;
#line 303 "../lib/DBus/Client.vala"
		return result;
#line 1223 "Client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 300 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 300 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 305 "../lib/DBus/Client.vala"
		_tmp13_ = e;
#line 305 "../lib/DBus/Client.vala"
		_tmp14_ = _tmp13_->message;
#line 305 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:305: %s", _tmp14_);
#line 300 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 1243 "Client.c"
	}
	__finally0:
#line 300 "../lib/DBus/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 300 "../lib/DBus/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 300 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 300 "../lib/DBus/Client.vala"
		return NULL;
#line 1254 "Client.c"
	}
#line 308 "../lib/DBus/Client.vala"
	_tmp15_ = NULL;
#line 308 "../lib/DBus/Client.vala"
	_tmp15__length1 = 0;
#line 308 "../lib/DBus/Client.vala"
	if (result_length1) {
#line 308 "../lib/DBus/Client.vala"
		*result_length1 = _tmp15__length1;
#line 1264 "Client.c"
	}
#line 308 "../lib/DBus/Client.vala"
	result = _tmp15_;
#line 308 "../lib/DBus/Client.vala"
	return result;
#line 1270 "Client.c"
}

/**
 * Gets the x,y coords with the dock's position to display a hover window for an item.
 *
 * @param uri an URI
 * @param x the resulting x position
 * @param y the resulting y position
 * @param dock_position the position of the dock
 * @return whether it was successfully retrieved
 */
gboolean
plank_dbus_client_get_hover_position (PlankDBusClient* self,
                                      const gchar* uri,
                                      gint* x,
                                      gint* y,
                                      GtkPositionType* dock_position)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GtkPositionType _vala_dock_position = 0;
	PlankDBusItemsIface* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 320 "../lib/DBus/Client.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 320 "../lib/DBus/Client.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 322 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->items_proxy;
#line 322 "../lib/DBus/Client.vala"
	if (_tmp0_ == NULL) {
#line 323 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:323: No proxy connected");
#line 324 "../lib/DBus/Client.vala"
		_vala_y = -1;
#line 324 "../lib/DBus/Client.vala"
		_vala_x = _vala_y;
#line 325 "../lib/DBus/Client.vala"
		_vala_dock_position = 0;
#line 326 "../lib/DBus/Client.vala"
		result = FALSE;
#line 326 "../lib/DBus/Client.vala"
		if (x) {
#line 326 "../lib/DBus/Client.vala"
			*x = _vala_x;
#line 1317 "Client.c"
		}
#line 326 "../lib/DBus/Client.vala"
		if (y) {
#line 326 "../lib/DBus/Client.vala"
			*y = _vala_y;
#line 1323 "Client.c"
		}
#line 326 "../lib/DBus/Client.vala"
		if (dock_position) {
#line 326 "../lib/DBus/Client.vala"
			*dock_position = _vala_dock_position;
#line 1329 "Client.c"
		}
#line 326 "../lib/DBus/Client.vala"
		return result;
#line 1333 "Client.c"
	}
	{
		gboolean _tmp1_ = FALSE;
		PlankDBusItemsIface* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		GtkPositionType _tmp5_ = 0;
		gboolean _tmp6_;
#line 330 "../lib/DBus/Client.vala"
		_tmp2_ = self->priv->items_proxy;
#line 330 "../lib/DBus/Client.vala"
		_tmp6_ = plank_dbus_items_iface_get_hover_position (_tmp2_, uri, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 330 "../lib/DBus/Client.vala"
		_vala_x = _tmp3_;
#line 330 "../lib/DBus/Client.vala"
		_vala_y = _tmp4_;
#line 330 "../lib/DBus/Client.vala"
		_vala_dock_position = _tmp5_;
#line 330 "../lib/DBus/Client.vala"
		_tmp1_ = _tmp6_;
#line 330 "../lib/DBus/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1356 "Client.c"
			goto __catch0_g_error;
		}
#line 330 "../lib/DBus/Client.vala"
		result = _tmp1_;
#line 330 "../lib/DBus/Client.vala"
		if (x) {
#line 330 "../lib/DBus/Client.vala"
			*x = _vala_x;
#line 1365 "Client.c"
		}
#line 330 "../lib/DBus/Client.vala"
		if (y) {
#line 330 "../lib/DBus/Client.vala"
			*y = _vala_y;
#line 1371 "Client.c"
		}
#line 330 "../lib/DBus/Client.vala"
		if (dock_position) {
#line 330 "../lib/DBus/Client.vala"
			*dock_position = _vala_dock_position;
#line 1377 "Client.c"
		}
#line 330 "../lib/DBus/Client.vala"
		return result;
#line 1381 "Client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 329 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 329 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 332 "../lib/DBus/Client.vala"
		_tmp7_ = e;
#line 332 "../lib/DBus/Client.vala"
		_tmp8_ = _tmp7_->message;
#line 332 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:332: %s", _tmp8_);
#line 329 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 1401 "Client.c"
	}
	__finally0:
#line 329 "../lib/DBus/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1406 "Client.c"
		gboolean _tmp9_ = FALSE;
#line 329 "../lib/DBus/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 329 "../lib/DBus/Client.vala"
		return _tmp9_;
#line 1414 "Client.c"
	}
#line 335 "../lib/DBus/Client.vala"
	result = FALSE;
#line 335 "../lib/DBus/Client.vala"
	if (x) {
#line 335 "../lib/DBus/Client.vala"
		*x = _vala_x;
#line 1422 "Client.c"
	}
#line 335 "../lib/DBus/Client.vala"
	if (y) {
#line 335 "../lib/DBus/Client.vala"
		*y = _vala_y;
#line 1428 "Client.c"
	}
#line 335 "../lib/DBus/Client.vala"
	if (dock_position) {
#line 335 "../lib/DBus/Client.vala"
		*dock_position = _vala_dock_position;
#line 1434 "Client.c"
	}
#line 335 "../lib/DBus/Client.vala"
	return result;
#line 1438 "Client.c"
}

gboolean
plank_dbus_client_get_is_connected (PlankDBusClient* self)
{
	gboolean result;
	PlankDBusItemsIface* _tmp0_;
#line 52 "../lib/DBus/Client.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->items_proxy;
#line 53 "../lib/DBus/Client.vala"
	result = _tmp0_ != NULL;
#line 53 "../lib/DBus/Client.vala"
	return result;
#line 1454 "Client.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 83 "../lib/DBus/Client.vala"
	return self ? g_object_ref (self) : NULL;
#line 1462 "Client.c"
}

static GObject *
plank_dbus_client_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDBusClient * self;
	GApplication* application = NULL;
	GApplication* _tmp0_;
	gchar* object_path = NULL;
	GApplication* _tmp1_;
	gboolean _tmp8_ = FALSE;
	GDBusConnection* _tmp9_;
	GDBusConnection* _tmp14_;
	gchar* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 77 "../lib/DBus/Client.vala"
	parent_class = G_OBJECT_CLASS (plank_dbus_client_parent_class);
#line 77 "../lib/DBus/Client.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 77 "../lib/DBus/Client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DBUS_CLIENT, PlankDBusClient);
#line 79 "../lib/DBus/Client.vala"
	_tmp0_ = g_application_get_default ();
#line 79 "../lib/DBus/Client.vala"
	application = _tmp0_;
#line 80 "../lib/DBus/Client.vala"
	object_path = NULL;
#line 82 "../lib/DBus/Client.vala"
	_tmp1_ = application;
#line 82 "../lib/DBus/Client.vala"
	if (_tmp1_ != NULL) {
#line 1498 "Client.c"
		GApplication* _tmp2_;
		GDBusConnection* _tmp3_;
		GDBusConnection* _tmp4_;
		GApplication* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 83 "../lib/DBus/Client.vala"
		_tmp2_ = application;
#line 83 "../lib/DBus/Client.vala"
		_tmp3_ = g_application_get_dbus_connection (_tmp2_);
#line 83 "../lib/DBus/Client.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 83 "../lib/DBus/Client.vala"
		_g_object_unref0 (self->priv->connection);
#line 83 "../lib/DBus/Client.vala"
		self->priv->connection = _tmp4_;
#line 84 "../lib/DBus/Client.vala"
		_tmp5_ = application;
#line 84 "../lib/DBus/Client.vala"
		_tmp6_ = g_application_get_dbus_object_path (_tmp5_);
#line 84 "../lib/DBus/Client.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 84 "../lib/DBus/Client.vala"
		_g_free0 (object_path);
#line 84 "../lib/DBus/Client.vala"
		object_path = _tmp7_;
#line 1525 "Client.c"
	}
#line 87 "../lib/DBus/Client.vala"
	_tmp9_ = self->priv->connection;
#line 87 "../lib/DBus/Client.vala"
	if (_tmp9_ == NULL) {
#line 87 "../lib/DBus/Client.vala"
		_tmp8_ = TRUE;
#line 1533 "Client.c"
	} else {
		const gchar* _tmp10_;
#line 87 "../lib/DBus/Client.vala"
		_tmp10_ = object_path;
#line 87 "../lib/DBus/Client.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 1540 "Client.c"
	}
#line 87 "../lib/DBus/Client.vala"
	if (_tmp8_) {
#line 88 "../lib/DBus/Client.vala"
		g_critical ("Client.vala:88: Initializing client failed");
#line 89 "../lib/DBus/Client.vala"
		_g_free0 (object_path);
#line 89 "../lib/DBus/Client.vala"
		return obj;
#line 1550 "Client.c"
	}
	{
		GDBusConnection* _tmp11_;
#line 94 "../lib/DBus/Client.vala"
		_tmp11_ = self->priv->connection;
#line 94 "../lib/DBus/Client.vala"
		self->priv->dbus_dock_ping_id = g_dbus_connection_signal_subscribe (_tmp11_, NULL, PLANK_DBUS_DOCK_INTERFACE_NAME, PLANK_DBUS_PING_NAME, NULL, NULL, G_DBUS_SIGNAL_FLAGS_NONE, (GDBusSignalCallback) plank_dbus_client_handle_dock_ping, g_object_ref (self), g_object_unref);
#line 1558 "Client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 92 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 92 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 97 "../lib/DBus/Client.vala"
		_tmp12_ = e;
#line 97 "../lib/DBus/Client.vala"
		_tmp13_ = _tmp12_->message;
#line 97 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:97: Could not subscribe for dock signal (%s)", _tmp13_);
#line 92 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 1578 "Client.c"
	}
	__finally0:
#line 92 "../lib/DBus/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../lib/DBus/Client.vala"
		_g_free0 (object_path);
#line 92 "../lib/DBus/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 1589 "Client.c"
	}
#line 100 "../lib/DBus/Client.vala"
	_tmp14_ = self->priv->connection;
#line 100 "../lib/DBus/Client.vala"
	self->priv->dbus_name_owner_changed_signal_id = g_dbus_connection_signal_subscribe (_tmp14_, "org.freedesktop.DBus", "org.freedesktop.DBus", "NameOwnerChanged", "/org/freedesktop/DBus", NULL, G_DBUS_SIGNAL_FLAGS_NONE, (GDBusSignalCallback) plank_dbus_client_handle_name_owner_changed, g_object_ref (self), g_object_unref);
#line 103 "../lib/DBus/Client.vala"
	_tmp15_ = object_path;
#line 103 "../lib/DBus/Client.vala"
	object_path = NULL;
#line 103 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->client_object_path);
#line 103 "../lib/DBus/Client.vala"
	self->priv->client_object_path = _tmp15_;
#line 1603 "Client.c"
	{
		GDBusConnection* _tmp16_;
		const gchar* _tmp17_;
#line 107 "../lib/DBus/Client.vala"
		_tmp16_ = self->priv->connection;
#line 107 "../lib/DBus/Client.vala"
		_tmp17_ = self->priv->client_object_path;
#line 107 "../lib/DBus/Client.vala"
		g_dbus_connection_emit_signal (_tmp16_, NULL, _tmp17_, PLANK_DBUS_CLIENT_INTERFACE_NAME, PLANK_DBUS_PING_NAME, NULL, &_inner_error0_);
#line 107 "../lib/DBus/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1615 "Client.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 105 "../lib/DBus/Client.vala"
		e = _inner_error0_;
#line 105 "../lib/DBus/Client.vala"
		_inner_error0_ = NULL;
#line 109 "../lib/DBus/Client.vala"
		_tmp18_ = e;
#line 109 "../lib/DBus/Client.vala"
		_tmp19_ = _tmp18_->message;
#line 109 "../lib/DBus/Client.vala"
		g_warning ("Client.vala:109: Could not ping running docks (%s)", _tmp19_);
#line 105 "../lib/DBus/Client.vala"
		_g_error_free0 (e);
#line 1637 "Client.c"
	}
	__finally1:
#line 105 "../lib/DBus/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../lib/DBus/Client.vala"
		_g_free0 (object_path);
#line 105 "../lib/DBus/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../lib/DBus/Client.vala"
		g_clear_error (&_inner_error0_);
#line 1648 "Client.c"
	}
#line 77 "../lib/DBus/Client.vala"
	_g_free0 (object_path);
#line 77 "../lib/DBus/Client.vala"
	return obj;
#line 1654 "Client.c"
}

static void
plank_dbus_client_class_init (PlankDBusClientClass * klass,
                              gpointer klass_data)
{
#line 26 "../lib/DBus/Client.vala"
	plank_dbus_client_parent_class = g_type_class_peek_parent (klass);
#line 26 "../lib/DBus/Client.vala"
	g_type_class_adjust_private_offset (klass, &PlankDBusClient_private_offset);
#line 26 "../lib/DBus/Client.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dbus_client_get_property;
#line 26 "../lib/DBus/Client.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_dbus_client_constructor;
#line 26 "../lib/DBus/Client.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dbus_client_finalize;
#line 1671 "Client.c"
	/**
	 * Whether the client is in an operatable state and connected to
	 * a running dock
	 */
#line 26 "../lib/DBus/Client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DBUS_CLIENT_IS_CONNECTED_PROPERTY, plank_dbus_client_properties[PLANK_DBUS_CLIENT_IS_CONNECTED_PROPERTY] = g_param_spec_boolean ("is-connected", "is-connected", "is-connected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1678 "Client.c"
	/**
	 * If the proxy interfaces for the dock are ready to be used
	 * or were changed on runtime this signal will be emitted.
	 */
#line 26 "../lib/DBus/Client.vala"
	plank_dbus_client_signals[PLANK_DBUS_CLIENT_PROXY_CHANGED_SIGNAL] = g_signal_new ("proxy-changed", PLANK_TYPE_DBUS_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1685 "Client.c"
}

static void
plank_dbus_client_instance_init (PlankDBusClient * self,
                                 gpointer klass)
{
#line 26 "../lib/DBus/Client.vala"
	self->priv = plank_dbus_client_get_instance_private (self);
#line 57 "../lib/DBus/Client.vala"
	self->priv->connection = NULL;
#line 64 "../lib/DBus/Client.vala"
	self->priv->dbus_dock_ping_id = (guint) 0;
#line 65 "../lib/DBus/Client.vala"
	self->priv->dbus_name_owner_changed_signal_id = (guint) 0;
#line 67 "../lib/DBus/Client.vala"
	self->priv->items_proxy = NULL;
#line 68 "../lib/DBus/Client.vala"
	self->priv->items_count = G_MININT;
#line 69 "../lib/DBus/Client.vala"
	self->priv->persistent_apps_list = NULL;
#line 69 "../lib/DBus/Client.vala"
	self->priv->persistent_apps_list_length1 = 0;
#line 69 "../lib/DBus/Client.vala"
	self->priv->_persistent_apps_list_size_ = self->priv->persistent_apps_list_length1;
#line 70 "../lib/DBus/Client.vala"
	self->priv->transient_apps_list = NULL;
#line 70 "../lib/DBus/Client.vala"
	self->priv->transient_apps_list_length1 = 0;
#line 70 "../lib/DBus/Client.vala"
	self->priv->_transient_apps_list_size_ = self->priv->transient_apps_list_length1;
#line 1716 "Client.c"
}

static void
plank_dbus_client_finalize (GObject * obj)
{
	PlankDBusClient * self;
	GDBusConnection* _tmp0_;
#line 26 "../lib/DBus/Client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DBUS_CLIENT, PlankDBusClient);
#line 115 "../lib/DBus/Client.vala"
	_tmp0_ = self->priv->connection;
#line 115 "../lib/DBus/Client.vala"
	if (_tmp0_ != NULL) {
#line 116 "../lib/DBus/Client.vala"
		if (self->priv->dbus_dock_ping_id > ((guint) 0)) {
#line 1732 "Client.c"
			GDBusConnection* _tmp1_;
#line 117 "../lib/DBus/Client.vala"
			_tmp1_ = self->priv->connection;
#line 117 "../lib/DBus/Client.vala"
			g_dbus_connection_signal_unsubscribe (_tmp1_, self->priv->dbus_dock_ping_id);
#line 1738 "Client.c"
		}
#line 118 "../lib/DBus/Client.vala"
		if (self->priv->dbus_name_owner_changed_signal_id > ((guint) 0)) {
#line 1742 "Client.c"
			GDBusConnection* _tmp2_;
#line 119 "../lib/DBus/Client.vala"
			_tmp2_ = self->priv->connection;
#line 119 "../lib/DBus/Client.vala"
			g_dbus_connection_signal_unsubscribe (_tmp2_, self->priv->dbus_name_owner_changed_signal_id);
#line 1748 "Client.c"
		}
	}
#line 57 "../lib/DBus/Client.vala"
	_g_object_unref0 (self->priv->connection);
#line 58 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->client_object_path);
#line 60 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->dock_bus_owner);
#line 61 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->dock_bus_name);
#line 62 "../lib/DBus/Client.vala"
	_g_free0 (self->priv->dock_object_path);
#line 67 "../lib/DBus/Client.vala"
	_g_object_unref0 (self->priv->items_proxy);
#line 69 "../lib/DBus/Client.vala"
	self->priv->persistent_apps_list = (_vala_array_free (self->priv->persistent_apps_list, self->priv->persistent_apps_list_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../lib/DBus/Client.vala"
	self->priv->transient_apps_list = (_vala_array_free (self->priv->transient_apps_list, self->priv->transient_apps_list_length1, (GDestroyNotify) g_free), NULL);
#line 26 "../lib/DBus/Client.vala"
	G_OBJECT_CLASS (plank_dbus_client_parent_class)->finalize (obj);
#line 1769 "Client.c"
}

/**
 * Connects to a running instance of plank via DBus and
 * provides remote interface to a currently runnning dock.
 */
static GType
plank_dbus_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDBusClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dbus_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDBusClient), 0, (GInstanceInitFunc) plank_dbus_client_instance_init, NULL };
	GType plank_dbus_client_type_id;
	plank_dbus_client_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDBusClient", &g_define_type_info, 0);
	PlankDBusClient_private_offset = g_type_add_instance_private (plank_dbus_client_type_id, sizeof (PlankDBusClientPrivate));
	return plank_dbus_client_type_id;
}

GType
plank_dbus_client_get_type (void)
{
	static volatile gsize plank_dbus_client_type_id__once = 0;
	if (g_once_init_enter (&plank_dbus_client_type_id__once)) {
		GType plank_dbus_client_type_id;
		plank_dbus_client_type_id = plank_dbus_client_get_type_once ();
		g_once_init_leave (&plank_dbus_client_type_id__once, plank_dbus_client_type_id);
	}
	return plank_dbus_client_type_id__once;
}

static void
_vala_plank_dbus_client_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	PlankDBusClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DBUS_CLIENT, PlankDBusClient);
#line 26 "../lib/DBus/Client.vala"
	switch (property_id) {
#line 26 "../lib/DBus/Client.vala"
		case PLANK_DBUS_CLIENT_IS_CONNECTED_PROPERTY:
#line 26 "../lib/DBus/Client.vala"
		g_value_set_boolean (value, plank_dbus_client_get_is_connected (self));
#line 26 "../lib/DBus/Client.vala"
		break;
#line 1814 "Client.c"
		default:
#line 26 "../lib/DBus/Client.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../lib/DBus/Client.vala"
		break;
#line 1820 "Client.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

