/* DockTheme.c generated by valac 0.56.3, the Vala compiler
 * generated from DockTheme.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define PLANK_DOCK_THEME_MIN_INDICATOR_SIZE 0.0
#define PLANK_DOCK_THEME_MAX_INDICATOR_SIZE 10.0
#define PLANK_DOCK_THEME_MAX_ICON_SHADOW_SIZE 5.0

enum  {
	PLANK_DOCK_THEME_0_PROPERTY,
	PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY,
	PLANK_DOCK_THEME_TOP_PADDING_PROPERTY,
	PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY,
	PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY,
	PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY,
	PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY,
	PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY,
	PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY,
	PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY,
	PLANK_DOCK_THEME_CLICK_TIME_PROPERTY,
	PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY,
	PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY,
	PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY,
	PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY,
	PLANK_DOCK_THEME_FADE_TIME_PROPERTY,
	PLANK_DOCK_THEME_HIDE_TIME_PROPERTY,
	PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY,
	PLANK_DOCK_THEME_GLOW_TIME_PROPERTY,
	PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY,
	PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY,
	PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY,
	PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY,
	PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY,
	PLANK_DOCK_THEME_NUM_PROPERTIES
};
static GParamSpec* plank_dock_theme_properties[PLANK_DOCK_THEME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PlankDockThemePrivate {
	gdouble _HorizPadding;
	gdouble _TopPadding;
	gdouble _BottomPadding;
	gdouble _ItemPadding;
	gdouble _IndicatorSize;
	gdouble _IconShadowSize;
	gdouble _UrgentBounceHeight;
	gdouble _LaunchBounceHeight;
	gdouble _FadeOpacity;
	gint _ClickTime;
	gint _UrgentBounceTime;
	gint _LaunchBounceTime;
	gint _ActiveTime;
	gint _SlideTime;
	gint _FadeTime;
	gint _HideTime;
	gint _GlowSize;
	gint _GlowTime;
	gint _GlowPulseTime;
	gint _UrgentHueShift;
	gint _ItemMoveTime;
	gboolean _CascadeHide;
	PlankColor _BadgeColor;
};

static gint PlankDockTheme_private_offset;
static gpointer plank_dock_theme_parent_class = NULL;

static void plank_dock_theme_real_reset_properties (PlankPreferences* base);
static void plank_dock_theme_real_verify (PlankPreferences* base,
                                   const gchar* prop);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static void plank_dock_theme_finalize (GObject * obj);
static GType plank_dock_theme_get_type_once (void);
static void _vala_plank_dock_theme_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_plank_dock_theme_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
plank_dock_theme_get_instance_private (PlankDockTheme* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockTheme_private_offset);
}

PlankDockTheme*
plank_dock_theme_construct (GType object_type,
                            const gchar* name)
{
	PlankDockTheme * self = NULL;
#line 100 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 102 "../lib/Drawing/DockTheme.vala"
	self = (PlankDockTheme*) plank_theme_construct_with_name (object_type, name);
#line 100 "../lib/Drawing/DockTheme.vala"
	return self;
#line 134 "DockTheme.c"
}

PlankDockTheme*
plank_dock_theme_new (const gchar* name)
{
#line 100 "../lib/Drawing/DockTheme.vala"
	return plank_dock_theme_construct (PLANK_TYPE_DOCK_THEME, name);
#line 142 "DockTheme.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_theme_real_reset_properties (PlankPreferences* base)
{
	PlankDockTheme * self;
	PlankColor _tmp0_ = {0};
#line 108 "../lib/Drawing/DockTheme.vala"
	self = (PlankDockTheme*) base;
#line 110 "../lib/Drawing/DockTheme.vala"
	PLANK_PREFERENCES_CLASS (plank_dock_theme_parent_class)->reset_properties ((PlankPreferences*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_THEME, PlankTheme));
#line 111 "../lib/Drawing/DockTheme.vala"
	plank_theme_set_TopRoundness ((PlankTheme*) self, 4);
#line 112 "../lib/Drawing/DockTheme.vala"
	plank_theme_set_BottomRoundness ((PlankTheme*) self, 0);
#line 113 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_HorizPadding (self, 0.0);
#line 114 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_TopPadding (self, -11.0);
#line 115 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_BottomPadding (self, 2.5);
#line 116 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_ItemPadding (self, 2.5);
#line 117 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_IndicatorSize (self, 5.0);
#line 118 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_IconShadowSize (self, 1.0);
#line 119 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_UrgentBounceHeight (self, 5.0 / 3.0);
#line 120 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_LaunchBounceHeight (self, 0.625);
#line 121 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_FadeOpacity (self, 1.0);
#line 122 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_ClickTime (self, 300);
#line 123 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_UrgentBounceTime (self, 600);
#line 124 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_LaunchBounceTime (self, 600);
#line 125 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_ActiveTime (self, 300);
#line 126 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_SlideTime (self, 300);
#line 127 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_FadeTime (self, 250);
#line 128 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_HideTime (self, 250);
#line 129 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_GlowSize (self, 30);
#line 130 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_GlowTime (self, 10000);
#line 131 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_GlowPulseTime (self, 2000);
#line 132 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_UrgentHueShift (self, 150);
#line 133 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_ItemMoveTime (self, 450);
#line 134 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_CascadeHide (self, TRUE);
#line 135 "../lib/Drawing/DockTheme.vala"
	_tmp0_.red = 0.0;
#line 135 "../lib/Drawing/DockTheme.vala"
	_tmp0_.green = 0.0;
#line 135 "../lib/Drawing/DockTheme.vala"
	_tmp0_.blue = 0.0;
#line 135 "../lib/Drawing/DockTheme.vala"
	_tmp0_.alpha = 0.0;
#line 135 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_set_BadgeColor (self, &_tmp0_);
#line 215 "DockTheme.c"
}

/**
 * Creates a surface for the dock background.
 *
 * @param width the width of the background
 * @param height the height of the background
 * @param position the position of the dock
 * @param model existing surface to use as basis of new surface
 * @return a new surface with the background drawn on it
 */
PlankSurface*
plank_dock_theme_create_background (PlankDockTheme* self,
                                    gint width,
                                    gint height,
                                    GtkPositionType position,
                                    PlankSurface* model)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	gboolean _tmp2_ = FALSE;
	PlankSurface* temp = NULL;
	PlankSurface* _tmp8_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	gdouble rotate = 0.0;
	gdouble x_offset = 0.0;
	gdouble y_offset = 0.0;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	PlankSurface* _tmp15_;
	cairo_surface_t* _tmp16_;
	cairo_surface_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	PlankSurface* result;
#line 147 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 149 "../lib/Drawing/DockTheme.vala"
	plank_logger_verbose ("DockTheme.create_background (width = %i, height = %i)", width, height, NULL);
#line 151 "../lib/Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_new_with_surface (width, height, model);
#line 151 "../lib/Drawing/DockTheme.vala"
	surface = _tmp0_;
#line 152 "../lib/Drawing/DockTheme.vala"
	_tmp1_ = surface;
#line 152 "../lib/Drawing/DockTheme.vala"
	plank_surface_clear (_tmp1_);
#line 154 "../lib/Drawing/DockTheme.vala"
	if (width <= 0) {
#line 154 "../lib/Drawing/DockTheme.vala"
		_tmp2_ = TRUE;
#line 274 "DockTheme.c"
	} else {
#line 154 "../lib/Drawing/DockTheme.vala"
		_tmp2_ = height <= 0;
#line 278 "DockTheme.c"
	}
#line 154 "../lib/Drawing/DockTheme.vala"
	if (_tmp2_) {
#line 155 "../lib/Drawing/DockTheme.vala"
		result = surface;
#line 155 "../lib/Drawing/DockTheme.vala"
		return result;
#line 286 "DockTheme.c"
	}
#line 157 "../lib/Drawing/DockTheme.vala"
	if (position == GTK_POS_BOTTOM) {
#line 290 "DockTheme.c"
		PlankSurface* _tmp3_;
#line 158 "../lib/Drawing/DockTheme.vala"
		_tmp3_ = surface;
#line 158 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_background ((PlankTheme*) self, _tmp3_);
#line 159 "../lib/Drawing/DockTheme.vala"
		result = surface;
#line 159 "../lib/Drawing/DockTheme.vala"
		return result;
#line 300 "DockTheme.c"
	}
#line 163 "../lib/Drawing/DockTheme.vala"
	if (position == GTK_POS_TOP) {
#line 304 "DockTheme.c"
		PlankSurface* _tmp4_;
		PlankSurface* _tmp5_;
#line 164 "../lib/Drawing/DockTheme.vala"
		_tmp4_ = surface;
#line 164 "../lib/Drawing/DockTheme.vala"
		_tmp5_ = plank_surface_new_with_surface (width, height, _tmp4_);
#line 164 "../lib/Drawing/DockTheme.vala"
		_g_object_unref0 (temp);
#line 164 "../lib/Drawing/DockTheme.vala"
		temp = _tmp5_;
#line 315 "DockTheme.c"
	} else {
		PlankSurface* _tmp6_;
		PlankSurface* _tmp7_;
#line 166 "../lib/Drawing/DockTheme.vala"
		_tmp6_ = surface;
#line 166 "../lib/Drawing/DockTheme.vala"
		_tmp7_ = plank_surface_new_with_surface (height, width, _tmp6_);
#line 166 "../lib/Drawing/DockTheme.vala"
		_g_object_unref0 (temp);
#line 166 "../lib/Drawing/DockTheme.vala"
		temp = _tmp7_;
#line 327 "DockTheme.c"
	}
#line 168 "../lib/Drawing/DockTheme.vala"
	_tmp8_ = temp;
#line 168 "../lib/Drawing/DockTheme.vala"
	plank_theme_draw_background ((PlankTheme*) self, _tmp8_);
#line 170 "../lib/Drawing/DockTheme.vala"
	_tmp9_ = surface;
#line 170 "../lib/Drawing/DockTheme.vala"
	_tmp10_ = plank_surface_get_Context (_tmp9_);
#line 170 "../lib/Drawing/DockTheme.vala"
	_tmp11_ = _tmp10_;
#line 170 "../lib/Drawing/DockTheme.vala"
	cr = _tmp11_;
#line 172 "../lib/Drawing/DockTheme.vala"
	rotate = 0.0;
#line 173 "../lib/Drawing/DockTheme.vala"
	x_offset = 0.0;
#line 173 "../lib/Drawing/DockTheme.vala"
	y_offset = 0.0;
#line 175 "../lib/Drawing/DockTheme.vala"
	switch (position) {
#line 349 "DockTheme.c"
		default:
#line 175 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_BOTTOM:
#line 353 "DockTheme.c"
		{
#line 178 "../lib/Drawing/DockTheme.vala"
			break;
#line 357 "DockTheme.c"
		}
#line 175 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_TOP:
#line 361 "DockTheme.c"
		{
#line 180 "../lib/Drawing/DockTheme.vala"
			rotate = G_PI;
#line 181 "../lib/Drawing/DockTheme.vala"
			x_offset = (gdouble) (-width);
#line 182 "../lib/Drawing/DockTheme.vala"
			y_offset = (gdouble) (-height);
#line 183 "../lib/Drawing/DockTheme.vala"
			break;
#line 371 "DockTheme.c"
		}
#line 175 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_LEFT:
#line 375 "DockTheme.c"
		{
#line 185 "../lib/Drawing/DockTheme.vala"
			rotate = G_PI_2;
#line 186 "../lib/Drawing/DockTheme.vala"
			y_offset = (gdouble) (-width);
#line 187 "../lib/Drawing/DockTheme.vala"
			break;
#line 383 "DockTheme.c"
		}
#line 175 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_RIGHT:
#line 387 "DockTheme.c"
		{
#line 189 "../lib/Drawing/DockTheme.vala"
			rotate = -G_PI_2;
#line 190 "../lib/Drawing/DockTheme.vala"
			x_offset = (gdouble) (-height);
#line 191 "../lib/Drawing/DockTheme.vala"
			break;
#line 395 "DockTheme.c"
		}
	}
#line 194 "../lib/Drawing/DockTheme.vala"
	_tmp12_ = cr;
#line 194 "../lib/Drawing/DockTheme.vala"
	cairo_save (_tmp12_);
#line 195 "../lib/Drawing/DockTheme.vala"
	_tmp13_ = cr;
#line 195 "../lib/Drawing/DockTheme.vala"
	cairo_rotate (_tmp13_, rotate);
#line 196 "../lib/Drawing/DockTheme.vala"
	_tmp14_ = cr;
#line 196 "../lib/Drawing/DockTheme.vala"
	_tmp15_ = temp;
#line 196 "../lib/Drawing/DockTheme.vala"
	_tmp16_ = plank_surface_get_Internal (_tmp15_);
#line 196 "../lib/Drawing/DockTheme.vala"
	_tmp17_ = _tmp16_;
#line 196 "../lib/Drawing/DockTheme.vala"
	cairo_set_source_surface (_tmp14_, _tmp17_, x_offset, y_offset);
#line 197 "../lib/Drawing/DockTheme.vala"
	_tmp18_ = cr;
#line 197 "../lib/Drawing/DockTheme.vala"
	cairo_paint (_tmp18_);
#line 198 "../lib/Drawing/DockTheme.vala"
	_tmp19_ = cr;
#line 198 "../lib/Drawing/DockTheme.vala"
	cairo_restore (_tmp19_);
#line 200 "../lib/Drawing/DockTheme.vala"
	result = surface;
#line 200 "../lib/Drawing/DockTheme.vala"
	_g_object_unref0 (temp);
#line 200 "../lib/Drawing/DockTheme.vala"
	return result;
#line 430 "DockTheme.c"
}

/**
 * Creates a surface for an indicator.
 *
 * @param size the size of the indicator
 * @param color the color of the indicator
 * @param model existing surface to use as basis of new surface
 * @return a new surface with the indicator drawn on it
 */
PlankSurface*
plank_dock_theme_create_indicator (PlankDockTheme* self,
                                   gint size,
                                   PlankColor* color,
                                   PlankSurface* model)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	gint x = 0;
	gint y = 0;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_pattern_t* rg = NULL;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_pattern_t* _tmp10_;
	PlankColor _tmp11_;
	PlankColor _tmp12_;
	PlankColor _tmp13_;
	cairo_pattern_t* _tmp14_;
	PlankColor _tmp15_;
	PlankColor _tmp16_;
	PlankColor _tmp17_;
	cairo_pattern_t* _tmp18_;
	PlankColor _tmp19_;
	PlankColor _tmp20_;
	PlankColor _tmp21_;
	cairo_pattern_t* _tmp22_;
	PlankColor _tmp23_;
	PlankColor _tmp24_;
	PlankColor _tmp25_;
	cairo_pattern_t* _tmp26_;
	PlankColor _tmp27_;
	PlankColor _tmp28_;
	PlankColor _tmp29_;
	cairo_t* _tmp30_;
	cairo_pattern_t* _tmp31_;
	cairo_t* _tmp32_;
	PlankSurface* result;
#line 211 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 211 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 211 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 213 "../lib/Drawing/DockTheme.vala"
	plank_logger_verbose ("DockTheme.create_indicator (size = %i)", size, NULL);
#line 215 "../lib/Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_new_with_surface (size, size, model);
#line 215 "../lib/Drawing/DockTheme.vala"
	surface = _tmp0_;
#line 216 "../lib/Drawing/DockTheme.vala"
	_tmp1_ = surface;
#line 216 "../lib/Drawing/DockTheme.vala"
	plank_surface_clear (_tmp1_);
#line 218 "../lib/Drawing/DockTheme.vala"
	if (size <= 0) {
#line 219 "../lib/Drawing/DockTheme.vala"
		result = surface;
#line 219 "../lib/Drawing/DockTheme.vala"
		return result;
#line 508 "DockTheme.c"
	}
#line 221 "../lib/Drawing/DockTheme.vala"
	_tmp2_ = surface;
#line 221 "../lib/Drawing/DockTheme.vala"
	_tmp3_ = plank_surface_get_Context (_tmp2_);
#line 221 "../lib/Drawing/DockTheme.vala"
	_tmp4_ = _tmp3_;
#line 221 "../lib/Drawing/DockTheme.vala"
	cr = _tmp4_;
#line 223 "../lib/Drawing/DockTheme.vala"
	x = size / 2;
#line 224 "../lib/Drawing/DockTheme.vala"
	y = x;
#line 226 "../lib/Drawing/DockTheme.vala"
	_tmp5_ = cr;
#line 226 "../lib/Drawing/DockTheme.vala"
	cairo_move_to (_tmp5_, (gdouble) x, (gdouble) y);
#line 227 "../lib/Drawing/DockTheme.vala"
	_tmp6_ = cr;
#line 227 "../lib/Drawing/DockTheme.vala"
	cairo_arc (_tmp6_, (gdouble) x, (gdouble) y, (gdouble) (size / 2), (gdouble) 0, G_PI * 2);
#line 228 "../lib/Drawing/DockTheme.vala"
	_tmp7_ = cr;
#line 228 "../lib/Drawing/DockTheme.vala"
	cairo_close_path (_tmp7_);
#line 230 "../lib/Drawing/DockTheme.vala"
	_tmp8_ = cairo_pattern_create_radial ((gdouble) x, (gdouble) y, (gdouble) 0, (gdouble) x, (gdouble) y, (gdouble) (size / 2));
#line 230 "../lib/Drawing/DockTheme.vala"
	rg = _tmp8_;
#line 231 "../lib/Drawing/DockTheme.vala"
	_tmp9_ = rg;
#line 231 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp9_, (gdouble) 0, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 232 "../lib/Drawing/DockTheme.vala"
	_tmp10_ = rg;
#line 232 "../lib/Drawing/DockTheme.vala"
	_tmp11_ = *color;
#line 232 "../lib/Drawing/DockTheme.vala"
	_tmp12_ = *color;
#line 232 "../lib/Drawing/DockTheme.vala"
	_tmp13_ = *color;
#line 232 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp10_, 0.1, _tmp11_.red, _tmp12_.green, _tmp13_.blue, (gdouble) 1);
#line 233 "../lib/Drawing/DockTheme.vala"
	_tmp14_ = rg;
#line 233 "../lib/Drawing/DockTheme.vala"
	_tmp15_ = *color;
#line 233 "../lib/Drawing/DockTheme.vala"
	_tmp16_ = *color;
#line 233 "../lib/Drawing/DockTheme.vala"
	_tmp17_ = *color;
#line 233 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp14_, 0.2, _tmp15_.red, _tmp16_.green, _tmp17_.blue, 0.6);
#line 234 "../lib/Drawing/DockTheme.vala"
	_tmp18_ = rg;
#line 234 "../lib/Drawing/DockTheme.vala"
	_tmp19_ = *color;
#line 234 "../lib/Drawing/DockTheme.vala"
	_tmp20_ = *color;
#line 234 "../lib/Drawing/DockTheme.vala"
	_tmp21_ = *color;
#line 234 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp18_, 0.25, _tmp19_.red, _tmp20_.green, _tmp21_.blue, 0.25);
#line 235 "../lib/Drawing/DockTheme.vala"
	_tmp22_ = rg;
#line 235 "../lib/Drawing/DockTheme.vala"
	_tmp23_ = *color;
#line 235 "../lib/Drawing/DockTheme.vala"
	_tmp24_ = *color;
#line 235 "../lib/Drawing/DockTheme.vala"
	_tmp25_ = *color;
#line 235 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp22_, 0.5, _tmp23_.red, _tmp24_.green, _tmp25_.blue, 0.15);
#line 236 "../lib/Drawing/DockTheme.vala"
	_tmp26_ = rg;
#line 236 "../lib/Drawing/DockTheme.vala"
	_tmp27_ = *color;
#line 236 "../lib/Drawing/DockTheme.vala"
	_tmp28_ = *color;
#line 236 "../lib/Drawing/DockTheme.vala"
	_tmp29_ = *color;
#line 236 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp26_, 1.0, _tmp27_.red, _tmp28_.green, _tmp29_.blue, 0.0);
#line 238 "../lib/Drawing/DockTheme.vala"
	_tmp30_ = cr;
#line 238 "../lib/Drawing/DockTheme.vala"
	_tmp31_ = rg;
#line 238 "../lib/Drawing/DockTheme.vala"
	cairo_set_source (_tmp30_, _tmp31_);
#line 239 "../lib/Drawing/DockTheme.vala"
	_tmp32_ = cr;
#line 239 "../lib/Drawing/DockTheme.vala"
	cairo_fill (_tmp32_);
#line 241 "../lib/Drawing/DockTheme.vala"
	result = surface;
#line 241 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (rg);
#line 241 "../lib/Drawing/DockTheme.vala"
	return result;
#line 608 "DockTheme.c"
}

/**
 * Creates a surface for an urgent glow.
 *
 * @param size the size of the urgent glow
 * @param color the color of the urgent glow
 * @param model existing surface to use as basis of new surface
 * @return a new surface with the urgent glow drawn on it
 */
PlankSurface*
plank_dock_theme_create_urgent_glow (PlankDockTheme* self,
                                     gint size,
                                     PlankColor* color,
                                     PlankSurface* model)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	gdouble x = 0.0;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_pattern_t* rg = NULL;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_pattern_t* _tmp10_;
	PlankColor _tmp11_;
	PlankColor _tmp12_;
	PlankColor _tmp13_;
	cairo_pattern_t* _tmp14_;
	PlankColor _tmp15_;
	PlankColor _tmp16_;
	PlankColor _tmp17_;
	cairo_pattern_t* _tmp18_;
	PlankColor _tmp19_;
	PlankColor _tmp20_;
	PlankColor _tmp21_;
	cairo_t* _tmp22_;
	cairo_pattern_t* _tmp23_;
	cairo_t* _tmp24_;
	PlankSurface* result;
#line 252 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 252 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 252 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 254 "../lib/Drawing/DockTheme.vala"
	plank_logger_verbose ("DockTheme.create_urgent_glow (size = %i)", size, NULL);
#line 256 "../lib/Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_new_with_surface (size, size, model);
#line 256 "../lib/Drawing/DockTheme.vala"
	surface = _tmp0_;
#line 257 "../lib/Drawing/DockTheme.vala"
	_tmp1_ = surface;
#line 257 "../lib/Drawing/DockTheme.vala"
	plank_surface_clear (_tmp1_);
#line 259 "../lib/Drawing/DockTheme.vala"
	if (size <= 0) {
#line 260 "../lib/Drawing/DockTheme.vala"
		result = surface;
#line 260 "../lib/Drawing/DockTheme.vala"
		return result;
#line 677 "DockTheme.c"
	}
#line 262 "../lib/Drawing/DockTheme.vala"
	_tmp2_ = surface;
#line 262 "../lib/Drawing/DockTheme.vala"
	_tmp3_ = plank_surface_get_Context (_tmp2_);
#line 262 "../lib/Drawing/DockTheme.vala"
	_tmp4_ = _tmp3_;
#line 262 "../lib/Drawing/DockTheme.vala"
	cr = _tmp4_;
#line 264 "../lib/Drawing/DockTheme.vala"
	x = size / 2.0;
#line 266 "../lib/Drawing/DockTheme.vala"
	_tmp5_ = cr;
#line 266 "../lib/Drawing/DockTheme.vala"
	cairo_move_to (_tmp5_, x, x);
#line 267 "../lib/Drawing/DockTheme.vala"
	_tmp6_ = cr;
#line 267 "../lib/Drawing/DockTheme.vala"
	cairo_arc (_tmp6_, x, x, (gdouble) (size / 2), (gdouble) 0, G_PI * 2);
#line 268 "../lib/Drawing/DockTheme.vala"
	_tmp7_ = cr;
#line 268 "../lib/Drawing/DockTheme.vala"
	cairo_close_path (_tmp7_);
#line 270 "../lib/Drawing/DockTheme.vala"
	_tmp8_ = cairo_pattern_create_radial (x, x, (gdouble) 0, x, x, (gdouble) (size / 2));
#line 270 "../lib/Drawing/DockTheme.vala"
	rg = _tmp8_;
#line 271 "../lib/Drawing/DockTheme.vala"
	_tmp9_ = rg;
#line 271 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp9_, (gdouble) 0, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 272 "../lib/Drawing/DockTheme.vala"
	_tmp10_ = rg;
#line 272 "../lib/Drawing/DockTheme.vala"
	_tmp11_ = *color;
#line 272 "../lib/Drawing/DockTheme.vala"
	_tmp12_ = *color;
#line 272 "../lib/Drawing/DockTheme.vala"
	_tmp13_ = *color;
#line 272 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp10_, 0.33, _tmp11_.red, _tmp12_.green, _tmp13_.blue, 0.66);
#line 273 "../lib/Drawing/DockTheme.vala"
	_tmp14_ = rg;
#line 273 "../lib/Drawing/DockTheme.vala"
	_tmp15_ = *color;
#line 273 "../lib/Drawing/DockTheme.vala"
	_tmp16_ = *color;
#line 273 "../lib/Drawing/DockTheme.vala"
	_tmp17_ = *color;
#line 273 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp14_, 0.66, _tmp15_.red, _tmp16_.green, _tmp17_.blue, 0.33);
#line 274 "../lib/Drawing/DockTheme.vala"
	_tmp18_ = rg;
#line 274 "../lib/Drawing/DockTheme.vala"
	_tmp19_ = *color;
#line 274 "../lib/Drawing/DockTheme.vala"
	_tmp20_ = *color;
#line 274 "../lib/Drawing/DockTheme.vala"
	_tmp21_ = *color;
#line 274 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp18_, 1.0, _tmp19_.red, _tmp20_.green, _tmp21_.blue, 0.0);
#line 276 "../lib/Drawing/DockTheme.vala"
	_tmp22_ = cr;
#line 276 "../lib/Drawing/DockTheme.vala"
	_tmp23_ = rg;
#line 276 "../lib/Drawing/DockTheme.vala"
	cairo_set_source (_tmp22_, _tmp23_);
#line 277 "../lib/Drawing/DockTheme.vala"
	_tmp24_ = cr;
#line 277 "../lib/Drawing/DockTheme.vala"
	cairo_fill (_tmp24_);
#line 279 "../lib/Drawing/DockTheme.vala"
	result = surface;
#line 279 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (rg);
#line 279 "../lib/Drawing/DockTheme.vala"
	return result;
#line 755 "DockTheme.c"
}

/**
 * Draws an active glow for an item.
 *
 * @param surface the surface to draw onto
 * @param clip_rect the rect to clip the glow to
 * @param rect the rect for the glow
 * @param color the color of the glow
 * @param opacity the opacity of the glow
 * @param pos the dock's position
 */
void
plank_dock_theme_draw_active_glow (PlankDockTheme* self,
                                   PlankSurface* surface,
                                   GdkRectangle* clip_rect,
                                   GdkRectangle* rect,
                                   PlankColor* color,
                                   gdouble opacity,
                                   GtkPositionType pos)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_t* cr = NULL;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	gdouble rotate = 0.0;
	gdouble xoffset = 0.0;
	gdouble yoffset = 0.0;
	cairo_pattern_t* gradient = NULL;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	gboolean _tmp35_ = FALSE;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	cairo_t* _tmp46_;
	cairo_pattern_t* _tmp47_;
	PlankColor _tmp48_;
	PlankColor _tmp49_;
	PlankColor _tmp50_;
	cairo_pattern_t* _tmp51_;
	PlankColor _tmp52_;
	PlankColor _tmp53_;
	PlankColor _tmp54_;
	cairo_t* _tmp55_;
	GdkRectangle _tmp56_;
	GdkRectangle _tmp57_;
	GdkRectangle _tmp58_;
	GdkRectangle _tmp59_;
	cairo_t* _tmp60_;
	cairo_pattern_t* _tmp61_;
	cairo_t* _tmp62_;
	cairo_t* _tmp63_;
#line 293 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 293 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (surface != NULL);
#line 293 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (clip_rect != NULL);
#line 293 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (rect != NULL);
#line 293 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (color != NULL);
#line 295 "../lib/Drawing/DockTheme.vala"
	if (opacity <= 0.0) {
#line 295 "../lib/Drawing/DockTheme.vala"
		_tmp1_ = TRUE;
#line 826 "DockTheme.c"
	} else {
		GdkRectangle _tmp2_;
#line 295 "../lib/Drawing/DockTheme.vala"
		_tmp2_ = *rect;
#line 295 "../lib/Drawing/DockTheme.vala"
		_tmp1_ = _tmp2_.width <= 0;
#line 833 "DockTheme.c"
	}
#line 295 "../lib/Drawing/DockTheme.vala"
	if (_tmp1_) {
#line 295 "../lib/Drawing/DockTheme.vala"
		_tmp0_ = TRUE;
#line 839 "DockTheme.c"
	} else {
		GdkRectangle _tmp3_;
#line 295 "../lib/Drawing/DockTheme.vala"
		_tmp3_ = *rect;
#line 295 "../lib/Drawing/DockTheme.vala"
		_tmp0_ = _tmp3_.height <= 0;
#line 846 "DockTheme.c"
	}
#line 295 "../lib/Drawing/DockTheme.vala"
	if (_tmp0_) {
#line 296 "../lib/Drawing/DockTheme.vala"
		return;
#line 852 "DockTheme.c"
	}
#line 298 "../lib/Drawing/DockTheme.vala"
	_tmp4_ = plank_surface_get_Context (surface);
#line 298 "../lib/Drawing/DockTheme.vala"
	_tmp5_ = _tmp4_;
#line 298 "../lib/Drawing/DockTheme.vala"
	cr = _tmp5_;
#line 300 "../lib/Drawing/DockTheme.vala"
	rotate = 0.0;
#line 301 "../lib/Drawing/DockTheme.vala"
	xoffset = 0.0;
#line 301 "../lib/Drawing/DockTheme.vala"
	yoffset = 0.0;
#line 303 "../lib/Drawing/DockTheme.vala"
	gradient = NULL;
#line 305 "../lib/Drawing/DockTheme.vala"
	switch (pos) {
#line 870 "DockTheme.c"
		default:
#line 305 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_BOTTOM:
#line 874 "DockTheme.c"
		{
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			cairo_pattern_t* _tmp11_;
#line 308 "../lib/Drawing/DockTheme.vala"
			_tmp6_ = *clip_rect;
#line 308 "../lib/Drawing/DockTheme.vala"
			xoffset = (gdouble) _tmp6_.x;
#line 309 "../lib/Drawing/DockTheme.vala"
			_tmp7_ = *clip_rect;
#line 309 "../lib/Drawing/DockTheme.vala"
			yoffset = (gdouble) _tmp7_.y;
#line 311 "../lib/Drawing/DockTheme.vala"
			_tmp8_ = *rect;
#line 311 "../lib/Drawing/DockTheme.vala"
			_tmp9_ = *rect;
#line 311 "../lib/Drawing/DockTheme.vala"
			_tmp10_ = *rect;
#line 311 "../lib/Drawing/DockTheme.vala"
			_tmp11_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) _tmp8_.y, (gdouble) 0, (gdouble) (_tmp9_.y + _tmp10_.height));
#line 311 "../lib/Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 311 "../lib/Drawing/DockTheme.vala"
			gradient = _tmp11_;
#line 312 "../lib/Drawing/DockTheme.vala"
			break;
#line 904 "DockTheme.c"
		}
#line 305 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_TOP:
#line 908 "DockTheme.c"
		{
			GdkRectangle _tmp12_;
			GdkRectangle _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
			GdkRectangle _tmp16_;
			GdkRectangle _tmp17_;
			cairo_pattern_t* _tmp18_;
#line 314 "../lib/Drawing/DockTheme.vala"
			rotate = G_PI;
#line 315 "../lib/Drawing/DockTheme.vala"
			_tmp12_ = *clip_rect;
#line 315 "../lib/Drawing/DockTheme.vala"
			_tmp13_ = *clip_rect;
#line 315 "../lib/Drawing/DockTheme.vala"
			xoffset = (gdouble) ((-_tmp12_.x) - _tmp13_.width);
#line 316 "../lib/Drawing/DockTheme.vala"
			_tmp14_ = *clip_rect;
#line 316 "../lib/Drawing/DockTheme.vala"
			yoffset = (gdouble) (-_tmp14_.height);
#line 318 "../lib/Drawing/DockTheme.vala"
			_tmp15_ = *rect;
#line 318 "../lib/Drawing/DockTheme.vala"
			_tmp16_ = *rect;
#line 318 "../lib/Drawing/DockTheme.vala"
			_tmp17_ = *rect;
#line 318 "../lib/Drawing/DockTheme.vala"
			_tmp18_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) (_tmp15_.y + _tmp16_.height), (gdouble) 0, (gdouble) _tmp17_.y);
#line 318 "../lib/Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 318 "../lib/Drawing/DockTheme.vala"
			gradient = _tmp18_;
#line 319 "../lib/Drawing/DockTheme.vala"
			break;
#line 943 "DockTheme.c"
		}
#line 305 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_LEFT:
#line 947 "DockTheme.c"
		{
			GdkRectangle _tmp19_;
			GdkRectangle _tmp20_;
			GdkRectangle _tmp21_;
			GdkRectangle _tmp22_;
			GdkRectangle _tmp23_;
			cairo_pattern_t* _tmp24_;
#line 321 "../lib/Drawing/DockTheme.vala"
			rotate = G_PI_2;
#line 322 "../lib/Drawing/DockTheme.vala"
			_tmp19_ = *clip_rect;
#line 322 "../lib/Drawing/DockTheme.vala"
			xoffset = (gdouble) _tmp19_.y;
#line 323 "../lib/Drawing/DockTheme.vala"
			_tmp20_ = *clip_rect;
#line 323 "../lib/Drawing/DockTheme.vala"
			yoffset = (gdouble) (-_tmp20_.width);
#line 325 "../lib/Drawing/DockTheme.vala"
			_tmp21_ = *rect;
#line 325 "../lib/Drawing/DockTheme.vala"
			_tmp22_ = *rect;
#line 325 "../lib/Drawing/DockTheme.vala"
			_tmp23_ = *rect;
#line 325 "../lib/Drawing/DockTheme.vala"
			_tmp24_ = cairo_pattern_create_linear ((gdouble) (_tmp21_.x + _tmp22_.width), (gdouble) 0, (gdouble) _tmp23_.x, (gdouble) 0);
#line 325 "../lib/Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 325 "../lib/Drawing/DockTheme.vala"
			gradient = _tmp24_;
#line 326 "../lib/Drawing/DockTheme.vala"
			break;
#line 979 "DockTheme.c"
		}
#line 305 "../lib/Drawing/DockTheme.vala"
		case GTK_POS_RIGHT:
#line 983 "DockTheme.c"
		{
			GdkRectangle _tmp25_;
			GdkRectangle _tmp26_;
			GdkRectangle _tmp27_;
			GdkRectangle _tmp28_;
			GdkRectangle _tmp29_;
			GdkRectangle _tmp30_;
			cairo_pattern_t* _tmp31_;
#line 328 "../lib/Drawing/DockTheme.vala"
			rotate = -G_PI_2;
#line 329 "../lib/Drawing/DockTheme.vala"
			_tmp25_ = *clip_rect;
#line 329 "../lib/Drawing/DockTheme.vala"
			_tmp26_ = *clip_rect;
#line 329 "../lib/Drawing/DockTheme.vala"
			xoffset = (gdouble) ((-_tmp25_.y) - _tmp26_.height);
#line 330 "../lib/Drawing/DockTheme.vala"
			_tmp27_ = *clip_rect;
#line 330 "../lib/Drawing/DockTheme.vala"
			yoffset = (gdouble) _tmp27_.x;
#line 332 "../lib/Drawing/DockTheme.vala"
			_tmp28_ = *rect;
#line 332 "../lib/Drawing/DockTheme.vala"
			_tmp29_ = *rect;
#line 332 "../lib/Drawing/DockTheme.vala"
			_tmp30_ = *rect;
#line 332 "../lib/Drawing/DockTheme.vala"
			_tmp31_ = cairo_pattern_create_linear ((gdouble) _tmp28_.x, (gdouble) 0, (gdouble) (_tmp29_.x + _tmp30_.width), (gdouble) 0);
#line 332 "../lib/Drawing/DockTheme.vala"
			_cairo_pattern_destroy0 (gradient);
#line 332 "../lib/Drawing/DockTheme.vala"
			gradient = _tmp31_;
#line 333 "../lib/Drawing/DockTheme.vala"
			break;
#line 1018 "DockTheme.c"
		}
	}
#line 336 "../lib/Drawing/DockTheme.vala"
	_tmp32_ = cr;
#line 336 "../lib/Drawing/DockTheme.vala"
	cairo_save (_tmp32_);
#line 337 "../lib/Drawing/DockTheme.vala"
	_tmp33_ = cr;
#line 337 "../lib/Drawing/DockTheme.vala"
	cairo_rotate (_tmp33_, rotate);
#line 338 "../lib/Drawing/DockTheme.vala"
	_tmp34_ = cr;
#line 338 "../lib/Drawing/DockTheme.vala"
	cairo_translate (_tmp34_, xoffset, yoffset);
#line 339 "../lib/Drawing/DockTheme.vala"
	if (pos == GTK_POS_BOTTOM) {
#line 339 "../lib/Drawing/DockTheme.vala"
		_tmp35_ = TRUE;
#line 1037 "DockTheme.c"
	} else {
#line 339 "../lib/Drawing/DockTheme.vala"
		_tmp35_ = pos == GTK_POS_TOP;
#line 1041 "DockTheme.c"
	}
#line 339 "../lib/Drawing/DockTheme.vala"
	if (_tmp35_) {
#line 1045 "DockTheme.c"
		cairo_t* _tmp36_;
		GdkRectangle _tmp37_;
		GdkRectangle _tmp38_;
#line 340 "../lib/Drawing/DockTheme.vala"
		_tmp36_ = cr;
#line 340 "../lib/Drawing/DockTheme.vala"
		_tmp37_ = *clip_rect;
#line 340 "../lib/Drawing/DockTheme.vala"
		_tmp38_ = *clip_rect;
#line 340 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_inner_rect ((PlankTheme*) self, _tmp36_, _tmp37_.width, _tmp38_.height);
#line 1057 "DockTheme.c"
	} else {
		cairo_t* _tmp39_;
		GdkRectangle _tmp40_;
		GdkRectangle _tmp41_;
#line 342 "../lib/Drawing/DockTheme.vala"
		_tmp39_ = cr;
#line 342 "../lib/Drawing/DockTheme.vala"
		_tmp40_ = *clip_rect;
#line 342 "../lib/Drawing/DockTheme.vala"
		_tmp41_ = *clip_rect;
#line 342 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_inner_rect ((PlankTheme*) self, _tmp39_, _tmp40_.height, _tmp41_.width);
#line 1070 "DockTheme.c"
	}
#line 343 "../lib/Drawing/DockTheme.vala"
	_tmp42_ = cr;
#line 343 "../lib/Drawing/DockTheme.vala"
	cairo_restore (_tmp42_);
#line 345 "../lib/Drawing/DockTheme.vala"
	_tmp43_ = cr;
#line 345 "../lib/Drawing/DockTheme.vala"
	_tmp44_ = plank_theme_get_LineWidth ((PlankTheme*) self);
#line 345 "../lib/Drawing/DockTheme.vala"
	_tmp45_ = _tmp44_;
#line 345 "../lib/Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp43_, (gdouble) _tmp45_);
#line 346 "../lib/Drawing/DockTheme.vala"
	_tmp46_ = cr;
#line 346 "../lib/Drawing/DockTheme.vala"
	cairo_clip (_tmp46_);
#line 348 "../lib/Drawing/DockTheme.vala"
	_tmp47_ = gradient;
#line 348 "../lib/Drawing/DockTheme.vala"
	_tmp48_ = *color;
#line 348 "../lib/Drawing/DockTheme.vala"
	_tmp49_ = *color;
#line 348 "../lib/Drawing/DockTheme.vala"
	_tmp50_ = *color;
#line 348 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp47_, (gdouble) 0, _tmp48_.red, _tmp49_.green, _tmp50_.blue, (gdouble) 0);
#line 349 "../lib/Drawing/DockTheme.vala"
	_tmp51_ = gradient;
#line 349 "../lib/Drawing/DockTheme.vala"
	_tmp52_ = *color;
#line 349 "../lib/Drawing/DockTheme.vala"
	_tmp53_ = *color;
#line 349 "../lib/Drawing/DockTheme.vala"
	_tmp54_ = *color;
#line 349 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp51_, (gdouble) 1, _tmp52_.red, _tmp53_.green, _tmp54_.blue, 0.6 * opacity);
#line 351 "../lib/Drawing/DockTheme.vala"
	_tmp55_ = cr;
#line 351 "../lib/Drawing/DockTheme.vala"
	_tmp56_ = *rect;
#line 351 "../lib/Drawing/DockTheme.vala"
	_tmp57_ = *rect;
#line 351 "../lib/Drawing/DockTheme.vala"
	_tmp58_ = *rect;
#line 351 "../lib/Drawing/DockTheme.vala"
	_tmp59_ = *rect;
#line 351 "../lib/Drawing/DockTheme.vala"
	cairo_rectangle (_tmp55_, (gdouble) _tmp56_.x, (gdouble) _tmp57_.y, (gdouble) _tmp58_.width, (gdouble) _tmp59_.height);
#line 352 "../lib/Drawing/DockTheme.vala"
	_tmp60_ = cr;
#line 352 "../lib/Drawing/DockTheme.vala"
	_tmp61_ = gradient;
#line 352 "../lib/Drawing/DockTheme.vala"
	cairo_set_source (_tmp60_, _tmp61_);
#line 353 "../lib/Drawing/DockTheme.vala"
	_tmp62_ = cr;
#line 353 "../lib/Drawing/DockTheme.vala"
	cairo_fill (_tmp62_);
#line 355 "../lib/Drawing/DockTheme.vala"
	_tmp63_ = cr;
#line 355 "../lib/Drawing/DockTheme.vala"
	cairo_reset_clip (_tmp63_);
#line 293 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (gradient);
#line 1136 "DockTheme.c"
}

/**
 * Draws a badge for an item.
 *
 * @param surface the surface to draw the badge onto
 * @param icon_size the icon-size of the dock
 * @param color the color of the badge
 * @param count the number for the badge to show
 */
void
plank_dock_theme_draw_item_count (PlankDockTheme* self,
                                  PlankSurface* surface,
                                  gint icon_size,
                                  PlankColor* color,
                                  gint64 count)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble x = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble y = 0.0;
	gint _tmp4_;
	gint _tmp5_;
	PlankColor badge_color_start = {0};
	PlankColor _tmp6_;
	PlankColor badge_color_middle = {0};
	PlankColor _tmp7_;
	PlankColor badge_color_end = {0};
	PlankColor _tmp8_;
	PlankColor stroke_color_start = {0};
	PlankColor _tmp9_;
	PlankColor stroke_color_end = {0};
	PlankColor _tmp10_;
	gboolean is_small = FALSE;
	gboolean is_large = FALSE;
	gdouble _tmp11_ = 0.0;
	gdouble padding = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble line_width = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble height = 0.0;
	gdouble width = 0.0;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gdouble _tmp20_;
	gdouble max_width = 0.0;
	cairo_t* _tmp21_;
	cairo_pattern_t* stroke = NULL;
	cairo_pattern_t* fill = NULL;
	PangoLayout* layout = NULL;
	PangoContext* _tmp53_;
	PangoContext* _tmp54_;
	PangoLayout* _tmp55_;
	PangoLayout* _tmp56_;
	PangoLayout* _tmp57_;
	PangoLayout* _tmp58_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp59_;
	PangoFontDescription* font_description = NULL;
	GtkStyleContext* _tmp60_;
	GtkStyleContext* _tmp61_;
	PangoFontDescription* _tmp62_;
	PangoFontDescription* _tmp63_;
	PangoFontDescription* _tmp64_;
	PangoLayout* _tmp65_;
	PangoFontDescription* _tmp66_;
	PangoLayout* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	PangoRectangle logical_rect = {0};
	PangoLayout* _tmp70_;
	PangoRectangle _tmp71_ = {0};
	gdouble scale = 0.0;
	PangoRectangle _tmp72_;
	PangoRectangle _tmp73_;
	cairo_t* _tmp76_;
	PangoRectangle _tmp77_;
	PangoRectangle _tmp78_;
	cairo_t* _tmp79_;
	cairo_t* _tmp81_;
	cairo_t* _tmp82_;
	PangoLayout* _tmp83_;
	cairo_t* _tmp84_;
	cairo_t* _tmp85_;
	cairo_t* _tmp86_;
	cairo_t* _tmp87_;
#line 366 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 366 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (surface != NULL);
#line 366 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (color != NULL);
#line 368 "../lib/Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_get_Context (surface);
#line 368 "../lib/Drawing/DockTheme.vala"
	_tmp1_ = _tmp0_;
#line 368 "../lib/Drawing/DockTheme.vala"
	cr = _tmp1_;
#line 372 "../lib/Drawing/DockTheme.vala"
	_tmp2_ = plank_surface_get_Width (surface);
#line 372 "../lib/Drawing/DockTheme.vala"
	_tmp3_ = _tmp2_;
#line 372 "../lib/Drawing/DockTheme.vala"
	x = floor ((gdouble) ((_tmp3_ - icon_size) / 2));
#line 373 "../lib/Drawing/DockTheme.vala"
	_tmp4_ = plank_surface_get_Height (surface);
#line 373 "../lib/Drawing/DockTheme.vala"
	_tmp5_ = _tmp4_;
#line 373 "../lib/Drawing/DockTheme.vala"
	y = floor ((gdouble) ((_tmp5_ - icon_size) / 2));
#line 375 "../lib/Drawing/DockTheme.vala"
	_tmp6_ = *color;
#line 375 "../lib/Drawing/DockTheme.vala"
	badge_color_start = _tmp6_;
#line 376 "../lib/Drawing/DockTheme.vala"
	plank_color_brighten_val (&badge_color_start, 1.0);
#line 377 "../lib/Drawing/DockTheme.vala"
	_tmp7_ = *color;
#line 377 "../lib/Drawing/DockTheme.vala"
	badge_color_middle = _tmp7_;
#line 378 "../lib/Drawing/DockTheme.vala"
	plank_color_set_sat (&badge_color_middle, 0.87);
#line 379 "../lib/Drawing/DockTheme.vala"
	_tmp8_ = *color;
#line 379 "../lib/Drawing/DockTheme.vala"
	badge_color_end = _tmp8_;
#line 380 "../lib/Drawing/DockTheme.vala"
	plank_color_set_sat (&badge_color_end, 0.87);
#line 381 "../lib/Drawing/DockTheme.vala"
	plank_color_darken_val (&badge_color_end, 0.7);
#line 382 "../lib/Drawing/DockTheme.vala"
	_tmp9_ = *color;
#line 382 "../lib/Drawing/DockTheme.vala"
	stroke_color_start = _tmp9_;
#line 383 "../lib/Drawing/DockTheme.vala"
	plank_color_set_sat (&stroke_color_start, 0.9);
#line 384 "../lib/Drawing/DockTheme.vala"
	_tmp10_ = *color;
#line 384 "../lib/Drawing/DockTheme.vala"
	stroke_color_end = _tmp10_;
#line 385 "../lib/Drawing/DockTheme.vala"
	plank_color_set_sat (&stroke_color_end, 0.9);
#line 386 "../lib/Drawing/DockTheme.vala"
	plank_color_darken_val (&stroke_color_end, 0.9);
#line 389 "../lib/Drawing/DockTheme.vala"
	is_small = icon_size < 32;
#line 390 "../lib/Drawing/DockTheme.vala"
	is_large = icon_size > 54;
#line 391 "../lib/Drawing/DockTheme.vala"
	if (is_small) {
#line 391 "../lib/Drawing/DockTheme.vala"
		_tmp11_ = 1.0;
#line 1294 "DockTheme.c"
	} else {
		gdouble _tmp12_ = 0.0;
#line 391 "../lib/Drawing/DockTheme.vala"
		if (is_large) {
#line 391 "../lib/Drawing/DockTheme.vala"
			_tmp12_ = 4.5;
#line 1301 "DockTheme.c"
		} else {
#line 391 "../lib/Drawing/DockTheme.vala"
			_tmp12_ = 2.0;
#line 1305 "DockTheme.c"
		}
#line 391 "../lib/Drawing/DockTheme.vala"
		_tmp11_ = _tmp12_;
#line 1309 "DockTheme.c"
	}
#line 391 "../lib/Drawing/DockTheme.vala"
	padding = _tmp11_;
#line 392 "../lib/Drawing/DockTheme.vala"
	if (is_small) {
#line 392 "../lib/Drawing/DockTheme.vala"
		_tmp13_ = 0.0;
#line 1317 "DockTheme.c"
	} else {
		gdouble _tmp14_ = 0.0;
#line 392 "../lib/Drawing/DockTheme.vala"
		if (is_large) {
#line 392 "../lib/Drawing/DockTheme.vala"
			_tmp14_ = 2.0;
#line 1324 "DockTheme.c"
		} else {
#line 392 "../lib/Drawing/DockTheme.vala"
			_tmp14_ = 1.0;
#line 1328 "DockTheme.c"
		}
#line 392 "../lib/Drawing/DockTheme.vala"
		_tmp13_ = _tmp14_;
#line 1332 "DockTheme.c"
	}
#line 392 "../lib/Drawing/DockTheme.vala"
	line_width = _tmp13_;
#line 394 "../lib/Drawing/DockTheme.vala"
	if (is_small) {
#line 394 "../lib/Drawing/DockTheme.vala"
		_tmp15_ = 0.80;
#line 1340 "DockTheme.c"
	} else {
#line 394 "../lib/Drawing/DockTheme.vala"
		_tmp15_ = 0.50;
#line 1344 "DockTheme.c"
	}
#line 394 "../lib/Drawing/DockTheme.vala"
	height = floor ((_tmp15_ * icon_size) - (2.0 * line_width));
#line 395 "../lib/Drawing/DockTheme.vala"
	_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, count);
#line 395 "../lib/Drawing/DockTheme.vala"
	_tmp17_ = _tmp16_;
#line 395 "../lib/Drawing/DockTheme.vala"
	_tmp18_ = strlen (_tmp17_);
#line 395 "../lib/Drawing/DockTheme.vala"
	_tmp19_ = _tmp18_;
#line 395 "../lib/Drawing/DockTheme.vala"
	_tmp20_ = floor ((0.75 + (0.25 * _tmp19_)) * height);
#line 395 "../lib/Drawing/DockTheme.vala"
	_g_free0 (_tmp17_);
#line 395 "../lib/Drawing/DockTheme.vala"
	width = _tmp20_;
#line 396 "../lib/Drawing/DockTheme.vala"
	max_width = icon_size - (2.0 * line_width);
#line 397 "../lib/Drawing/DockTheme.vala"
	if (width > max_width) {
#line 398 "../lib/Drawing/DockTheme.vala"
		width = max_width;
#line 1368 "DockTheme.c"
	}
#line 401 "../lib/Drawing/DockTheme.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 402 "../lib/Drawing/DockTheme.vala"
		x += line_width + (line_width / 2.0);
#line 1374 "DockTheme.c"
	} else {
#line 404 "../lib/Drawing/DockTheme.vala"
		x += (icon_size - width) - (1.5 * line_width);
#line 1378 "DockTheme.c"
	}
#line 405 "../lib/Drawing/DockTheme.vala"
	y += line_width + (line_width / 2.0);
#line 407 "../lib/Drawing/DockTheme.vala"
	_tmp21_ = cr;
#line 407 "../lib/Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp21_, line_width);
#line 411 "../lib/Drawing/DockTheme.vala"
	if (!is_small) {
#line 1388 "DockTheme.c"
		cairo_pattern_t* _tmp22_;
		cairo_t* _tmp23_;
		cairo_pattern_t* _tmp24_;
		cairo_pattern_t* _tmp25_;
		cairo_pattern_t* _tmp26_;
		PlankColor _tmp27_;
		PlankColor _tmp28_;
		PlankColor _tmp29_;
		cairo_pattern_t* _tmp30_;
		PlankColor _tmp31_;
		PlankColor _tmp32_;
		PlankColor _tmp33_;
		cairo_pattern_t* _tmp34_;
		cairo_pattern_t* _tmp35_;
		PlankColor _tmp36_;
		PlankColor _tmp37_;
		PlankColor _tmp38_;
		cairo_pattern_t* _tmp39_;
		PlankColor _tmp40_;
		PlankColor _tmp41_;
		PlankColor _tmp42_;
		cairo_pattern_t* _tmp43_;
		PlankColor _tmp44_;
		PlankColor _tmp45_;
		PlankColor _tmp46_;
		cairo_t* _tmp47_;
		cairo_pattern_t* _tmp48_;
		cairo_pattern_t* _tmp49_;
		cairo_pattern_t* _tmp50_;
		cairo_t* _tmp51_;
		cairo_pattern_t* _tmp52_;
#line 413 "../lib/Drawing/DockTheme.vala"
		_tmp22_ = cairo_pattern_create_rgba (0.2, 0.2, 0.2, 0.3);
#line 413 "../lib/Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (stroke);
#line 413 "../lib/Drawing/DockTheme.vala"
		stroke = _tmp22_;
#line 414 "../lib/Drawing/DockTheme.vala"
		_tmp23_ = cr;
#line 414 "../lib/Drawing/DockTheme.vala"
		_tmp24_ = stroke;
#line 414 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp23_, x, y, width + line_width, height, TRUE, TRUE, _tmp24_, NULL);
#line 417 "../lib/Drawing/DockTheme.vala"
		_tmp25_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 417 "../lib/Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (stroke);
#line 417 "../lib/Drawing/DockTheme.vala"
		stroke = _tmp25_;
#line 418 "../lib/Drawing/DockTheme.vala"
		_tmp26_ = stroke;
#line 418 "../lib/Drawing/DockTheme.vala"
		_tmp27_ = stroke_color_start;
#line 418 "../lib/Drawing/DockTheme.vala"
		_tmp28_ = stroke_color_start;
#line 418 "../lib/Drawing/DockTheme.vala"
		_tmp29_ = stroke_color_start;
#line 418 "../lib/Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp26_, 0.2, _tmp27_.red, _tmp28_.green, _tmp29_.blue, 0.8);
#line 419 "../lib/Drawing/DockTheme.vala"
		_tmp30_ = stroke;
#line 419 "../lib/Drawing/DockTheme.vala"
		_tmp31_ = stroke_color_end;
#line 419 "../lib/Drawing/DockTheme.vala"
		_tmp32_ = stroke_color_end;
#line 419 "../lib/Drawing/DockTheme.vala"
		_tmp33_ = stroke_color_end;
#line 419 "../lib/Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp30_, 0.8, _tmp31_.red, _tmp32_.green, _tmp33_.blue, 0.8);
#line 420 "../lib/Drawing/DockTheme.vala"
		_tmp34_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 420 "../lib/Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (fill);
#line 420 "../lib/Drawing/DockTheme.vala"
		fill = _tmp34_;
#line 421 "../lib/Drawing/DockTheme.vala"
		_tmp35_ = fill;
#line 421 "../lib/Drawing/DockTheme.vala"
		_tmp36_ = badge_color_start;
#line 421 "../lib/Drawing/DockTheme.vala"
		_tmp37_ = badge_color_start;
#line 421 "../lib/Drawing/DockTheme.vala"
		_tmp38_ = badge_color_start;
#line 421 "../lib/Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp35_, 0.1, _tmp36_.red, _tmp37_.green, _tmp38_.blue, 1.0);
#line 422 "../lib/Drawing/DockTheme.vala"
		_tmp39_ = fill;
#line 422 "../lib/Drawing/DockTheme.vala"
		_tmp40_ = badge_color_middle;
#line 422 "../lib/Drawing/DockTheme.vala"
		_tmp41_ = badge_color_middle;
#line 422 "../lib/Drawing/DockTheme.vala"
		_tmp42_ = badge_color_middle;
#line 422 "../lib/Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp39_, 0.5, _tmp40_.red, _tmp41_.green, _tmp42_.blue, 1.0);
#line 423 "../lib/Drawing/DockTheme.vala"
		_tmp43_ = fill;
#line 423 "../lib/Drawing/DockTheme.vala"
		_tmp44_ = badge_color_end;
#line 423 "../lib/Drawing/DockTheme.vala"
		_tmp45_ = badge_color_end;
#line 423 "../lib/Drawing/DockTheme.vala"
		_tmp46_ = badge_color_end;
#line 423 "../lib/Drawing/DockTheme.vala"
		cairo_pattern_add_color_stop_rgba (_tmp43_, 0.9, _tmp44_.red, _tmp45_.green, _tmp46_.blue, 1.0);
#line 424 "../lib/Drawing/DockTheme.vala"
		_tmp47_ = cr;
#line 424 "../lib/Drawing/DockTheme.vala"
		_tmp48_ = stroke;
#line 424 "../lib/Drawing/DockTheme.vala"
		_tmp49_ = fill;
#line 424 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp47_, x, y, width, height, TRUE, TRUE, _tmp48_, _tmp49_);
#line 427 "../lib/Drawing/DockTheme.vala"
		_tmp50_ = cairo_pattern_create_rgba (0.9, 0.9, 0.9, 0.1);
#line 427 "../lib/Drawing/DockTheme.vala"
		_cairo_pattern_destroy0 (stroke);
#line 427 "../lib/Drawing/DockTheme.vala"
		stroke = _tmp50_;
#line 428 "../lib/Drawing/DockTheme.vala"
		_tmp51_ = cr;
#line 428 "../lib/Drawing/DockTheme.vala"
		_tmp52_ = stroke;
#line 428 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp51_, x + line_width, y + line_width, width - (2 * line_width), height - (2 * line_width), TRUE, TRUE, _tmp52_, NULL);
#line 1514 "DockTheme.c"
	}
#line 431 "../lib/Drawing/DockTheme.vala"
	_tmp53_ = gdk_pango_context_get ();
#line 431 "../lib/Drawing/DockTheme.vala"
	_tmp54_ = _tmp53_;
#line 431 "../lib/Drawing/DockTheme.vala"
	_tmp55_ = pango_layout_new (_tmp54_);
#line 431 "../lib/Drawing/DockTheme.vala"
	_tmp56_ = _tmp55_;
#line 431 "../lib/Drawing/DockTheme.vala"
	_g_object_unref0 (_tmp54_);
#line 431 "../lib/Drawing/DockTheme.vala"
	layout = _tmp56_;
#line 432 "../lib/Drawing/DockTheme.vala"
	_tmp57_ = layout;
#line 432 "../lib/Drawing/DockTheme.vala"
	pango_layout_set_width (_tmp57_, (gint) (width * PANGO_SCALE));
#line 433 "../lib/Drawing/DockTheme.vala"
	_tmp58_ = layout;
#line 433 "../lib/Drawing/DockTheme.vala"
	pango_layout_set_ellipsize (_tmp58_, PANGO_ELLIPSIZE_NONE);
#line 435 "../lib/Drawing/DockTheme.vala"
	_tmp59_ = plank_theme_get_style_context ((PlankTheme*) self);
#line 435 "../lib/Drawing/DockTheme.vala"
	style_context = _tmp59_;
#line 436 "../lib/Drawing/DockTheme.vala"
	_tmp60_ = style_context;
#line 436 "../lib/Drawing/DockTheme.vala"
	_tmp61_ = style_context;
#line 436 "../lib/Drawing/DockTheme.vala"
	_tmp62_ = gtk_style_context_get_font (_tmp60_, gtk_style_context_get_state (_tmp61_));
#line 436 "../lib/Drawing/DockTheme.vala"
	font_description = _tmp62_;
#line 437 "../lib/Drawing/DockTheme.vala"
	_tmp63_ = font_description;
#line 437 "../lib/Drawing/DockTheme.vala"
	pango_font_description_set_absolute_size (_tmp63_, (gdouble) ((gint) (height * PANGO_SCALE)));
#line 438 "../lib/Drawing/DockTheme.vala"
	_tmp64_ = font_description;
#line 438 "../lib/Drawing/DockTheme.vala"
	pango_font_description_set_weight (_tmp64_, PANGO_WEIGHT_BOLD);
#line 439 "../lib/Drawing/DockTheme.vala"
	_tmp65_ = layout;
#line 439 "../lib/Drawing/DockTheme.vala"
	_tmp66_ = font_description;
#line 439 "../lib/Drawing/DockTheme.vala"
	pango_layout_set_font_description (_tmp65_, _tmp66_);
#line 441 "../lib/Drawing/DockTheme.vala"
	_tmp67_ = layout;
#line 441 "../lib/Drawing/DockTheme.vala"
	_tmp68_ = g_strdup_printf ("%" G_GINT64_FORMAT, count);
#line 441 "../lib/Drawing/DockTheme.vala"
	_tmp69_ = _tmp68_;
#line 441 "../lib/Drawing/DockTheme.vala"
	pango_layout_set_text (_tmp67_, _tmp69_, -1);
#line 441 "../lib/Drawing/DockTheme.vala"
	_g_free0 (_tmp69_);
#line 443 "../lib/Drawing/DockTheme.vala"
	_tmp70_ = layout;
#line 443 "../lib/Drawing/DockTheme.vala"
	pango_layout_get_pixel_extents (_tmp70_, NULL, &_tmp71_);
#line 443 "../lib/Drawing/DockTheme.vala"
	logical_rect = _tmp71_;
#line 445 "../lib/Drawing/DockTheme.vala"
	_tmp72_ = logical_rect;
#line 445 "../lib/Drawing/DockTheme.vala"
	_tmp73_ = logical_rect;
#line 445 "../lib/Drawing/DockTheme.vala"
	scale = MIN (1.0, MIN (((width - (2.0 * padding)) - (2.0 * line_width)) / ((gdouble) _tmp72_.width), (height - (2.0 * padding)) / ((gdouble) _tmp73_.height)));
#line 447 "../lib/Drawing/DockTheme.vala"
	if (!is_small) {
#line 1586 "DockTheme.c"
		cairo_t* _tmp74_;
#line 448 "../lib/Drawing/DockTheme.vala"
		_tmp74_ = cr;
#line 448 "../lib/Drawing/DockTheme.vala"
		cairo_set_source_rgba (_tmp74_, 0.0, 0.0, 0.0, 0.2);
#line 1592 "DockTheme.c"
	} else {
		cairo_t* _tmp75_;
#line 450 "../lib/Drawing/DockTheme.vala"
		_tmp75_ = cr;
#line 450 "../lib/Drawing/DockTheme.vala"
		cairo_set_source_rgba (_tmp75_, 0.0, 0.0, 0.0, 0.6);
#line 1599 "DockTheme.c"
	}
#line 452 "../lib/Drawing/DockTheme.vala"
	_tmp76_ = cr;
#line 452 "../lib/Drawing/DockTheme.vala"
	_tmp77_ = logical_rect;
#line 452 "../lib/Drawing/DockTheme.vala"
	_tmp78_ = logical_rect;
#line 452 "../lib/Drawing/DockTheme.vala"
	cairo_move_to (_tmp76_, x + floor ((width / 2.0) - ((scale * _tmp77_.width) / 2.0)), y + floor ((height / 2.0) - ((scale * _tmp78_.height) / 2.0)));
#line 455 "../lib/Drawing/DockTheme.vala"
	_tmp79_ = cr;
#line 455 "../lib/Drawing/DockTheme.vala"
	cairo_save (_tmp79_);
#line 456 "../lib/Drawing/DockTheme.vala"
	if (scale < ((gdouble) 1)) {
#line 1615 "DockTheme.c"
		cairo_t* _tmp80_;
#line 457 "../lib/Drawing/DockTheme.vala"
		_tmp80_ = cr;
#line 457 "../lib/Drawing/DockTheme.vala"
		cairo_scale (_tmp80_, scale, scale);
#line 1621 "DockTheme.c"
	}
#line 459 "../lib/Drawing/DockTheme.vala"
	_tmp81_ = cr;
#line 459 "../lib/Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp81_, line_width);
#line 460 "../lib/Drawing/DockTheme.vala"
	_tmp82_ = cr;
#line 460 "../lib/Drawing/DockTheme.vala"
	_tmp83_ = layout;
#line 460 "../lib/Drawing/DockTheme.vala"
	pango_cairo_layout_path (_tmp82_, _tmp83_);
#line 461 "../lib/Drawing/DockTheme.vala"
	_tmp84_ = cr;
#line 461 "../lib/Drawing/DockTheme.vala"
	cairo_stroke_preserve (_tmp84_);
#line 462 "../lib/Drawing/DockTheme.vala"
	_tmp85_ = cr;
#line 462 "../lib/Drawing/DockTheme.vala"
	cairo_set_source_rgba (_tmp85_, 1.0, 1.0, 1.0, 0.95);
#line 463 "../lib/Drawing/DockTheme.vala"
	_tmp86_ = cr;
#line 463 "../lib/Drawing/DockTheme.vala"
	cairo_fill (_tmp86_);
#line 464 "../lib/Drawing/DockTheme.vala"
	_tmp87_ = cr;
#line 464 "../lib/Drawing/DockTheme.vala"
	cairo_restore (_tmp87_);
#line 366 "../lib/Drawing/DockTheme.vala"
	_g_object_unref0 (layout);
#line 366 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 366 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 1655 "DockTheme.c"
}

/**
 * Draws a progress bar for an item.
 *
 * @param surface the surface to draw the progress onto
 * @param icon_size the icon-size of the dock
 * @param color the color of the progress
 * @param progress the value between 0.0 and 1.0
 */
void
plank_dock_theme_draw_item_progress (PlankDockTheme* self,
                                     PlankSurface* surface,
                                     gint icon_size,
                                     PlankColor* color,
                                     gdouble progress)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble x = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble y = 0.0;
	gint _tmp4_;
	gint _tmp5_;
	gdouble line_width = 0.0;
	gdouble padding = 0.0;
	gdouble width = 0.0;
	gdouble height = 0.0;
	cairo_t* _tmp6_;
	cairo_pattern_t* stroke = NULL;
	cairo_pattern_t* fill = NULL;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_pattern_t* _tmp12_;
	cairo_pattern_t* _tmp13_;
	cairo_pattern_t* _tmp14_;
	cairo_pattern_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_pattern_t* _tmp17_;
	cairo_pattern_t* _tmp18_;
	gdouble finished_width = 0.0;
	cairo_pattern_t* _tmp19_;
	cairo_pattern_t* _tmp20_;
#line 476 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 476 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (surface != NULL);
#line 476 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (color != NULL);
#line 478 "../lib/Drawing/DockTheme.vala"
	if (progress < ((gdouble) 0)) {
#line 479 "../lib/Drawing/DockTheme.vala"
		return;
#line 1714 "DockTheme.c"
	}
#line 481 "../lib/Drawing/DockTheme.vala"
	if (progress > 1.0) {
#line 482 "../lib/Drawing/DockTheme.vala"
		progress = 1.0;
#line 1720 "DockTheme.c"
	}
#line 484 "../lib/Drawing/DockTheme.vala"
	_tmp0_ = plank_surface_get_Context (surface);
#line 484 "../lib/Drawing/DockTheme.vala"
	_tmp1_ = _tmp0_;
#line 484 "../lib/Drawing/DockTheme.vala"
	cr = _tmp1_;
#line 488 "../lib/Drawing/DockTheme.vala"
	_tmp2_ = plank_surface_get_Width (surface);
#line 488 "../lib/Drawing/DockTheme.vala"
	_tmp3_ = _tmp2_;
#line 488 "../lib/Drawing/DockTheme.vala"
	x = floor ((gdouble) ((_tmp3_ - icon_size) / 2));
#line 489 "../lib/Drawing/DockTheme.vala"
	_tmp4_ = plank_surface_get_Height (surface);
#line 489 "../lib/Drawing/DockTheme.vala"
	_tmp5_ = _tmp4_;
#line 489 "../lib/Drawing/DockTheme.vala"
	y = floor ((gdouble) ((_tmp5_ - icon_size) / 2));
#line 492 "../lib/Drawing/DockTheme.vala"
	line_width = 1.0;
#line 493 "../lib/Drawing/DockTheme.vala"
	padding = 4.0;
#line 494 "../lib/Drawing/DockTheme.vala"
	width = icon_size - (2.0 * padding);
#line 495 "../lib/Drawing/DockTheme.vala"
	height = floor (MIN (18.0, (gdouble) ((gint) (0.15 * icon_size))));
#line 496 "../lib/Drawing/DockTheme.vala"
	x += padding;
#line 497 "../lib/Drawing/DockTheme.vala"
	y += (icon_size - height) - padding;
#line 499 "../lib/Drawing/DockTheme.vala"
	_tmp6_ = cr;
#line 499 "../lib/Drawing/DockTheme.vala"
	cairo_set_line_width (_tmp6_, line_width);
#line 504 "../lib/Drawing/DockTheme.vala"
	_tmp7_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 504 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 504 "../lib/Drawing/DockTheme.vala"
	stroke = _tmp7_;
#line 505 "../lib/Drawing/DockTheme.vala"
	_tmp8_ = stroke;
#line 505 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp8_, 0.5, 0.5, 0.5, 0.5, 0.1);
#line 506 "../lib/Drawing/DockTheme.vala"
	_tmp9_ = stroke;
#line 506 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp9_, 0.9, 0.8, 0.8, 0.8, 0.4);
#line 507 "../lib/Drawing/DockTheme.vala"
	_tmp10_ = cr;
#line 507 "../lib/Drawing/DockTheme.vala"
	_tmp11_ = stroke;
#line 507 "../lib/Drawing/DockTheme.vala"
	plank_theme_draw_rounded_line (_tmp10_, x + (line_width / 2.0), y + (line_width / 2.0), width, height, TRUE, TRUE, _tmp11_, NULL);
#line 510 "../lib/Drawing/DockTheme.vala"
	x += line_width;
#line 511 "../lib/Drawing/DockTheme.vala"
	y += line_width;
#line 512 "../lib/Drawing/DockTheme.vala"
	width -= 2.0 * line_width;
#line 513 "../lib/Drawing/DockTheme.vala"
	height -= 2.0 * line_width;
#line 515 "../lib/Drawing/DockTheme.vala"
	_tmp12_ = cairo_pattern_create_rgba (0.20, 0.20, 0.20, 0.9);
#line 515 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 515 "../lib/Drawing/DockTheme.vala"
	stroke = _tmp12_;
#line 516 "../lib/Drawing/DockTheme.vala"
	_tmp13_ = cairo_pattern_create_linear ((gdouble) 0, y, (gdouble) 0, y + height);
#line 516 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 516 "../lib/Drawing/DockTheme.vala"
	fill = _tmp13_;
#line 517 "../lib/Drawing/DockTheme.vala"
	_tmp14_ = fill;
#line 517 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp14_, 0.4, 0.25, 0.25, 0.25, 1.0);
#line 518 "../lib/Drawing/DockTheme.vala"
	_tmp15_ = fill;
#line 518 "../lib/Drawing/DockTheme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp15_, 0.9, 0.35, 0.35, 0.35, 1.0);
#line 519 "../lib/Drawing/DockTheme.vala"
	_tmp16_ = cr;
#line 519 "../lib/Drawing/DockTheme.vala"
	_tmp17_ = stroke;
#line 519 "../lib/Drawing/DockTheme.vala"
	_tmp18_ = fill;
#line 519 "../lib/Drawing/DockTheme.vala"
	plank_theme_draw_rounded_line (_tmp16_, x + (line_width / 2.0), y + (line_width / 2.0), width, height, TRUE, TRUE, _tmp17_, _tmp18_);
#line 522 "../lib/Drawing/DockTheme.vala"
	x += line_width;
#line 523 "../lib/Drawing/DockTheme.vala"
	y += line_width;
#line 524 "../lib/Drawing/DockTheme.vala"
	width -= 2.0 * line_width;
#line 525 "../lib/Drawing/DockTheme.vala"
	height -= 2.0 * line_width;
#line 527 "../lib/Drawing/DockTheme.vala"
	finished_width = ceil (progress * width);
#line 528 "../lib/Drawing/DockTheme.vala"
	_tmp19_ = cairo_pattern_create_rgba (0.8, 0.8, 0.8, 1.0);
#line 528 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 528 "../lib/Drawing/DockTheme.vala"
	stroke = _tmp19_;
#line 529 "../lib/Drawing/DockTheme.vala"
	_tmp20_ = cairo_pattern_create_rgba (0.9, 0.9, 0.9, 1.0);
#line 529 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 529 "../lib/Drawing/DockTheme.vala"
	fill = _tmp20_;
#line 532 "../lib/Drawing/DockTheme.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 1836 "DockTheme.c"
		cairo_t* _tmp21_;
		cairo_pattern_t* _tmp22_;
		cairo_pattern_t* _tmp23_;
#line 533 "../lib/Drawing/DockTheme.vala"
		_tmp21_ = cr;
#line 533 "../lib/Drawing/DockTheme.vala"
		_tmp22_ = stroke;
#line 533 "../lib/Drawing/DockTheme.vala"
		_tmp23_ = fill;
#line 533 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp21_, ((x + (line_width / 2.0)) + width) - finished_width, y + (line_width / 2.0), finished_width, height, TRUE, TRUE, _tmp22_, _tmp23_);
#line 1848 "DockTheme.c"
	} else {
		cairo_t* _tmp24_;
		cairo_pattern_t* _tmp25_;
		cairo_pattern_t* _tmp26_;
#line 535 "../lib/Drawing/DockTheme.vala"
		_tmp24_ = cr;
#line 535 "../lib/Drawing/DockTheme.vala"
		_tmp25_ = stroke;
#line 535 "../lib/Drawing/DockTheme.vala"
		_tmp26_ = fill;
#line 535 "../lib/Drawing/DockTheme.vala"
		plank_theme_draw_rounded_line (_tmp24_, x + (line_width / 2.0), y + (line_width / 2.0), finished_width, height, TRUE, TRUE, _tmp25_, _tmp26_);
#line 1861 "DockTheme.c"
	}
#line 476 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (fill);
#line 476 "../lib/Drawing/DockTheme.vala"
	_cairo_pattern_destroy0 (stroke);
#line 1867 "DockTheme.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_theme_real_verify (PlankPreferences* base,
                              const gchar* prop)
{
	PlankDockTheme * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label0 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label1 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label2 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label3 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label4 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label5 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label6 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label7 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label8 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label9 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label10 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label11 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label12 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label13 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label14 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label15 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label16 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label17 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label18 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label19 = 0;
#line 545 "../lib/Drawing/DockTheme.vala"
	static GQuark _tmp1_label20 = 0;
#line 541 "../lib/Drawing/DockTheme.vala"
	self = (PlankDockTheme*) base;
#line 541 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (prop != NULL);
#line 543 "../lib/Drawing/DockTheme.vala"
	PLANK_PREFERENCES_CLASS (plank_dock_theme_parent_class)->verify ((PlankPreferences*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_THEME, PlankTheme), prop);
#line 545 "../lib/Drawing/DockTheme.vala"
	_tmp0_ = prop;
#line 545 "../lib/Drawing/DockTheme.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 545 "../lib/Drawing/DockTheme.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("HorizPadding")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 1936 "DockTheme.c"
			default:
			{
#line 547 "../lib/Drawing/DockTheme.vala"
				break;
#line 1941 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("TopPadding")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 1947 "DockTheme.c"
			default:
			{
#line 550 "../lib/Drawing/DockTheme.vala"
				break;
#line 1952 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("BottomPadding")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 1958 "DockTheme.c"
			default:
			{
				gdouble _tmp3_;
#line 553 "../lib/Drawing/DockTheme.vala"
				_tmp3_ = self->priv->_BottomPadding;
#line 553 "../lib/Drawing/DockTheme.vala"
				if (_tmp3_ < ((gdouble) 0)) {
#line 554 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_BottomPadding (self, (gdouble) 0);
#line 1968 "DockTheme.c"
				}
#line 555 "../lib/Drawing/DockTheme.vala"
				break;
#line 1972 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("ItemPadding")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 1978 "DockTheme.c"
			default:
			{
				gdouble _tmp4_;
#line 558 "../lib/Drawing/DockTheme.vala"
				_tmp4_ = self->priv->_ItemPadding;
#line 558 "../lib/Drawing/DockTheme.vala"
				if (_tmp4_ < ((gdouble) 0)) {
#line 559 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_ItemPadding (self, (gdouble) 0);
#line 1988 "DockTheme.c"
				}
#line 560 "../lib/Drawing/DockTheme.vala"
				break;
#line 1992 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("IndicatorSize")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 1998 "DockTheme.c"
			default:
			{
				gdouble _tmp5_;
#line 563 "../lib/Drawing/DockTheme.vala"
				_tmp5_ = self->priv->_IndicatorSize;
#line 563 "../lib/Drawing/DockTheme.vala"
				if (_tmp5_ < PLANK_DOCK_THEME_MIN_INDICATOR_SIZE) {
#line 564 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_IndicatorSize (self, PLANK_DOCK_THEME_MIN_INDICATOR_SIZE);
#line 2008 "DockTheme.c"
				} else {
					gdouble _tmp6_;
#line 565 "../lib/Drawing/DockTheme.vala"
					_tmp6_ = self->priv->_IndicatorSize;
#line 565 "../lib/Drawing/DockTheme.vala"
					if (_tmp6_ > PLANK_DOCK_THEME_MAX_INDICATOR_SIZE) {
#line 566 "../lib/Drawing/DockTheme.vala"
						plank_dock_theme_set_IndicatorSize (self, PLANK_DOCK_THEME_MAX_INDICATOR_SIZE);
#line 2017 "DockTheme.c"
					}
				}
#line 567 "../lib/Drawing/DockTheme.vala"
				break;
#line 2022 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("IconShadowSize")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2028 "DockTheme.c"
			default:
			{
				gdouble _tmp7_;
#line 570 "../lib/Drawing/DockTheme.vala"
				_tmp7_ = self->priv->_IconShadowSize;
#line 570 "../lib/Drawing/DockTheme.vala"
				if (_tmp7_ < ((gdouble) 0)) {
#line 571 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_IconShadowSize (self, (gdouble) 0);
#line 2038 "DockTheme.c"
				} else {
					gdouble _tmp8_;
#line 572 "../lib/Drawing/DockTheme.vala"
					_tmp8_ = self->priv->_IconShadowSize;
#line 572 "../lib/Drawing/DockTheme.vala"
					if (_tmp8_ > PLANK_DOCK_THEME_MAX_ICON_SHADOW_SIZE) {
#line 573 "../lib/Drawing/DockTheme.vala"
						plank_dock_theme_set_IconShadowSize (self, PLANK_DOCK_THEME_MAX_ICON_SHADOW_SIZE);
#line 2047 "DockTheme.c"
					}
				}
#line 574 "../lib/Drawing/DockTheme.vala"
				break;
#line 2052 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("UrgentBounceHeight")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2058 "DockTheme.c"
			default:
			{
				gdouble _tmp9_;
#line 577 "../lib/Drawing/DockTheme.vala"
				_tmp9_ = self->priv->_UrgentBounceHeight;
#line 577 "../lib/Drawing/DockTheme.vala"
				if (_tmp9_ < ((gdouble) 0)) {
#line 578 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_UrgentBounceHeight (self, (gdouble) 0);
#line 2068 "DockTheme.c"
				}
#line 579 "../lib/Drawing/DockTheme.vala"
				break;
#line 2072 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("LaunchBounceHeight")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2078 "DockTheme.c"
			default:
			{
				gdouble _tmp10_;
#line 582 "../lib/Drawing/DockTheme.vala"
				_tmp10_ = self->priv->_LaunchBounceHeight;
#line 582 "../lib/Drawing/DockTheme.vala"
				if (_tmp10_ < ((gdouble) 0)) {
#line 583 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_LaunchBounceHeight (self, (gdouble) 0);
#line 2088 "DockTheme.c"
				}
#line 584 "../lib/Drawing/DockTheme.vala"
				break;
#line 2092 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("FadeOpacity")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2098 "DockTheme.c"
			default:
			{
				gdouble _tmp11_;
#line 587 "../lib/Drawing/DockTheme.vala"
				_tmp11_ = self->priv->_FadeOpacity;
#line 587 "../lib/Drawing/DockTheme.vala"
				if (_tmp11_ < ((gdouble) 0)) {
#line 588 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_FadeOpacity (self, (gdouble) 0);
#line 2108 "DockTheme.c"
				} else {
					gdouble _tmp12_;
#line 589 "../lib/Drawing/DockTheme.vala"
					_tmp12_ = self->priv->_FadeOpacity;
#line 589 "../lib/Drawing/DockTheme.vala"
					if (_tmp12_ > ((gdouble) 1)) {
#line 590 "../lib/Drawing/DockTheme.vala"
						plank_dock_theme_set_FadeOpacity (self, (gdouble) 1);
#line 2117 "DockTheme.c"
					}
				}
#line 591 "../lib/Drawing/DockTheme.vala"
				break;
#line 2122 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("ClickTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2128 "DockTheme.c"
			default:
			{
				gint _tmp13_;
#line 594 "../lib/Drawing/DockTheme.vala"
				_tmp13_ = self->priv->_ClickTime;
#line 594 "../lib/Drawing/DockTheme.vala"
				if (_tmp13_ < 0) {
#line 595 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_ClickTime (self, 0);
#line 2138 "DockTheme.c"
				}
#line 596 "../lib/Drawing/DockTheme.vala"
				break;
#line 2142 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("UrgentBounceTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2148 "DockTheme.c"
			default:
			{
				gint _tmp14_;
#line 599 "../lib/Drawing/DockTheme.vala"
				_tmp14_ = self->priv->_UrgentBounceTime;
#line 599 "../lib/Drawing/DockTheme.vala"
				if (_tmp14_ < 0) {
#line 600 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_UrgentBounceTime (self, 0);
#line 2158 "DockTheme.c"
				}
#line 601 "../lib/Drawing/DockTheme.vala"
				break;
#line 2162 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("LaunchBounceTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2168 "DockTheme.c"
			default:
			{
				gint _tmp15_;
#line 604 "../lib/Drawing/DockTheme.vala"
				_tmp15_ = self->priv->_LaunchBounceTime;
#line 604 "../lib/Drawing/DockTheme.vala"
				if (_tmp15_ < 0) {
#line 605 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_LaunchBounceTime (self, 0);
#line 2178 "DockTheme.c"
				}
#line 606 "../lib/Drawing/DockTheme.vala"
				break;
#line 2182 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("ActiveTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2188 "DockTheme.c"
			default:
			{
				gint _tmp16_;
#line 609 "../lib/Drawing/DockTheme.vala"
				_tmp16_ = self->priv->_ActiveTime;
#line 609 "../lib/Drawing/DockTheme.vala"
				if (_tmp16_ < 0) {
#line 610 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_ActiveTime (self, 0);
#line 2198 "DockTheme.c"
				}
#line 611 "../lib/Drawing/DockTheme.vala"
				break;
#line 2202 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("SlideTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2208 "DockTheme.c"
			default:
			{
				gint _tmp17_;
#line 614 "../lib/Drawing/DockTheme.vala"
				_tmp17_ = self->priv->_SlideTime;
#line 614 "../lib/Drawing/DockTheme.vala"
				if (_tmp17_ < 0) {
#line 615 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_SlideTime (self, 0);
#line 2218 "DockTheme.c"
				}
#line 616 "../lib/Drawing/DockTheme.vala"
				break;
#line 2222 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("FadeTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2228 "DockTheme.c"
			default:
			{
				gint _tmp18_;
#line 619 "../lib/Drawing/DockTheme.vala"
				_tmp18_ = self->priv->_FadeTime;
#line 619 "../lib/Drawing/DockTheme.vala"
				if (_tmp18_ < 0) {
#line 620 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_FadeTime (self, 0);
#line 2238 "DockTheme.c"
				}
#line 621 "../lib/Drawing/DockTheme.vala"
				break;
#line 2242 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("HideTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2248 "DockTheme.c"
			default:
			{
				gint _tmp19_;
#line 624 "../lib/Drawing/DockTheme.vala"
				_tmp19_ = self->priv->_HideTime;
#line 624 "../lib/Drawing/DockTheme.vala"
				if (_tmp19_ < 0) {
#line 625 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_HideTime (self, 0);
#line 2258 "DockTheme.c"
				}
#line 626 "../lib/Drawing/DockTheme.vala"
				break;
#line 2262 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("GlowSize")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2268 "DockTheme.c"
			default:
			{
				gint _tmp20_;
#line 629 "../lib/Drawing/DockTheme.vala"
				_tmp20_ = self->priv->_GlowSize;
#line 629 "../lib/Drawing/DockTheme.vala"
				if (_tmp20_ < 0) {
#line 630 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_GlowSize (self, 0);
#line 2278 "DockTheme.c"
				}
#line 631 "../lib/Drawing/DockTheme.vala"
				break;
#line 2282 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label17) ? _tmp1_label17 : (_tmp1_label17 = g_quark_from_static_string ("GlowTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2288 "DockTheme.c"
			default:
			{
				gint _tmp21_;
#line 634 "../lib/Drawing/DockTheme.vala"
				_tmp21_ = self->priv->_GlowTime;
#line 634 "../lib/Drawing/DockTheme.vala"
				if (_tmp21_ < 0) {
#line 635 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_GlowTime (self, 0);
#line 2298 "DockTheme.c"
				}
#line 636 "../lib/Drawing/DockTheme.vala"
				break;
#line 2302 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label18) ? _tmp1_label18 : (_tmp1_label18 = g_quark_from_static_string ("GlowPulseTime")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2308 "DockTheme.c"
			default:
			{
				gint _tmp22_;
#line 639 "../lib/Drawing/DockTheme.vala"
				_tmp22_ = self->priv->_GlowPulseTime;
#line 639 "../lib/Drawing/DockTheme.vala"
				if (_tmp22_ < 0) {
#line 640 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_GlowPulseTime (self, 0);
#line 2318 "DockTheme.c"
				}
#line 641 "../lib/Drawing/DockTheme.vala"
				break;
#line 2322 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label19) ? _tmp1_label19 : (_tmp1_label19 = g_quark_from_static_string ("UrgentHueShift")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2328 "DockTheme.c"
			default:
			{
				gint _tmp23_;
#line 644 "../lib/Drawing/DockTheme.vala"
				_tmp23_ = self->priv->_UrgentHueShift;
#line 644 "../lib/Drawing/DockTheme.vala"
				if (_tmp23_ < -180) {
#line 645 "../lib/Drawing/DockTheme.vala"
					plank_dock_theme_set_UrgentHueShift (self, -180);
#line 2338 "DockTheme.c"
				} else {
					gint _tmp24_;
#line 646 "../lib/Drawing/DockTheme.vala"
					_tmp24_ = self->priv->_UrgentHueShift;
#line 646 "../lib/Drawing/DockTheme.vala"
					if (_tmp24_ > 180) {
#line 647 "../lib/Drawing/DockTheme.vala"
						plank_dock_theme_set_UrgentHueShift (self, 180);
#line 2347 "DockTheme.c"
					}
				}
#line 648 "../lib/Drawing/DockTheme.vala"
				break;
#line 2352 "DockTheme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label20) ? _tmp1_label20 : (_tmp1_label20 = g_quark_from_static_string ("BadgeColor")))) {
#line 545 "../lib/Drawing/DockTheme.vala"
		switch (0) {
#line 2358 "DockTheme.c"
			default:
			{
#line 651 "../lib/Drawing/DockTheme.vala"
				break;
#line 2363 "DockTheme.c"
			}
		}
	}
}

gdouble
plank_dock_theme_get_HorizPadding (PlankDockTheme* self)
{
	gdouble result;
#line 32 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 32 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_HorizPadding;
#line 32 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2379 "DockTheme.c"
}

void
plank_dock_theme_set_HorizPadding (PlankDockTheme* self,
                                   gdouble value)
{
	gdouble old_value;
#line 32 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 32 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_HorizPadding (self);
#line 32 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 32 "../lib/Drawing/DockTheme.vala"
		self->priv->_HorizPadding = value;
#line 32 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY]);
#line 2397 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_TopPadding (PlankDockTheme* self)
{
	gdouble result;
#line 35 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 35 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_TopPadding;
#line 35 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2411 "DockTheme.c"
}

void
plank_dock_theme_set_TopPadding (PlankDockTheme* self,
                                 gdouble value)
{
	gdouble old_value;
#line 35 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 35 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_TopPadding (self);
#line 35 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 35 "../lib/Drawing/DockTheme.vala"
		self->priv->_TopPadding = value;
#line 35 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_TOP_PADDING_PROPERTY]);
#line 2429 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_BottomPadding (PlankDockTheme* self)
{
	gdouble result;
#line 38 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 38 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_BottomPadding;
#line 38 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2443 "DockTheme.c"
}

void
plank_dock_theme_set_BottomPadding (PlankDockTheme* self,
                                    gdouble value)
{
	gdouble old_value;
#line 38 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 38 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_BottomPadding (self);
#line 38 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 38 "../lib/Drawing/DockTheme.vala"
		self->priv->_BottomPadding = value;
#line 38 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY]);
#line 2461 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_ItemPadding (PlankDockTheme* self)
{
	gdouble result;
#line 41 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 41 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_ItemPadding;
#line 41 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2475 "DockTheme.c"
}

void
plank_dock_theme_set_ItemPadding (PlankDockTheme* self,
                                  gdouble value)
{
	gdouble old_value;
#line 41 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ItemPadding (self);
#line 41 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 41 "../lib/Drawing/DockTheme.vala"
		self->priv->_ItemPadding = value;
#line 41 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY]);
#line 2493 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_IndicatorSize (PlankDockTheme* self)
{
	gdouble result;
#line 44 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 44 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_IndicatorSize;
#line 44 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2507 "DockTheme.c"
}

void
plank_dock_theme_set_IndicatorSize (PlankDockTheme* self,
                                    gdouble value)
{
	gdouble old_value;
#line 44 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 44 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_IndicatorSize (self);
#line 44 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 44 "../lib/Drawing/DockTheme.vala"
		self->priv->_IndicatorSize = value;
#line 44 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY]);
#line 2525 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_IconShadowSize (PlankDockTheme* self)
{
	gdouble result;
#line 47 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 47 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_IconShadowSize;
#line 47 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2539 "DockTheme.c"
}

void
plank_dock_theme_set_IconShadowSize (PlankDockTheme* self,
                                     gdouble value)
{
	gdouble old_value;
#line 47 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 47 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_IconShadowSize (self);
#line 47 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 47 "../lib/Drawing/DockTheme.vala"
		self->priv->_IconShadowSize = value;
#line 47 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY]);
#line 2557 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_UrgentBounceHeight (PlankDockTheme* self)
{
	gdouble result;
#line 50 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 50 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_UrgentBounceHeight;
#line 50 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2571 "DockTheme.c"
}

void
plank_dock_theme_set_UrgentBounceHeight (PlankDockTheme* self,
                                         gdouble value)
{
	gdouble old_value;
#line 50 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 50 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_UrgentBounceHeight (self);
#line 50 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 50 "../lib/Drawing/DockTheme.vala"
		self->priv->_UrgentBounceHeight = value;
#line 50 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY]);
#line 2589 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_LaunchBounceHeight (PlankDockTheme* self)
{
	gdouble result;
#line 53 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 53 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_LaunchBounceHeight;
#line 53 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2603 "DockTheme.c"
}

void
plank_dock_theme_set_LaunchBounceHeight (PlankDockTheme* self,
                                         gdouble value)
{
	gdouble old_value;
#line 53 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 53 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_LaunchBounceHeight (self);
#line 53 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 53 "../lib/Drawing/DockTheme.vala"
		self->priv->_LaunchBounceHeight = value;
#line 53 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY]);
#line 2621 "DockTheme.c"
	}
}

gdouble
plank_dock_theme_get_FadeOpacity (PlankDockTheme* self)
{
	gdouble result;
#line 56 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 56 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_FadeOpacity;
#line 56 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2635 "DockTheme.c"
}

void
plank_dock_theme_set_FadeOpacity (PlankDockTheme* self,
                                  gdouble value)
{
	gdouble old_value;
#line 56 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 56 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_FadeOpacity (self);
#line 56 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 56 "../lib/Drawing/DockTheme.vala"
		self->priv->_FadeOpacity = value;
#line 56 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY]);
#line 2653 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_ClickTime (PlankDockTheme* self)
{
	gint result;
#line 59 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_ClickTime;
#line 59 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2667 "DockTheme.c"
}

void
plank_dock_theme_set_ClickTime (PlankDockTheme* self,
                                gint value)
{
	gint old_value;
#line 59 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 59 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ClickTime (self);
#line 59 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 59 "../lib/Drawing/DockTheme.vala"
		self->priv->_ClickTime = value;
#line 59 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_CLICK_TIME_PROPERTY]);
#line 2685 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_UrgentBounceTime (PlankDockTheme* self)
{
	gint result;
#line 62 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_UrgentBounceTime;
#line 62 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2699 "DockTheme.c"
}

void
plank_dock_theme_set_UrgentBounceTime (PlankDockTheme* self,
                                       gint value)
{
	gint old_value;
#line 62 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 62 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_UrgentBounceTime (self);
#line 62 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 62 "../lib/Drawing/DockTheme.vala"
		self->priv->_UrgentBounceTime = value;
#line 62 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY]);
#line 2717 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_LaunchBounceTime (PlankDockTheme* self)
{
	gint result;
#line 65 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_LaunchBounceTime;
#line 65 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2731 "DockTheme.c"
}

void
plank_dock_theme_set_LaunchBounceTime (PlankDockTheme* self,
                                       gint value)
{
	gint old_value;
#line 65 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 65 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_LaunchBounceTime (self);
#line 65 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 65 "../lib/Drawing/DockTheme.vala"
		self->priv->_LaunchBounceTime = value;
#line 65 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY]);
#line 2749 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_ActiveTime (PlankDockTheme* self)
{
	gint result;
#line 68 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_ActiveTime;
#line 68 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2763 "DockTheme.c"
}

void
plank_dock_theme_set_ActiveTime (PlankDockTheme* self,
                                 gint value)
{
	gint old_value;
#line 68 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 68 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ActiveTime (self);
#line 68 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 68 "../lib/Drawing/DockTheme.vala"
		self->priv->_ActiveTime = value;
#line 68 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY]);
#line 2781 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_SlideTime (PlankDockTheme* self)
{
	gint result;
#line 71 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 71 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_SlideTime;
#line 71 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2795 "DockTheme.c"
}

void
plank_dock_theme_set_SlideTime (PlankDockTheme* self,
                                gint value)
{
	gint old_value;
#line 71 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 71 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_SlideTime (self);
#line 71 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 71 "../lib/Drawing/DockTheme.vala"
		self->priv->_SlideTime = value;
#line 71 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY]);
#line 2813 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_FadeTime (PlankDockTheme* self)
{
	gint result;
#line 74 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 74 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_FadeTime;
#line 74 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2827 "DockTheme.c"
}

void
plank_dock_theme_set_FadeTime (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 74 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 74 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_FadeTime (self);
#line 74 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 74 "../lib/Drawing/DockTheme.vala"
		self->priv->_FadeTime = value;
#line 74 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_TIME_PROPERTY]);
#line 2845 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_HideTime (PlankDockTheme* self)
{
	gint result;
#line 77 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_HideTime;
#line 77 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2859 "DockTheme.c"
}

void
plank_dock_theme_set_HideTime (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 77 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 77 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_HideTime (self);
#line 77 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 77 "../lib/Drawing/DockTheme.vala"
		self->priv->_HideTime = value;
#line 77 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_HIDE_TIME_PROPERTY]);
#line 2877 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_GlowSize (PlankDockTheme* self)
{
	gint result;
#line 80 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_GlowSize;
#line 80 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2891 "DockTheme.c"
}

void
plank_dock_theme_set_GlowSize (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 80 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 80 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_GlowSize (self);
#line 80 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 80 "../lib/Drawing/DockTheme.vala"
		self->priv->_GlowSize = value;
#line 80 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY]);
#line 2909 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_GlowTime (PlankDockTheme* self)
{
	gint result;
#line 83 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 83 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_GlowTime;
#line 83 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2923 "DockTheme.c"
}

void
plank_dock_theme_set_GlowTime (PlankDockTheme* self,
                               gint value)
{
	gint old_value;
#line 83 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 83 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_GlowTime (self);
#line 83 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 83 "../lib/Drawing/DockTheme.vala"
		self->priv->_GlowTime = value;
#line 83 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_TIME_PROPERTY]);
#line 2941 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_GlowPulseTime (PlankDockTheme* self)
{
	gint result;
#line 86 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 86 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_GlowPulseTime;
#line 86 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2955 "DockTheme.c"
}

void
plank_dock_theme_set_GlowPulseTime (PlankDockTheme* self,
                                    gint value)
{
	gint old_value;
#line 86 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 86 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_GlowPulseTime (self);
#line 86 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 86 "../lib/Drawing/DockTheme.vala"
		self->priv->_GlowPulseTime = value;
#line 86 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY]);
#line 2973 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_UrgentHueShift (PlankDockTheme* self)
{
	gint result;
#line 89 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 89 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_UrgentHueShift;
#line 89 "../lib/Drawing/DockTheme.vala"
	return result;
#line 2987 "DockTheme.c"
}

void
plank_dock_theme_set_UrgentHueShift (PlankDockTheme* self,
                                     gint value)
{
	gint old_value;
#line 89 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 89 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_UrgentHueShift (self);
#line 89 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 89 "../lib/Drawing/DockTheme.vala"
		self->priv->_UrgentHueShift = value;
#line 89 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY]);
#line 3005 "DockTheme.c"
	}
}

gint
plank_dock_theme_get_ItemMoveTime (PlankDockTheme* self)
{
	gint result;
#line 92 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_ItemMoveTime;
#line 92 "../lib/Drawing/DockTheme.vala"
	return result;
#line 3019 "DockTheme.c"
}

void
plank_dock_theme_set_ItemMoveTime (PlankDockTheme* self,
                                   gint value)
{
	gint old_value;
#line 92 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 92 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_ItemMoveTime (self);
#line 92 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 92 "../lib/Drawing/DockTheme.vala"
		self->priv->_ItemMoveTime = value;
#line 92 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY]);
#line 3037 "DockTheme.c"
	}
}

gboolean
plank_dock_theme_get_CascadeHide (PlankDockTheme* self)
{
	gboolean result;
#line 95 "../lib/Drawing/DockTheme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 95 "../lib/Drawing/DockTheme.vala"
	result = self->priv->_CascadeHide;
#line 95 "../lib/Drawing/DockTheme.vala"
	return result;
#line 3051 "DockTheme.c"
}

void
plank_dock_theme_set_CascadeHide (PlankDockTheme* self,
                                  gboolean value)
{
	gboolean old_value;
#line 95 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 95 "../lib/Drawing/DockTheme.vala"
	old_value = plank_dock_theme_get_CascadeHide (self);
#line 95 "../lib/Drawing/DockTheme.vala"
	if (old_value != value) {
#line 95 "../lib/Drawing/DockTheme.vala"
		self->priv->_CascadeHide = value;
#line 95 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY]);
#line 3069 "DockTheme.c"
	}
}

void
plank_dock_theme_get_BadgeColor (PlankDockTheme* self,
                                 PlankColor * result)
{
	PlankColor _tmp0_;
#line 98 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 98 "../lib/Drawing/DockTheme.vala"
	_tmp0_ = self->priv->_BadgeColor;
#line 98 "../lib/Drawing/DockTheme.vala"
	*result = _tmp0_;
#line 98 "../lib/Drawing/DockTheme.vala"
	return;
#line 3086 "DockTheme.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 98 "../lib/Drawing/DockTheme.vala"
	if (s1 == s2) {
#line 98 "../lib/Drawing/DockTheme.vala"
		return TRUE;
#line 3097 "DockTheme.c"
	}
#line 98 "../lib/Drawing/DockTheme.vala"
	if (s1 == NULL) {
#line 98 "../lib/Drawing/DockTheme.vala"
		return FALSE;
#line 3103 "DockTheme.c"
	}
#line 98 "../lib/Drawing/DockTheme.vala"
	if (s2 == NULL) {
#line 98 "../lib/Drawing/DockTheme.vala"
		return FALSE;
#line 3109 "DockTheme.c"
	}
#line 98 "../lib/Drawing/DockTheme.vala"
	if (s1->red != s2->red) {
#line 98 "../lib/Drawing/DockTheme.vala"
		return FALSE;
#line 3115 "DockTheme.c"
	}
#line 98 "../lib/Drawing/DockTheme.vala"
	if (s1->green != s2->green) {
#line 98 "../lib/Drawing/DockTheme.vala"
		return FALSE;
#line 3121 "DockTheme.c"
	}
#line 98 "../lib/Drawing/DockTheme.vala"
	if (s1->blue != s2->blue) {
#line 98 "../lib/Drawing/DockTheme.vala"
		return FALSE;
#line 3127 "DockTheme.c"
	}
#line 98 "../lib/Drawing/DockTheme.vala"
	if (s1->alpha != s2->alpha) {
#line 98 "../lib/Drawing/DockTheme.vala"
		return FALSE;
#line 3133 "DockTheme.c"
	}
#line 98 "../lib/Drawing/DockTheme.vala"
	return TRUE;
#line 3137 "DockTheme.c"
}

void
plank_dock_theme_set_BadgeColor (PlankDockTheme* self,
                                 PlankColor * value)
{
	PlankColor old_value;
#line 98 "../lib/Drawing/DockTheme.vala"
	g_return_if_fail (self != NULL);
#line 98 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_get_BadgeColor (self, &old_value);
#line 98 "../lib/Drawing/DockTheme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 3151 "DockTheme.c"
		PlankColor _tmp0_;
#line 98 "../lib/Drawing/DockTheme.vala"
		_tmp0_ = *value;
#line 98 "../lib/Drawing/DockTheme.vala"
		self->priv->_BadgeColor = _tmp0_;
#line 98 "../lib/Drawing/DockTheme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_theme_properties[PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY]);
#line 3159 "DockTheme.c"
	}
}

static void
plank_dock_theme_class_init (PlankDockThemeClass * klass,
                             gpointer klass_data)
{
#line 25 "../lib/Drawing/DockTheme.vala"
	plank_dock_theme_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Drawing/DockTheme.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockTheme_private_offset);
#line 25 "../lib/Drawing/DockTheme.vala"
	((PlankPreferencesClass *) klass)->reset_properties = (void (*) (PlankPreferences*)) plank_dock_theme_real_reset_properties;
#line 25 "../lib/Drawing/DockTheme.vala"
	((PlankPreferencesClass *) klass)->verify = (void (*) (PlankPreferences*, const gchar*)) plank_dock_theme_real_verify;
#line 25 "../lib/Drawing/DockTheme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_theme_get_property;
#line 25 "../lib/Drawing/DockTheme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_theme_set_property;
#line 25 "../lib/Drawing/DockTheme.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_theme_finalize;
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY] = g_param_spec_double ("HorizPadding", "horizontal-padding", "The padding on the left/right dock edges, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_TOP_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_TOP_PADDING_PROPERTY] = g_param_spec_double ("TopPadding", "top-padding", "The padding on the top dock edge, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY] = g_param_spec_double ("BottomPadding", "bottom-padding", "The padding on the bottom dock edge, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY] = g_param_spec_double ("ItemPadding", "item-padding", "The padding between items on the dock, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY] = g_param_spec_double ("IndicatorSize", "indicator-size", "The size of item indicators, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY] = g_param_spec_double ("IconShadowSize", "icon-shadow-size", "The size of the icon-shadow behind every item, in tenths of a percent of IconSize.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_double ("UrgentBounceHeight", "urgent-bounce", "The height (in percent of IconSize) to bounce an icon when the application sets urgent.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_double ("LaunchBounceHeight", "launch-bounce", "The height (in percent of IconSize) to bounce an icon when launching an application.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY] = g_param_spec_double ("FadeOpacity", "fade-opacity", "The opacity value (0 to 1) to fade the dock to when hiding it.", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_CLICK_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_CLICK_TIME_PROPERTY] = g_param_spec_int ("ClickTime", "click-time", "The amount of time (in ms) for click animations.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY] = g_param_spec_int ("UrgentBounceTime", "urgent-bounce-time", "The amount of time (in ms) to bounce an urgent icon.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY] = g_param_spec_int ("LaunchBounceTime", "launch-bounce-time", "The amount of time (in ms) to bounce an icon when launching an application.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY] = g_param_spec_int ("ActiveTime", "active-time", "The amount of time (in ms) for active window indicator animations.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY] = g_param_spec_int ("SlideTime", "slide-time", "The amount of time (in ms) to slide icons into/out of the dock.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_FADE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_FADE_TIME_PROPERTY] = g_param_spec_int ("FadeTime", "fade-time", "The time (in ms) to fade the dock in/out on a hide (if FadeOpacity is < 1).", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_HIDE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_HIDE_TIME_PROPERTY] = g_param_spec_int ("HideTime", "hide-time", "The time (in ms) to slide the dock in/out on a hide (if FadeOpacity is 1).", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY] = g_param_spec_int ("GlowSize", "glow-size", "The size of the urgent glow (shown when dock is hidden), in tenths of a percent of IconSize.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_GLOW_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_TIME_PROPERTY] = g_param_spec_int ("GlowTime", "glow-time", "The total time (in ms) to show the hidden-dock urgent glow.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY] = g_param_spec_int ("GlowPulseTime", "glow-pulse-time", "The time (in ms) of each pulse of the hidden-dock urgent glow.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY] = g_param_spec_int ("UrgentHueShift", "urgent-hue-shift", "The hue-shift (-180 to 180) of the urgent indicator color.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY] = g_param_spec_int ("ItemMoveTime", "item-move-time", "The time (in ms) to move an item to its new position or its addition/removal to/from the dock.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY] = g_param_spec_boolean ("CascadeHide", "cascade-hide", "Whether background and icons will unhide/hide with different speeds. The top-border of both will leave/hit the screen-edge at the same time.", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/DockTheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY, plank_dock_theme_properties[PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY] = g_param_spec_boxed ("BadgeColor", "badge-color", "The color (RGBA) of the badge displaying urgent count", PLANK_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3227 "DockTheme.c"
}

static void
plank_dock_theme_instance_init (PlankDockTheme * self,
                                gpointer klass)
{
#line 25 "../lib/Drawing/DockTheme.vala"
	self->priv = plank_dock_theme_get_instance_private (self);
#line 3236 "DockTheme.c"
}

static void
plank_dock_theme_finalize (GObject * obj)
{
	PlankDockTheme * self;
#line 25 "../lib/Drawing/DockTheme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_THEME, PlankDockTheme);
#line 25 "../lib/Drawing/DockTheme.vala"
	G_OBJECT_CLASS (plank_dock_theme_parent_class)->finalize (obj);
#line 3247 "DockTheme.c"
}

/**
 * A themed renderer for dock windows.
 */
static GType
plank_dock_theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockTheme), 0, (GInstanceInitFunc) plank_dock_theme_instance_init, NULL };
	GType plank_dock_theme_type_id;
	plank_dock_theme_type_id = g_type_register_static (PLANK_TYPE_THEME, "PlankDockTheme", &g_define_type_info, 0);
	PlankDockTheme_private_offset = g_type_add_instance_private (plank_dock_theme_type_id, sizeof (PlankDockThemePrivate));
	return plank_dock_theme_type_id;
}

GType
plank_dock_theme_get_type (void)
{
	static volatile gsize plank_dock_theme_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_theme_type_id__once)) {
		GType plank_dock_theme_type_id;
		plank_dock_theme_type_id = plank_dock_theme_get_type_once ();
		g_once_init_leave (&plank_dock_theme_type_id__once, plank_dock_theme_type_id);
	}
	return plank_dock_theme_type_id__once;
}

static void
_vala_plank_dock_theme_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	PlankDockTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_THEME, PlankDockTheme);
#line 25 "../lib/Drawing/DockTheme.vala"
	switch (property_id) {
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_HorizPadding (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_TOP_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_TopPadding (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_BottomPadding (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_ItemPadding (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_IndicatorSize (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_IconShadowSize (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_UrgentBounceHeight (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_LaunchBounceHeight (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_double (value, plank_dock_theme_get_FadeOpacity (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CLICK_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_ClickTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_UrgentBounceTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_LaunchBounceTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_ActiveTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_SlideTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_FadeTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HIDE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_HideTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_GlowSize (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_GlowTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_GlowPulseTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_UrgentHueShift (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_int (value, plank_dock_theme_get_ItemMoveTime (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		g_value_set_boolean (value, plank_dock_theme_get_CascadeHide (self));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY:
#line 3419 "DockTheme.c"
		{
			PlankColor boxed;
#line 25 "../lib/Drawing/DockTheme.vala"
			plank_dock_theme_get_BadgeColor (self, &boxed);
#line 25 "../lib/Drawing/DockTheme.vala"
			g_value_set_boxed (value, &boxed);
#line 3426 "DockTheme.c"
		}
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 3430 "DockTheme.c"
		default:
#line 25 "../lib/Drawing/DockTheme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 3436 "DockTheme.c"
	}
}

static void
_vala_plank_dock_theme_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	PlankDockTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_THEME, PlankDockTheme);
#line 25 "../lib/Drawing/DockTheme.vala"
	switch (property_id) {
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HORIZ_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_HorizPadding (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_TOP_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_TopPadding (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BOTTOM_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_BottomPadding (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_PADDING_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_ItemPadding (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_INDICATOR_SIZE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_IndicatorSize (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_IconShadowSize (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_UrgentBounceHeight (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_LaunchBounceHeight (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_OPACITY_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_FadeOpacity (self, g_value_get_double (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CLICK_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_ClickTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_BOUNCE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_UrgentBounceTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_LAUNCH_BOUNCE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_LaunchBounceTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ACTIVE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_ActiveTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_SLIDE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_SlideTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_FADE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_FadeTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_HIDE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_HideTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_SIZE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_GlowSize (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_GlowTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_GLOW_PULSE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_GlowPulseTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_URGENT_HUE_SHIFT_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_UrgentHueShift (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_ITEM_MOVE_TIME_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_ItemMoveTime (self, g_value_get_int (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_CASCADE_HIDE_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_CascadeHide (self, g_value_get_boolean (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 25 "../lib/Drawing/DockTheme.vala"
		case PLANK_DOCK_THEME_BADGE_COLOR_PROPERTY:
#line 25 "../lib/Drawing/DockTheme.vala"
		plank_dock_theme_set_BadgeColor (self, g_value_get_boxed (value));
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 3588 "DockTheme.c"
		default:
#line 25 "../lib/Drawing/DockTheme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Drawing/DockTheme.vala"
		break;
#line 3594 "DockTheme.c"
	}
}

