/* DockWindow.c generated by valac 0.56.3, the Vala compiler
 * generated from DockWindow.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Michal Hruby, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "plank-internal.h"
#include <libbamf/libbamf.h>
#include <gio/gio.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#define PLANK_DOCK_WINDOW_LONG_PRESS_TIME 750U
#define PLANK_DOCK_WINDOW_HOVER_DELAY_TIME 200U

enum  {
	PLANK_DOCK_WINDOW_0_PROPERTY,
	PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY,
	PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY,
	PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY,
	PLANK_DOCK_WINDOW_NUM_PROPERTIES
};
static GParamSpec* plank_dock_window_properties[PLANK_DOCK_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block18Data Block18Data;
typedef struct _Block19Data Block19Data;
typedef struct _Block20Data Block20Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))

struct _PlankDockWindowPrivate {
	PlankDockController* _controller;
	PlankDockItem* _HoveredItem;
	PlankDockItemProvider* _HoveredItemProvider;
	PlankDockItem* _ClickedItem;
	GtkMenu* menu;
	GeeArrayList* menu_items;
	guint hover_reposition_timer_id;
	guint long_press_timer_id;
	gboolean long_press_active;
	guint long_press_button;
	GdkRectangle input_rect;
	gint requested_x;
	gint requested_y;
	gint window_position_retry;
};

struct _Block18Data {
	int _ref_count_;
	PlankDockWindow* self;
	GraniteSettings* granite_settings;
	GtkSettings* gtk_settings;
};

struct _Block19Data {
	int _ref_count_;
	PlankDockController* controller;
};

struct _Block20Data {
	int _ref_count_;
	GFile* dock_item_file;
	PlankDockItem* item;
};

static gint PlankDockWindow_private_offset;
static gpointer plank_dock_window_parent_class = NULL;

static void plank_dock_window_on_menu_show (PlankDockWindow* self);
static void _plank_dock_window_on_menu_show_gtk_widget_show (GtkWidget* _sender,
                                                      gpointer self);
static void plank_dock_window_on_menu_hide (PlankDockWindow* self);
static void _plank_dock_window_on_menu_hide_gtk_widget_hide (GtkWidget* _sender,
                                                      gpointer self);
static PlankDockController* plank_dock_window_get_controller (PlankDockWindow* self);
static void plank_dock_window_set_struts (PlankDockWindow* self);
static void _plank_dock_window_set_struts_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void __lambda51_ (Block18Data* _data18_);
static void ___lambda51__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean plank_dock_window_real_button_press_event (GtkWidget* base,
                                                    GdkEventButton* event);
static void plank_dock_window_set_ClickedItem (PlankDockWindow* self,
                                        PlankDockItem* value);
static gboolean plank_dock_window_show_menu (PlankDockWindow* self,
                                      PlankDockItem* item,
                                      GdkEventButton* event);
static gboolean __lambda57_ (PlankDockWindow* self);
static gboolean ___lambda57__gsource_func (gpointer self);
static gboolean plank_dock_window_real_button_release_event (GtkWidget* base,
                                                      GdkEventButton* event);
static PlankDockItem* plank_dock_window_get_ClickedItem (PlankDockWindow* self);
static gboolean plank_dock_window_real_enter_notify_event (GtkWidget* base,
                                                    GdkEventCrossing* event);
static gboolean plank_dock_window_real_leave_notify_event (GtkWidget* base,
                                                    GdkEventCrossing* event);
static void plank_dock_window_set_hovered_provider (PlankDockWindow* self,
                                             PlankDockItemProvider* provider);
static void plank_dock_window_set_hovered (PlankDockWindow* self,
                                    PlankDockItem* item);
static gboolean plank_dock_window_real_motion_notify_event (GtkWidget* base,
                                                     GdkEventMotion* event);
static void plank_dock_window_real_drag_begin (GtkWidget* base,
                                        GdkDragContext* context);
static gboolean plank_dock_window_real_scroll_event (GtkWidget* base,
                                              GdkEventScroll* event);
static gboolean plank_dock_window_real_configure_event (GtkWidget* base,
                                                 GdkEventConfigure* event);
static gboolean plank_dock_window_real_draw (GtkWidget* base,
                                      cairo_t* cr);
static void plank_dock_window_set_input_mask (PlankDockWindow* self);
static gboolean plank_dock_window_real_map_event (GtkWidget* base,
                                           GdkEventAny* event);
static void plank_dock_window_set_HoveredItemProvider (PlankDockWindow* self,
                                                PlankDockItemProvider* value);
static void plank_dock_window_set_HoveredItem (PlankDockWindow* self,
                                        PlankDockItem* value);
static gboolean __lambda44_ (PlankDockWindow* self);
static gboolean ___lambda44__gsource_func (gpointer self);
 G_GNUC_INTERNAL BamfApplication* plank_application_dock_item_get_App (PlankApplicationDockItem* self);
static GeeArrayList* plank_dock_window_get_dock_debug_menu_items (PlankDockController* controller);
static GeeArrayList* plank_dock_window_get_item_debug_menu_items (PlankDockItem* item);
static void plank_dock_window_position_menu (GtkMenu* menu,
                                      gint* x,
                                      gint* y,
                                      gboolean* push_in,
                                      PlankDockWindow* self);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void __lambda52_ (Block19Data* _data19_);
static void ___lambda52__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda53_ (Block19Data* _data19_);
static void ___lambda53__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static void __lambda54_ (Block20Data* _data20_);
static void ___lambda54__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda55_ (Block20Data* _data20_);
static void ___lambda55__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda56_ (Block20Data* _data20_);
static void ___lambda56__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static gboolean _cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                                     const cairo_rectangle_int_t * s2);
static GObject * plank_dock_window_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void plank_dock_window_finalize (GObject * obj);
static GType plank_dock_window_get_type_once (void);
static void _vala_plank_dock_window_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_plank_dock_window_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
plank_dock_window_get_instance_private (PlankDockWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockWindow_private_offset);
}

static void
_plank_dock_window_on_menu_show_gtk_widget_show (GtkWidget* _sender,
                                                 gpointer self)
{
#line 109 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_on_menu_show ((PlankDockWindow*) self);
#line 212 "DockWindow.c"
}

static void
_plank_dock_window_on_menu_hide_gtk_widget_hide (GtkWidget* _sender,
                                                 gpointer self)
{
#line 110 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_on_menu_hide ((PlankDockWindow*) self);
#line 221 "DockWindow.c"
}

static void
_plank_dock_window_set_struts_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 113 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_struts ((PlankDockWindow*) self);
#line 231 "DockWindow.c"
}

/**
 * Creates a new dock window.
 */
static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 72 "../lib/Widgets/DockWindow.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 72 "../lib/Widgets/DockWindow.vala"
	return _data18_;
#line 244 "DockWindow.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 72 "../lib/Widgets/DockWindow.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 254 "DockWindow.c"
		PlankDockWindow* self;
#line 72 "../lib/Widgets/DockWindow.vala"
		self = _data18_->self;
#line 72 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (_data18_->gtk_settings);
#line 72 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (_data18_->granite_settings);
#line 72 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (self);
#line 72 "../lib/Widgets/DockWindow.vala"
		g_slice_free (Block18Data, _data18_);
#line 266 "DockWindow.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../lib/Widgets/DockWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 275 "DockWindow.c"
}

static void
__lambda51_ (Block18Data* _data18_)
{
	PlankDockWindow* self;
	GraniteSettingsColorScheme _tmp0_;
	GraniteSettingsColorScheme _tmp1_;
#line 81 "../lib/Widgets/DockWindow.vala"
	self = _data18_->self;
#line 82 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = granite_settings_get_prefers_color_scheme (_data18_->granite_settings);
#line 82 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = _tmp0_;
#line 82 "../lib/Widgets/DockWindow.vala"
	g_object_set (_data18_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp1_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 292 "DockWindow.c"
}

static void
___lambda51__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 81 "../lib/Widgets/DockWindow.vala"
	__lambda51_ (self);
#line 302 "DockWindow.c"
}

PlankDockWindow*
plank_dock_window_construct (GType object_type,
                             PlankDockController* controller)
{
	PlankDockWindow * self = NULL;
	Block18Data* _data18_;
	GraniteSettings* _tmp0_;
	GraniteSettings* _tmp1_;
	GtkSettings* _tmp2_;
	GtkSettings* _tmp3_;
	GraniteSettingsColorScheme _tmp4_;
	GraniteSettingsColorScheme _tmp5_;
#line 72 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 72 "../lib/Widgets/DockWindow.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 72 "../lib/Widgets/DockWindow.vala"
	_data18_->_ref_count_ = 1;
#line 74 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) g_object_new (object_type, "controller", controller, "type", GTK_WINDOW_TOPLEVEL, "type-hint", GDK_WINDOW_TYPE_HINT_DOCK, NULL);
#line 74 "../lib/Widgets/DockWindow.vala"
	_data18_->self = g_object_ref (self);
#line 76 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = granite_settings_get_default ();
#line 76 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 76 "../lib/Widgets/DockWindow.vala"
	_data18_->granite_settings = _tmp1_;
#line 77 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = gtk_settings_get_default ();
#line 77 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 77 "../lib/Widgets/DockWindow.vala"
	_data18_->gtk_settings = _tmp3_;
#line 79 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = granite_settings_get_prefers_color_scheme (_data18_->granite_settings);
#line 79 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = _tmp4_;
#line 79 "../lib/Widgets/DockWindow.vala"
	g_object_set (_data18_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp5_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 81 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_data ((GObject*) _data18_->granite_settings, "notify::prefers-color-scheme", (GCallback) ___lambda51__g_object_notify, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 72 "../lib/Widgets/DockWindow.vala"
	block18_data_unref (_data18_);
#line 72 "../lib/Widgets/DockWindow.vala"
	_data18_ = NULL;
#line 72 "../lib/Widgets/DockWindow.vala"
	return self;
#line 353 "DockWindow.c"
}

PlankDockWindow*
plank_dock_window_new (PlankDockController* controller)
{
#line 72 "../lib/Widgets/DockWindow.vala"
	return plank_dock_window_construct (PLANK_TYPE_DOCK_WINDOW, controller);
#line 361 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
__lambda57_ (PlankDockWindow* self)
{
	gboolean result;
#line 156 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_active = TRUE;
#line 157 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_timer_id = 0U;
#line 158 "../lib/Widgets/DockWindow.vala"
	result = FALSE;
#line 158 "../lib/Widgets/DockWindow.vala"
	return result;
#line 379 "DockWindow.c"
}

static gboolean
___lambda57__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda57_ ((PlankDockWindow*) self);
#line 155 "../lib/Widgets/DockWindow.vala"
	return result;
#line 389 "DockWindow.c"
}

static gboolean
plank_dock_window_real_button_press_event (GtkWidget* base,
                                           GdkEventButton* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	PlankDockController* _tmp5_;
	PlankDragManager* _tmp6_;
	PlankDragManager* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	PlankDockItem* _tmp10_;
	PlankDockItem* _tmp11_;
	PlankDockItem* _tmp12_;
	gboolean result;
#line 124 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 124 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 127 "../lib/Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 128 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 128 "../lib/Widgets/DockWindow.vala"
		return result;
#line 421 "DockWindow.c"
	}
#line 131 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 131 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 131 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 131 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 131 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 131 "../lib/Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 132 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 132 "../lib/Widgets/DockWindow.vala"
		return result;
#line 439 "DockWindow.c"
	}
#line 136 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 136 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_drag_manager (_tmp5_);
#line 136 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 136 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = plank_drag_manager_get_InternalDragActive (_tmp7_);
#line 136 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = _tmp8_;
#line 136 "../lib/Widgets/DockWindow.vala"
	if (_tmp9_) {
#line 137 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 137 "../lib/Widgets/DockWindow.vala"
		return result;
#line 457 "DockWindow.c"
	}
#line 142 "../lib/Widgets/DockWindow.vala"
	_tmp10_ = self->priv->_HoveredItem;
#line 142 "../lib/Widgets/DockWindow.vala"
	if (_tmp10_ == NULL) {
#line 143 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_update_hovered (self, (gint) event->x, (gint) event->y);
#line 465 "DockWindow.c"
	}
#line 145 "../lib/Widgets/DockWindow.vala"
	_tmp11_ = self->priv->_HoveredItem;
#line 145 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_ClickedItem (self, _tmp11_);
#line 148 "../lib/Widgets/DockWindow.vala"
	_tmp12_ = self->priv->_HoveredItem;
#line 148 "../lib/Widgets/DockWindow.vala"
	if (plank_dock_window_show_menu (self, _tmp12_, event)) {
#line 149 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 149 "../lib/Widgets/DockWindow.vala"
		return result;
#line 479 "DockWindow.c"
	}
#line 151 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_active = FALSE;
#line 152 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_button = event->button;
#line 153 "../lib/Widgets/DockWindow.vala"
	if (self->priv->long_press_timer_id > 0U) {
#line 154 "../lib/Widgets/DockWindow.vala"
		g_source_remove (self->priv->long_press_timer_id);
#line 489 "DockWindow.c"
	}
#line 155 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_timer_id = gdk_threads_add_timeout (PLANK_DOCK_WINDOW_LONG_PRESS_TIME, ___lambda57__gsource_func, self);
#line 161 "../lib/Widgets/DockWindow.vala"
	result = GDK_EVENT_PROPAGATE;
#line 161 "../lib/Widgets/DockWindow.vala"
	return result;
#line 497 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_button_release_event (GtkWidget* base,
                                             GdkEventButton* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	PlankDockController* _tmp6_;
	PlankDragManager* _tmp7_;
	PlankDragManager* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	PlankDockItem* _tmp13_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	PlankDockItem* _tmp18_;
	gboolean result;
#line 167 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 167 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 170 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 170 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 170 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 170 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 170 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 170 "../lib/Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 171 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 171 "../lib/Widgets/DockWindow.vala"
		return result;
#line 546 "DockWindow.c"
	}
#line 173 "../lib/Widgets/DockWindow.vala"
	if (self->priv->long_press_timer_id > 0U) {
#line 174 "../lib/Widgets/DockWindow.vala"
		g_source_remove (self->priv->long_press_timer_id);
#line 175 "../lib/Widgets/DockWindow.vala"
		self->priv->long_press_timer_id = 0U;
#line 554 "DockWindow.c"
	}
#line 178 "../lib/Widgets/DockWindow.vala"
	if (self->priv->long_press_active) {
#line 178 "../lib/Widgets/DockWindow.vala"
		_tmp5_ = self->priv->long_press_button == event->button;
#line 560 "DockWindow.c"
	} else {
#line 178 "../lib/Widgets/DockWindow.vala"
		_tmp5_ = FALSE;
#line 564 "DockWindow.c"
	}
#line 178 "../lib/Widgets/DockWindow.vala"
	if (_tmp5_) {
#line 179 "../lib/Widgets/DockWindow.vala"
		self->priv->long_press_active = FALSE;
#line 180 "../lib/Widgets/DockWindow.vala"
		self->priv->long_press_button = (guint) 0;
#line 181 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 181 "../lib/Widgets/DockWindow.vala"
		return result;
#line 576 "DockWindow.c"
	}
#line 184 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = self->priv->_controller;
#line 184 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = plank_dock_controller_get_drag_manager (_tmp6_);
#line 184 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = _tmp7_;
#line 184 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = plank_drag_manager_get_InternalDragActive (_tmp8_);
#line 184 "../lib/Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 184 "../lib/Widgets/DockWindow.vala"
	if (_tmp10_) {
#line 185 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 185 "../lib/Widgets/DockWindow.vala"
		return result;
#line 594 "DockWindow.c"
	}
#line 188 "../lib/Widgets/DockWindow.vala"
	_tmp13_ = self->priv->_HoveredItem;
#line 188 "../lib/Widgets/DockWindow.vala"
	if (_tmp13_ != NULL) {
#line 600 "DockWindow.c"
		PlankDockItem* _tmp14_;
#line 188 "../lib/Widgets/DockWindow.vala"
		_tmp14_ = self->priv->_ClickedItem;
#line 188 "../lib/Widgets/DockWindow.vala"
		_tmp12_ = _tmp14_ == NULL;
#line 606 "DockWindow.c"
	} else {
#line 188 "../lib/Widgets/DockWindow.vala"
		_tmp12_ = FALSE;
#line 610 "DockWindow.c"
	}
#line 188 "../lib/Widgets/DockWindow.vala"
	if (_tmp12_) {
#line 188 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = plank_dock_window_menu_is_visible (self);
#line 616 "DockWindow.c"
	} else {
#line 188 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = FALSE;
#line 620 "DockWindow.c"
	}
#line 188 "../lib/Widgets/DockWindow.vala"
	if (_tmp11_) {
#line 624 "DockWindow.c"
		GtkMenu* _tmp15_;
#line 189 "../lib/Widgets/DockWindow.vala"
		_tmp15_ = self->priv->menu;
#line 189 "../lib/Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp15_);
#line 630 "DockWindow.c"
	}
#line 192 "../lib/Widgets/DockWindow.vala"
	_tmp18_ = self->priv->_ClickedItem;
#line 192 "../lib/Widgets/DockWindow.vala"
	if (_tmp18_ != NULL) {
#line 636 "DockWindow.c"
		PlankDockItem* _tmp19_;
		PlankDockItem* _tmp20_;
#line 192 "../lib/Widgets/DockWindow.vala"
		_tmp19_ = self->priv->_HoveredItem;
#line 192 "../lib/Widgets/DockWindow.vala"
		_tmp20_ = self->priv->_ClickedItem;
#line 192 "../lib/Widgets/DockWindow.vala"
		_tmp17_ = _tmp19_ == _tmp20_;
#line 645 "DockWindow.c"
	} else {
#line 192 "../lib/Widgets/DockWindow.vala"
		_tmp17_ = FALSE;
#line 649 "DockWindow.c"
	}
#line 192 "../lib/Widgets/DockWindow.vala"
	if (_tmp17_) {
#line 192 "../lib/Widgets/DockWindow.vala"
		_tmp16_ = !plank_dock_window_menu_is_visible (self);
#line 655 "DockWindow.c"
	} else {
#line 192 "../lib/Widgets/DockWindow.vala"
		_tmp16_ = FALSE;
#line 659 "DockWindow.c"
	}
#line 192 "../lib/Widgets/DockWindow.vala"
	if (_tmp16_) {
#line 663 "DockWindow.c"
		PlankDockController* _tmp21_;
		PlankHoverWindow* _tmp22_;
		PlankHoverWindow* _tmp23_;
		PlankDockItem* _tmp24_;
#line 194 "../lib/Widgets/DockWindow.vala"
		_tmp21_ = self->priv->_controller;
#line 194 "../lib/Widgets/DockWindow.vala"
		_tmp22_ = plank_dock_controller_get_hover (_tmp21_);
#line 194 "../lib/Widgets/DockWindow.vala"
		_tmp23_ = _tmp22_;
#line 194 "../lib/Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 196 "../lib/Widgets/DockWindow.vala"
		_tmp24_ = self->priv->_HoveredItem;
#line 196 "../lib/Widgets/DockWindow.vala"
		plank_dock_element_clicked ((PlankDockElement*) _tmp24_, plank_popup_button_from_event_button (event), event->state, event->time);
#line 680 "DockWindow.c"
	}
#line 199 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_ClickedItem (self, NULL);
#line 201 "../lib/Widgets/DockWindow.vala"
	result = GDK_EVENT_PROPAGATE;
#line 201 "../lib/Widgets/DockWindow.vala"
	return result;
#line 688 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_enter_notify_event (GtkWidget* base,
                                           GdkEventCrossing* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	gboolean result;
#line 207 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 207 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 209 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 209 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 209 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 209 "../lib/Widgets/DockWindow.vala"
	plank_dock_renderer_update_local_cursor (_tmp2_, (gint) event->x, (gint) event->y);
#line 210 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_update_hovered (self, (gint) event->x, (gint) event->y);
#line 212 "../lib/Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 212 "../lib/Widgets/DockWindow.vala"
	return result;
#line 721 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_leave_notify_event (GtkWidget* base,
                                           GdkEventCrossing* event)
{
	PlankDockWindow * self;
	gboolean result;
#line 218 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 218 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 221 "../lib/Widgets/DockWindow.vala"
	if ((gboolean) event->send_event) {
#line 222 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 222 "../lib/Widgets/DockWindow.vala"
		return result;
#line 743 "DockWindow.c"
	}
#line 224 "../lib/Widgets/DockWindow.vala"
	if (!plank_dock_window_menu_is_visible (self)) {
#line 225 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 226 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 751 "DockWindow.c"
	} else {
		PlankDockController* _tmp0_;
		PlankHoverWindow* _tmp1_;
		PlankHoverWindow* _tmp2_;
#line 228 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = self->priv->_controller;
#line 228 "../lib/Widgets/DockWindow.vala"
		_tmp1_ = plank_dock_controller_get_hover (_tmp0_);
#line 228 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = _tmp1_;
#line 228 "../lib/Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 764 "DockWindow.c"
	}
#line 230 "../lib/Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 230 "../lib/Widgets/DockWindow.vala"
	return result;
#line 770 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_motion_notify_event (GtkWidget* base,
                                            GdkEventMotion* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	gboolean result;
#line 236 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 236 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 239 "../lib/Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 240 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 240 "../lib/Widgets/DockWindow.vala"
		return result;
#line 795 "DockWindow.c"
	}
#line 242 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 242 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 242 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 242 "../lib/Widgets/DockWindow.vala"
	plank_dock_renderer_update_local_cursor (_tmp2_, (gint) event->x, (gint) event->y);
#line 243 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_update_hovered (self, (gint) event->x, (gint) event->y);
#line 245 "../lib/Widgets/DockWindow.vala"
	result = GDK_EVENT_PROPAGATE;
#line 245 "../lib/Widgets/DockWindow.vala"
	return result;
#line 811 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_window_real_drag_begin (GtkWidget* base,
                                   GdkDragContext* context)
{
	PlankDockWindow * self;
#line 251 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 251 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (context != NULL);
#line 253 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_active = FALSE;
#line 254 "../lib/Widgets/DockWindow.vala"
	if (self->priv->long_press_timer_id > 0U) {
#line 255 "../lib/Widgets/DockWindow.vala"
		g_source_remove (self->priv->long_press_timer_id);
#line 256 "../lib/Widgets/DockWindow.vala"
		self->priv->long_press_timer_id = 0U;
#line 834 "DockWindow.c"
	}
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_scroll_event (GtkWidget* base,
                                     GdkEventScroll* event)
{
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	PlankDockController* _tmp5_;
	PlankDragManager* _tmp6_;
	PlankDragManager* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	PlankDockItem* _tmp16_;
	gboolean result;
#line 263 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 263 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 266 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 266 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 266 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 266 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 266 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 266 "../lib/Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 267 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 267 "../lib/Widgets/DockWindow.vala"
		return result;
#line 878 "DockWindow.c"
	}
#line 269 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 269 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_drag_manager (_tmp5_);
#line 269 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 269 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = plank_drag_manager_get_InternalDragActive (_tmp7_);
#line 269 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = _tmp8_;
#line 269 "../lib/Widgets/DockWindow.vala"
	if (_tmp9_) {
#line 270 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 270 "../lib/Widgets/DockWindow.vala"
		return result;
#line 896 "DockWindow.c"
	}
#line 273 "../lib/Widgets/DockWindow.vala"
	if (event->direction >= 4) {
#line 274 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 274 "../lib/Widgets/DockWindow.vala"
		return result;
#line 904 "DockWindow.c"
	}
#line 276 "../lib/Widgets/DockWindow.vala"
	if ((event->state & GDK_CONTROL_MASK) != 0) {
#line 277 "../lib/Widgets/DockWindow.vala"
		if (event->direction == GDK_SCROLL_UP) {
#line 910 "DockWindow.c"
			PlankDockController* _tmp10_;
			PlankDockPreferences* _tmp11_;
			PlankDockPreferences* _tmp12_;
#line 278 "../lib/Widgets/DockWindow.vala"
			_tmp10_ = self->priv->_controller;
#line 278 "../lib/Widgets/DockWindow.vala"
			_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 278 "../lib/Widgets/DockWindow.vala"
			_tmp12_ = _tmp11_;
#line 278 "../lib/Widgets/DockWindow.vala"
			plank_dock_preferences_increase_icon_size (_tmp12_);
#line 922 "DockWindow.c"
		} else {
#line 279 "../lib/Widgets/DockWindow.vala"
			if (event->direction == GDK_SCROLL_DOWN) {
#line 926 "DockWindow.c"
				PlankDockController* _tmp13_;
				PlankDockPreferences* _tmp14_;
				PlankDockPreferences* _tmp15_;
#line 280 "../lib/Widgets/DockWindow.vala"
				_tmp13_ = self->priv->_controller;
#line 280 "../lib/Widgets/DockWindow.vala"
				_tmp14_ = plank_dock_controller_get_prefs (_tmp13_);
#line 280 "../lib/Widgets/DockWindow.vala"
				_tmp15_ = _tmp14_;
#line 280 "../lib/Widgets/DockWindow.vala"
				plank_dock_preferences_decrease_icon_size (_tmp15_);
#line 938 "DockWindow.c"
			}
		}
#line 282 "../lib/Widgets/DockWindow.vala"
		result = GDK_EVENT_STOP;
#line 282 "../lib/Widgets/DockWindow.vala"
		return result;
#line 945 "DockWindow.c"
	}
#line 285 "../lib/Widgets/DockWindow.vala"
	_tmp16_ = self->priv->_HoveredItem;
#line 285 "../lib/Widgets/DockWindow.vala"
	if (_tmp16_ != NULL) {
#line 951 "DockWindow.c"
		PlankDockController* _tmp17_;
		PlankHoverWindow* _tmp18_;
		PlankHoverWindow* _tmp19_;
		PlankDockItem* _tmp20_;
		PlankDockController* _tmp21_;
		PlankDockRenderer* _tmp22_;
		PlankDockRenderer* _tmp23_;
#line 287 "../lib/Widgets/DockWindow.vala"
		_tmp17_ = self->priv->_controller;
#line 287 "../lib/Widgets/DockWindow.vala"
		_tmp18_ = plank_dock_controller_get_hover (_tmp17_);
#line 287 "../lib/Widgets/DockWindow.vala"
		_tmp19_ = _tmp18_;
#line 287 "../lib/Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp19_);
#line 289 "../lib/Widgets/DockWindow.vala"
		_tmp20_ = self->priv->_HoveredItem;
#line 289 "../lib/Widgets/DockWindow.vala"
		plank_dock_element_scrolled ((PlankDockElement*) _tmp20_, event->direction, event->state, event->time);
#line 290 "../lib/Widgets/DockWindow.vala"
		_tmp21_ = self->priv->_controller;
#line 290 "../lib/Widgets/DockWindow.vala"
		_tmp22_ = plank_dock_controller_get_renderer (_tmp21_);
#line 290 "../lib/Widgets/DockWindow.vala"
		_tmp23_ = _tmp22_;
#line 290 "../lib/Widgets/DockWindow.vala"
		plank_renderer_animated_draw ((PlankRenderer*) _tmp23_);
#line 979 "DockWindow.c"
	}
#line 293 "../lib/Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 293 "../lib/Widgets/DockWindow.vala"
	return result;
#line 985 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_configure_event (GtkWidget* base,
                                        GdkEventConfigure* event)
{
	PlankDockWindow * self;
	GdkRectangle win_rect = {0};
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	GdkRectangle _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	GdkRectangle _tmp7_;
	gboolean needs_update = FALSE;
	gboolean result;
#line 299 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 299 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 301 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 301 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 301 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 301 "../lib/Widgets/DockWindow.vala"
	plank_position_manager_get_dock_window_region (_tmp2_, &_tmp3_);
#line 301 "../lib/Widgets/DockWindow.vala"
	win_rect = _tmp3_;
#line 302 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = win_rect;
#line 302 "../lib/Widgets/DockWindow.vala"
	if (_tmp7_.width != event->width) {
#line 302 "../lib/Widgets/DockWindow.vala"
		_tmp6_ = TRUE;
#line 1027 "DockWindow.c"
	} else {
		GdkRectangle _tmp8_;
#line 302 "../lib/Widgets/DockWindow.vala"
		_tmp8_ = win_rect;
#line 302 "../lib/Widgets/DockWindow.vala"
		_tmp6_ = _tmp8_.height != event->height;
#line 1034 "DockWindow.c"
	}
#line 302 "../lib/Widgets/DockWindow.vala"
	if (_tmp6_) {
#line 302 "../lib/Widgets/DockWindow.vala"
		_tmp5_ = TRUE;
#line 1040 "DockWindow.c"
	} else {
		GdkRectangle _tmp9_;
#line 303 "../lib/Widgets/DockWindow.vala"
		_tmp9_ = win_rect;
#line 303 "../lib/Widgets/DockWindow.vala"
		_tmp5_ = _tmp9_.x != event->x;
#line 1047 "DockWindow.c"
	}
#line 302 "../lib/Widgets/DockWindow.vala"
	if (_tmp5_) {
#line 302 "../lib/Widgets/DockWindow.vala"
		_tmp4_ = TRUE;
#line 1053 "DockWindow.c"
	} else {
		GdkRectangle _tmp10_;
#line 303 "../lib/Widgets/DockWindow.vala"
		_tmp10_ = win_rect;
#line 303 "../lib/Widgets/DockWindow.vala"
		_tmp4_ = _tmp10_.y != event->y;
#line 1060 "DockWindow.c"
	}
#line 302 "../lib/Widgets/DockWindow.vala"
	needs_update = _tmp4_;
#line 305 "../lib/Widgets/DockWindow.vala"
	if (needs_update) {
#line 1066 "DockWindow.c"
		gint _tmp11_;
#line 306 "../lib/Widgets/DockWindow.vala"
		self->priv->window_position_retry = self->priv->window_position_retry + 1;
#line 306 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = self->priv->window_position_retry;
#line 306 "../lib/Widgets/DockWindow.vala"
		if (_tmp11_ < 3) {
#line 307 "../lib/Widgets/DockWindow.vala"
			g_critical ("DockWindow.vala:307: Retry #%i update_size_and_position() to force req" \
"uested values!", self->priv->window_position_retry);
#line 308 "../lib/Widgets/DockWindow.vala"
			plank_dock_window_update_size_and_position (self);
#line 1078 "DockWindow.c"
		}
	} else {
#line 311 "../lib/Widgets/DockWindow.vala"
		self->priv->window_position_retry = 0;
#line 1083 "DockWindow.c"
	}
#line 314 "../lib/Widgets/DockWindow.vala"
	result = GTK_WIDGET_CLASS (plank_dock_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_COMPOSITED_WINDOW, PlankCompositedWindow), event);
#line 314 "../lib/Widgets/DockWindow.vala"
	return result;
#line 1089 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_draw (GtkWidget* base,
                             cairo_t* cr)
{
	PlankDockWindow * self;
	gboolean result;
#line 320 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 320 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 322 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_input_mask (self);
#line 324 "../lib/Widgets/DockWindow.vala"
	result = GDK_EVENT_STOP;
#line 324 "../lib/Widgets/DockWindow.vala"
	return result;
#line 1111 "DockWindow.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_window_real_map_event (GtkWidget* base,
                                  GdkEventAny* event)
{
	PlankDockWindow * self;
	gboolean result;
#line 330 "../lib/Widgets/DockWindow.vala"
	self = (PlankDockWindow*) base;
#line 330 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 332 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_struts (self);
#line 334 "../lib/Widgets/DockWindow.vala"
	result = GTK_WIDGET_CLASS (plank_dock_window_parent_class)->map_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_COMPOSITED_WINDOW, PlankCompositedWindow), event);
#line 334 "../lib/Widgets/DockWindow.vala"
	return result;
#line 1133 "DockWindow.c"
}

/**
 * Sets the currently hovered item-provider for this dock.
 *
 * @param provider the hovered item-provider (if any) for this dock
 */
static void
plank_dock_window_set_hovered_provider (PlankDockWindow* self,
                                        PlankDockItemProvider* provider)
{
	PlankDockItemProvider* _tmp0_;
#line 342 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 344 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItemProvider;
#line 344 "../lib/Widgets/DockWindow.vala"
	if (_tmp0_ == provider) {
#line 345 "../lib/Widgets/DockWindow.vala"
		return;
#line 1154 "DockWindow.c"
	}
#line 347 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_HoveredItemProvider (self, provider);
#line 1158 "DockWindow.c"
}

/**
 * Sets the currently hovered item for this dock.
 *
 * @param item the hovered item (if any) for this dock
 */
static gboolean
__lambda44_ (PlankDockWindow* self)
{
	PlankDockItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PlankDockController* _tmp2_;
	PlankHideManager* _tmp3_;
	PlankHideManager* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	PlankHoverWindow* hover = NULL;
	PlankDockController* _tmp12_;
	PlankHoverWindow* _tmp13_;
	PlankHoverWindow* _tmp14_;
	gint x = 0;
	gint y = 0;
	PlankHoverWindow* _tmp15_;
	PlankDockItem* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	PlankDockController* _tmp19_;
	PlankPositionManager* _tmp20_;
	PlankPositionManager* _tmp21_;
	PlankDockItem* _tmp22_;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	PlankHoverWindow* _tmp25_;
	PlankDockController* _tmp26_;
	PlankPositionManager* _tmp27_;
	PlankPositionManager* _tmp28_;
	GtkPositionType _tmp29_;
	GtkPositionType _tmp30_;
	gboolean result;
#line 386 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItem;
#line 386 "../lib/Widgets/DockWindow.vala"
	if (_tmp0_ == NULL) {
#line 387 "../lib/Widgets/DockWindow.vala"
		self->priv->hover_reposition_timer_id = 0U;
#line 388 "../lib/Widgets/DockWindow.vala"
		result = FALSE;
#line 388 "../lib/Widgets/DockWindow.vala"
		return result;
#line 1209 "DockWindow.c"
	}
#line 392 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = self->priv->_controller;
#line 392 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = plank_dock_controller_get_hide_manager (_tmp2_);
#line 392 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 392 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = plank_hide_manager_get_Hidden (_tmp4_);
#line 392 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = _tmp5_;
#line 392 "../lib/Widgets/DockWindow.vala"
	if (!_tmp6_) {
#line 1223 "DockWindow.c"
		PlankDockController* _tmp7_;
		PlankDockRenderer* _tmp8_;
		PlankDockRenderer* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 393 "../lib/Widgets/DockWindow.vala"
		_tmp7_ = self->priv->_controller;
#line 393 "../lib/Widgets/DockWindow.vala"
		_tmp8_ = plank_dock_controller_get_renderer (_tmp7_);
#line 393 "../lib/Widgets/DockWindow.vala"
		_tmp9_ = _tmp8_;
#line 393 "../lib/Widgets/DockWindow.vala"
		_tmp10_ = plank_dock_renderer_get_hide_progress (_tmp9_);
#line 393 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = _tmp10_;
#line 393 "../lib/Widgets/DockWindow.vala"
		_tmp1_ = _tmp11_ > 0.0;
#line 1241 "DockWindow.c"
	} else {
#line 392 "../lib/Widgets/DockWindow.vala"
		_tmp1_ = FALSE;
#line 1245 "DockWindow.c"
	}
#line 392 "../lib/Widgets/DockWindow.vala"
	if (_tmp1_) {
#line 394 "../lib/Widgets/DockWindow.vala"
		result = TRUE;
#line 394 "../lib/Widgets/DockWindow.vala"
		return result;
#line 1253 "DockWindow.c"
	}
#line 396 "../lib/Widgets/DockWindow.vala"
	self->priv->hover_reposition_timer_id = 0U;
#line 397 "../lib/Widgets/DockWindow.vala"
	_tmp12_ = self->priv->_controller;
#line 397 "../lib/Widgets/DockWindow.vala"
	_tmp13_ = plank_dock_controller_get_hover (_tmp12_);
#line 397 "../lib/Widgets/DockWindow.vala"
	_tmp14_ = _tmp13_;
#line 397 "../lib/Widgets/DockWindow.vala"
	hover = _tmp14_;
#line 400 "../lib/Widgets/DockWindow.vala"
	_tmp15_ = hover;
#line 400 "../lib/Widgets/DockWindow.vala"
	_tmp16_ = self->priv->_HoveredItem;
#line 400 "../lib/Widgets/DockWindow.vala"
	_tmp17_ = plank_dock_element_get_Text ((PlankDockElement*) _tmp16_);
#line 400 "../lib/Widgets/DockWindow.vala"
	_tmp18_ = _tmp17_;
#line 400 "../lib/Widgets/DockWindow.vala"
	plank_hover_window_set_text (_tmp15_, _tmp18_);
#line 401 "../lib/Widgets/DockWindow.vala"
	_tmp19_ = self->priv->_controller;
#line 401 "../lib/Widgets/DockWindow.vala"
	_tmp20_ = plank_dock_controller_get_position_manager (_tmp19_);
#line 401 "../lib/Widgets/DockWindow.vala"
	_tmp21_ = _tmp20_;
#line 401 "../lib/Widgets/DockWindow.vala"
	_tmp22_ = self->priv->_HoveredItem;
#line 401 "../lib/Widgets/DockWindow.vala"
	plank_position_manager_get_hover_position (_tmp21_, _tmp22_, &_tmp23_, &_tmp24_);
#line 401 "../lib/Widgets/DockWindow.vala"
	x = _tmp23_;
#line 401 "../lib/Widgets/DockWindow.vala"
	y = _tmp24_;
#line 402 "../lib/Widgets/DockWindow.vala"
	_tmp25_ = hover;
#line 402 "../lib/Widgets/DockWindow.vala"
	_tmp26_ = self->priv->_controller;
#line 402 "../lib/Widgets/DockWindow.vala"
	_tmp27_ = plank_dock_controller_get_position_manager (_tmp26_);
#line 402 "../lib/Widgets/DockWindow.vala"
	_tmp28_ = _tmp27_;
#line 402 "../lib/Widgets/DockWindow.vala"
	_tmp29_ = plank_position_manager_get_Position (_tmp28_);
#line 402 "../lib/Widgets/DockWindow.vala"
	_tmp30_ = _tmp29_;
#line 402 "../lib/Widgets/DockWindow.vala"
	plank_hover_window_show_at (_tmp25_, x, y, _tmp30_);
#line 404 "../lib/Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 1305 "DockWindow.c"
		PlankHoverWindow* _tmp31_;
#line 405 "../lib/Widgets/DockWindow.vala"
		_tmp31_ = hover;
#line 405 "../lib/Widgets/DockWindow.vala"
		gtk_widget_hide ((GtkWidget*) _tmp31_);
#line 1311 "DockWindow.c"
	}
#line 407 "../lib/Widgets/DockWindow.vala"
	result = FALSE;
#line 407 "../lib/Widgets/DockWindow.vala"
	return result;
#line 1317 "DockWindow.c"
}

static gboolean
___lambda44__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda44_ ((PlankDockWindow*) self);
#line 385 "../lib/Widgets/DockWindow.vala"
	return result;
#line 1327 "DockWindow.c"
}

static void
plank_dock_window_set_hovered (PlankDockWindow* self,
                               PlankDockItem* item)
{
	PlankDockItem* _tmp0_;
	PlankDockItem* _tmp1_;
	PlankDockController* _tmp3_;
	PlankDragManager* _tmp4_;
	PlankDragManager* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	PlankDockController* _tmp8_;
	PlankHoverWindow* _tmp9_;
	PlankHoverWindow* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	PlankDockItem* _tmp13_;
#line 355 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 357 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItem;
#line 357 "../lib/Widgets/DockWindow.vala"
	if (_tmp0_ == item) {
#line 358 "../lib/Widgets/DockWindow.vala"
		return;
#line 1355 "DockWindow.c"
	}
#line 360 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = self->priv->_HoveredItem;
#line 360 "../lib/Widgets/DockWindow.vala"
	if (_tmp1_ != NULL) {
#line 1361 "DockWindow.c"
		PlankDockItem* _tmp2_;
#line 361 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = self->priv->_HoveredItem;
#line 361 "../lib/Widgets/DockWindow.vala"
		plank_dock_element_hovered ((PlankDockElement*) _tmp2_);
#line 1367 "DockWindow.c"
	}
#line 363 "../lib/Widgets/DockWindow.vala"
	if (item != NULL) {
#line 364 "../lib/Widgets/DockWindow.vala"
		plank_dock_element_hovered ((PlankDockElement*) item);
#line 1373 "DockWindow.c"
	}
#line 366 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_HoveredItem (self, item);
#line 369 "../lib/Widgets/DockWindow.vala"
	if (self->priv->hover_reposition_timer_id > 0U) {
#line 370 "../lib/Widgets/DockWindow.vala"
		g_source_remove (self->priv->hover_reposition_timer_id);
#line 371 "../lib/Widgets/DockWindow.vala"
		self->priv->hover_reposition_timer_id = 0U;
#line 1383 "DockWindow.c"
	}
#line 374 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = self->priv->_controller;
#line 374 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = plank_dock_controller_get_drag_manager (_tmp3_);
#line 374 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = _tmp4_;
#line 374 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = plank_drag_manager_get_ExternalDragActive (_tmp5_);
#line 374 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 374 "../lib/Widgets/DockWindow.vala"
	if (_tmp7_) {
#line 375 "../lib/Widgets/DockWindow.vala"
		return;
#line 1399 "DockWindow.c"
	}
#line 377 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = self->priv->_controller;
#line 377 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_controller_get_hover (_tmp8_);
#line 377 "../lib/Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 377 "../lib/Widgets/DockWindow.vala"
	gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 379 "../lib/Widgets/DockWindow.vala"
	_tmp13_ = self->priv->_HoveredItem;
#line 379 "../lib/Widgets/DockWindow.vala"
	if (_tmp13_ == NULL) {
#line 379 "../lib/Widgets/DockWindow.vala"
		_tmp12_ = TRUE;
#line 1415 "DockWindow.c"
	} else {
		PlankDockController* _tmp14_;
		PlankDockPreferences* _tmp15_;
		PlankDockPreferences* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 380 "../lib/Widgets/DockWindow.vala"
		_tmp14_ = self->priv->_controller;
#line 380 "../lib/Widgets/DockWindow.vala"
		_tmp15_ = plank_dock_controller_get_prefs (_tmp14_);
#line 380 "../lib/Widgets/DockWindow.vala"
		_tmp16_ = _tmp15_;
#line 380 "../lib/Widgets/DockWindow.vala"
		_tmp17_ = plank_dock_preferences_get_TooltipsEnabled (_tmp16_);
#line 380 "../lib/Widgets/DockWindow.vala"
		_tmp18_ = _tmp17_;
#line 380 "../lib/Widgets/DockWindow.vala"
		_tmp12_ = !_tmp18_;
#line 1434 "DockWindow.c"
	}
#line 379 "../lib/Widgets/DockWindow.vala"
	if (_tmp12_) {
#line 379 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = TRUE;
#line 1440 "DockWindow.c"
	} else {
		PlankDockController* _tmp19_;
		PlankDragManager* _tmp20_;
		PlankDragManager* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
#line 381 "../lib/Widgets/DockWindow.vala"
		_tmp19_ = self->priv->_controller;
#line 381 "../lib/Widgets/DockWindow.vala"
		_tmp20_ = plank_dock_controller_get_drag_manager (_tmp19_);
#line 381 "../lib/Widgets/DockWindow.vala"
		_tmp21_ = _tmp20_;
#line 381 "../lib/Widgets/DockWindow.vala"
		_tmp22_ = plank_drag_manager_get_InternalDragActive (_tmp21_);
#line 381 "../lib/Widgets/DockWindow.vala"
		_tmp23_ = _tmp22_;
#line 381 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = _tmp23_;
#line 1459 "DockWindow.c"
	}
#line 379 "../lib/Widgets/DockWindow.vala"
	if (_tmp11_) {
#line 382 "../lib/Widgets/DockWindow.vala"
		return;
#line 1465 "DockWindow.c"
	}
#line 385 "../lib/Widgets/DockWindow.vala"
	self->priv->hover_reposition_timer_id = gdk_threads_add_timeout (PLANK_DOCK_WINDOW_HOVER_DELAY_TIME, ___lambda44__gsource_func, self);
#line 1469 "DockWindow.c"
}

/**
 * Determines if an item is hovered by the cursor at the x/y position.
 *
 * @param x the cursor x position
 * @param y the cursor x position
 * @return if a dock item is hovered
 */
gboolean
plank_dock_window_update_hovered (PlankDockWindow* self,
                                  gint x,
                                  gint y)
{
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp5_;
	PlankPositionManager* _tmp6_;
	PlankPositionManager* _tmp7_;
	PlankDockItem* drag_item = NULL;
	PlankDockController* _tmp8_;
	PlankDragManager* _tmp9_;
	PlankDragManager* _tmp10_;
	PlankDockItem* _tmp11_;
	PlankDockItem* _tmp12_;
	GdkRectangle rect = {0};
	PlankDockItem* _tmp13_;
	PlankPositionManager* _tmp31_;
	GdkRectangle _tmp32_ = {0};
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GdkRectangle _tmp36_;
	gboolean found_hovered_provider = FALSE;
	PlankDockItem* item = NULL;
	PlankDockItemProvider* provider = NULL;
	gboolean result;
#line 418 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 421 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 421 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 421 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 421 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = plank_hide_manager_get_Hidden (_tmp2_);
#line 421 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 421 "../lib/Widgets/DockWindow.vala"
	if (_tmp4_) {
#line 422 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 423 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 424 "../lib/Widgets/DockWindow.vala"
		result = FALSE;
#line 424 "../lib/Widgets/DockWindow.vala"
		return result;
#line 1533 "DockWindow.c"
	}
#line 427 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 427 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_position_manager (_tmp5_);
#line 427 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 427 "../lib/Widgets/DockWindow.vala"
	position_manager = _tmp7_;
#line 428 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = self->priv->_controller;
#line 428 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_controller_get_drag_manager (_tmp8_);
#line 428 "../lib/Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 428 "../lib/Widgets/DockWindow.vala"
	_tmp11_ = plank_drag_manager_get_DragItem (_tmp10_);
#line 428 "../lib/Widgets/DockWindow.vala"
	_tmp12_ = _tmp11_;
#line 428 "../lib/Widgets/DockWindow.vala"
	drag_item = _tmp12_;
#line 432 "../lib/Widgets/DockWindow.vala"
	_tmp13_ = self->priv->_HoveredItem;
#line 432 "../lib/Widgets/DockWindow.vala"
	if (_tmp13_ != NULL) {
#line 1559 "DockWindow.c"
		PlankPositionManager* _tmp14_;
		PlankDockItem* _tmp15_;
		GdkRectangle _tmp16_ = {0};
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		GdkRectangle _tmp20_;
#line 433 "../lib/Widgets/DockWindow.vala"
		_tmp14_ = position_manager;
#line 433 "../lib/Widgets/DockWindow.vala"
		_tmp15_ = self->priv->_HoveredItem;
#line 433 "../lib/Widgets/DockWindow.vala"
		plank_position_manager_get_hover_region_for_element (_tmp14_, (PlankDockElement*) _tmp15_, &_tmp16_);
#line 433 "../lib/Widgets/DockWindow.vala"
		rect = _tmp16_;
#line 434 "../lib/Widgets/DockWindow.vala"
		_tmp20_ = rect;
#line 434 "../lib/Widgets/DockWindow.vala"
		if (y >= _tmp20_.y) {
#line 1579 "DockWindow.c"
			GdkRectangle _tmp21_;
			GdkRectangle _tmp22_;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp21_ = rect;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp22_ = rect;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp19_ = y < (_tmp21_.y + _tmp22_.height);
#line 1588 "DockWindow.c"
		} else {
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp19_ = FALSE;
#line 1592 "DockWindow.c"
		}
#line 434 "../lib/Widgets/DockWindow.vala"
		if (_tmp19_) {
#line 1596 "DockWindow.c"
			GdkRectangle _tmp23_;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp23_ = rect;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp18_ = x >= _tmp23_.x;
#line 1602 "DockWindow.c"
		} else {
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp18_ = FALSE;
#line 1606 "DockWindow.c"
		}
#line 434 "../lib/Widgets/DockWindow.vala"
		if (_tmp18_) {
#line 1610 "DockWindow.c"
			GdkRectangle _tmp24_;
			GdkRectangle _tmp25_;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp24_ = rect;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp25_ = rect;
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp17_ = x < (_tmp24_.x + _tmp25_.width);
#line 1619 "DockWindow.c"
		} else {
#line 434 "../lib/Widgets/DockWindow.vala"
			_tmp17_ = FALSE;
#line 1623 "DockWindow.c"
		}
#line 434 "../lib/Widgets/DockWindow.vala"
		if (_tmp17_) {
#line 1627 "DockWindow.c"
			PlankDockItem* _tmp26_;
			PlankDockItem* _tmp27_;
#line 436 "../lib/Widgets/DockWindow.vala"
			_tmp26_ = drag_item;
#line 436 "../lib/Widgets/DockWindow.vala"
			_tmp27_ = self->priv->_HoveredItem;
#line 436 "../lib/Widgets/DockWindow.vala"
			if (_tmp26_ == _tmp27_) {
#line 1636 "DockWindow.c"
				PlankDockItem* _tmp28_;
				PlankDockContainer* _tmp29_;
				PlankDockContainer* _tmp30_;
#line 437 "../lib/Widgets/DockWindow.vala"
				_tmp28_ = self->priv->_HoveredItem;
#line 437 "../lib/Widgets/DockWindow.vala"
				_tmp29_ = plank_dock_element_get_Container ((PlankDockElement*) _tmp28_);
#line 437 "../lib/Widgets/DockWindow.vala"
				_tmp30_ = _tmp29_;
#line 437 "../lib/Widgets/DockWindow.vala"
				plank_dock_window_set_hovered_provider (self, PLANK_IS_DOCK_ITEM_PROVIDER (_tmp30_) ? ((PlankDockItemProvider*) _tmp30_) : NULL);
#line 438 "../lib/Widgets/DockWindow.vala"
				plank_dock_window_set_hovered (self, NULL);
#line 439 "../lib/Widgets/DockWindow.vala"
				result = FALSE;
#line 439 "../lib/Widgets/DockWindow.vala"
				return result;
#line 1654 "DockWindow.c"
			} else {
#line 442 "../lib/Widgets/DockWindow.vala"
				result = TRUE;
#line 442 "../lib/Widgets/DockWindow.vala"
				return result;
#line 1660 "DockWindow.c"
			}
		}
	}
#line 446 "../lib/Widgets/DockWindow.vala"
	_tmp31_ = position_manager;
#line 446 "../lib/Widgets/DockWindow.vala"
	plank_position_manager_get_cursor_region (_tmp31_, &_tmp32_);
#line 446 "../lib/Widgets/DockWindow.vala"
	rect = _tmp32_;
#line 447 "../lib/Widgets/DockWindow.vala"
	_tmp36_ = rect;
#line 447 "../lib/Widgets/DockWindow.vala"
	if (y < _tmp36_.y) {
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp35_ = TRUE;
#line 1676 "DockWindow.c"
	} else {
		GdkRectangle _tmp37_;
		GdkRectangle _tmp38_;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp37_ = rect;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp38_ = rect;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp35_ = y >= (_tmp37_.y + _tmp38_.height);
#line 1686 "DockWindow.c"
	}
#line 447 "../lib/Widgets/DockWindow.vala"
	if (_tmp35_) {
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp34_ = TRUE;
#line 1692 "DockWindow.c"
	} else {
		GdkRectangle _tmp39_;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp39_ = rect;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp34_ = x < _tmp39_.x;
#line 1699 "DockWindow.c"
	}
#line 447 "../lib/Widgets/DockWindow.vala"
	if (_tmp34_) {
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp33_ = TRUE;
#line 1705 "DockWindow.c"
	} else {
		GdkRectangle _tmp40_;
		GdkRectangle _tmp41_;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp40_ = rect;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp41_ = rect;
#line 447 "../lib/Widgets/DockWindow.vala"
		_tmp33_ = x >= (_tmp40_.x + _tmp41_.width);
#line 1715 "DockWindow.c"
	}
#line 447 "../lib/Widgets/DockWindow.vala"
	if (_tmp33_) {
#line 448 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 449 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 450 "../lib/Widgets/DockWindow.vala"
		result = FALSE;
#line 450 "../lib/Widgets/DockWindow.vala"
		return result;
#line 1727 "DockWindow.c"
	}
#line 453 "../lib/Widgets/DockWindow.vala"
	found_hovered_provider = FALSE;
#line 454 "../lib/Widgets/DockWindow.vala"
	item = NULL;
#line 455 "../lib/Widgets/DockWindow.vala"
	provider = NULL;
#line 1735 "DockWindow.c"
	{
		GeeArrayList* _element_list = NULL;
		PlankDockController* _tmp42_;
		GeeArrayList* _tmp43_;
		GeeArrayList* _tmp44_;
		gint _element_size = 0;
		GeeArrayList* _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _element_index = 0;
#line 457 "../lib/Widgets/DockWindow.vala"
		_tmp42_ = self->priv->_controller;
#line 457 "../lib/Widgets/DockWindow.vala"
		_tmp43_ = plank_dock_container_get_VisibleElements ((PlankDockContainer*) _tmp42_);
#line 457 "../lib/Widgets/DockWindow.vala"
		_tmp44_ = _tmp43_;
#line 457 "../lib/Widgets/DockWindow.vala"
		_element_list = _tmp44_;
#line 457 "../lib/Widgets/DockWindow.vala"
		_tmp45_ = _element_list;
#line 457 "../lib/Widgets/DockWindow.vala"
		_tmp46_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp45_);
#line 457 "../lib/Widgets/DockWindow.vala"
		_tmp47_ = _tmp46_;
#line 457 "../lib/Widgets/DockWindow.vala"
		_element_size = _tmp47_;
#line 457 "../lib/Widgets/DockWindow.vala"
		_element_index = -1;
#line 457 "../lib/Widgets/DockWindow.vala"
		while (TRUE) {
#line 1766 "DockWindow.c"
			gint _tmp48_;
			gint _tmp49_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp50_;
			gpointer _tmp51_;
			PlankDockElement* _tmp52_;
			PlankDockItem* _tmp53_;
			PlankDockElement* _tmp69_;
			PlankDockItemProvider* _tmp70_;
			PlankPositionManager* _tmp71_;
			PlankDockItemProvider* _tmp72_;
			GdkRectangle _tmp73_ = {0};
			gboolean _tmp74_ = FALSE;
			gboolean _tmp75_ = FALSE;
			gboolean _tmp76_ = FALSE;
			GdkRectangle _tmp77_;
			PlankDockItemProvider* _tmp83_;
#line 457 "../lib/Widgets/DockWindow.vala"
			_element_index = _element_index + 1;
#line 457 "../lib/Widgets/DockWindow.vala"
			_tmp48_ = _element_index;
#line 457 "../lib/Widgets/DockWindow.vala"
			_tmp49_ = _element_size;
#line 457 "../lib/Widgets/DockWindow.vala"
			if (!(_tmp48_ < _tmp49_)) {
#line 457 "../lib/Widgets/DockWindow.vala"
				break;
#line 1794 "DockWindow.c"
			}
#line 457 "../lib/Widgets/DockWindow.vala"
			_tmp50_ = _element_list;
#line 457 "../lib/Widgets/DockWindow.vala"
			_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp50_, _element_index);
#line 457 "../lib/Widgets/DockWindow.vala"
			element = (PlankDockElement*) _tmp51_;
#line 458 "../lib/Widgets/DockWindow.vala"
			_tmp52_ = element;
#line 458 "../lib/Widgets/DockWindow.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp52_) ? ((PlankDockItem*) _tmp52_) : NULL;
#line 459 "../lib/Widgets/DockWindow.vala"
			_tmp53_ = item;
#line 459 "../lib/Widgets/DockWindow.vala"
			if (_tmp53_ != NULL) {
#line 1810 "DockWindow.c"
				PlankPositionManager* _tmp54_;
				PlankDockItem* _tmp55_;
				GdkRectangle _tmp56_ = {0};
				gboolean _tmp57_ = FALSE;
				gboolean _tmp58_ = FALSE;
				gboolean _tmp59_ = FALSE;
				GdkRectangle _tmp60_;
				PlankDockItem* _tmp66_;
				PlankDockItem* _tmp67_;
				PlankDockItem* _tmp68_;
#line 460 "../lib/Widgets/DockWindow.vala"
				_tmp54_ = position_manager;
#line 460 "../lib/Widgets/DockWindow.vala"
				_tmp55_ = item;
#line 460 "../lib/Widgets/DockWindow.vala"
				plank_position_manager_get_hover_region_for_element (_tmp54_, (PlankDockElement*) _tmp55_, &_tmp56_);
#line 460 "../lib/Widgets/DockWindow.vala"
				rect = _tmp56_;
#line 461 "../lib/Widgets/DockWindow.vala"
				_tmp60_ = rect;
#line 461 "../lib/Widgets/DockWindow.vala"
				if (y < _tmp60_.y) {
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp59_ = TRUE;
#line 1835 "DockWindow.c"
				} else {
					GdkRectangle _tmp61_;
					GdkRectangle _tmp62_;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp61_ = rect;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp62_ = rect;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp59_ = y >= (_tmp61_.y + _tmp62_.height);
#line 1845 "DockWindow.c"
				}
#line 461 "../lib/Widgets/DockWindow.vala"
				if (_tmp59_) {
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp58_ = TRUE;
#line 1851 "DockWindow.c"
				} else {
					GdkRectangle _tmp63_;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp63_ = rect;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp58_ = x < _tmp63_.x;
#line 1858 "DockWindow.c"
				}
#line 461 "../lib/Widgets/DockWindow.vala"
				if (_tmp58_) {
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp57_ = TRUE;
#line 1864 "DockWindow.c"
				} else {
					GdkRectangle _tmp64_;
					GdkRectangle _tmp65_;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp64_ = rect;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp65_ = rect;
#line 461 "../lib/Widgets/DockWindow.vala"
					_tmp57_ = x >= (_tmp64_.x + _tmp65_.width);
#line 1874 "DockWindow.c"
				}
#line 461 "../lib/Widgets/DockWindow.vala"
				if (_tmp57_) {
#line 462 "../lib/Widgets/DockWindow.vala"
					_g_object_unref0 (element);
#line 462 "../lib/Widgets/DockWindow.vala"
					continue;
#line 1882 "DockWindow.c"
				}
#line 465 "../lib/Widgets/DockWindow.vala"
				_tmp66_ = drag_item;
#line 465 "../lib/Widgets/DockWindow.vala"
				_tmp67_ = item;
#line 465 "../lib/Widgets/DockWindow.vala"
				if (_tmp66_ == _tmp67_) {
#line 466 "../lib/Widgets/DockWindow.vala"
					_g_object_unref0 (element);
#line 466 "../lib/Widgets/DockWindow.vala"
					break;
#line 1894 "DockWindow.c"
				}
#line 468 "../lib/Widgets/DockWindow.vala"
				plank_dock_window_set_hovered_provider (self, NULL);
#line 469 "../lib/Widgets/DockWindow.vala"
				_tmp68_ = item;
#line 469 "../lib/Widgets/DockWindow.vala"
				plank_dock_window_set_hovered (self, PLANK_IS_DOCK_ITEM (_tmp68_) ? ((PlankDockItem*) _tmp68_) : NULL);
#line 470 "../lib/Widgets/DockWindow.vala"
				result = TRUE;
#line 470 "../lib/Widgets/DockWindow.vala"
				_g_object_unref0 (element);
#line 470 "../lib/Widgets/DockWindow.vala"
				return result;
#line 1908 "DockWindow.c"
			}
#line 473 "../lib/Widgets/DockWindow.vala"
			_tmp69_ = element;
#line 473 "../lib/Widgets/DockWindow.vala"
			provider = PLANK_IS_DOCK_ITEM_PROVIDER (_tmp69_) ? ((PlankDockItemProvider*) _tmp69_) : NULL;
#line 474 "../lib/Widgets/DockWindow.vala"
			_tmp70_ = provider;
#line 474 "../lib/Widgets/DockWindow.vala"
			if (_tmp70_ == NULL) {
#line 475 "../lib/Widgets/DockWindow.vala"
				_g_object_unref0 (element);
#line 475 "../lib/Widgets/DockWindow.vala"
				continue;
#line 1922 "DockWindow.c"
			}
#line 477 "../lib/Widgets/DockWindow.vala"
			_tmp71_ = position_manager;
#line 477 "../lib/Widgets/DockWindow.vala"
			_tmp72_ = provider;
#line 477 "../lib/Widgets/DockWindow.vala"
			plank_position_manager_get_hover_region_for_element (_tmp71_, (PlankDockElement*) _tmp72_, &_tmp73_);
#line 477 "../lib/Widgets/DockWindow.vala"
			rect = _tmp73_;
#line 478 "../lib/Widgets/DockWindow.vala"
			_tmp77_ = rect;
#line 478 "../lib/Widgets/DockWindow.vala"
			if (y < _tmp77_.y) {
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp76_ = TRUE;
#line 1938 "DockWindow.c"
			} else {
				GdkRectangle _tmp78_;
				GdkRectangle _tmp79_;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp78_ = rect;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp79_ = rect;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp76_ = y >= (_tmp78_.y + _tmp79_.height);
#line 1948 "DockWindow.c"
			}
#line 478 "../lib/Widgets/DockWindow.vala"
			if (_tmp76_) {
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp75_ = TRUE;
#line 1954 "DockWindow.c"
			} else {
				GdkRectangle _tmp80_;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp80_ = rect;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp75_ = x < _tmp80_.x;
#line 1961 "DockWindow.c"
			}
#line 478 "../lib/Widgets/DockWindow.vala"
			if (_tmp75_) {
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp74_ = TRUE;
#line 1967 "DockWindow.c"
			} else {
				GdkRectangle _tmp81_;
				GdkRectangle _tmp82_;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp81_ = rect;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp82_ = rect;
#line 478 "../lib/Widgets/DockWindow.vala"
				_tmp74_ = x >= (_tmp81_.x + _tmp82_.width);
#line 1977 "DockWindow.c"
			}
#line 478 "../lib/Widgets/DockWindow.vala"
			if (_tmp74_) {
#line 479 "../lib/Widgets/DockWindow.vala"
				_g_object_unref0 (element);
#line 479 "../lib/Widgets/DockWindow.vala"
				continue;
#line 1985 "DockWindow.c"
			}
#line 481 "../lib/Widgets/DockWindow.vala"
			_tmp83_ = provider;
#line 481 "../lib/Widgets/DockWindow.vala"
			plank_dock_window_set_hovered_provider (self, _tmp83_);
#line 482 "../lib/Widgets/DockWindow.vala"
			found_hovered_provider = TRUE;
#line 1993 "DockWindow.c"
			{
				GeeArrayList* _element2_list = NULL;
				PlankDockItemProvider* _tmp84_;
				GeeArrayList* _tmp85_;
				GeeArrayList* _tmp86_;
				gint _element2_size = 0;
				GeeArrayList* _tmp87_;
				gint _tmp88_;
				gint _tmp89_;
				gint _element2_index = 0;
#line 484 "../lib/Widgets/DockWindow.vala"
				_tmp84_ = provider;
#line 484 "../lib/Widgets/DockWindow.vala"
				_tmp85_ = plank_dock_container_get_VisibleElements ((PlankDockContainer*) _tmp84_);
#line 484 "../lib/Widgets/DockWindow.vala"
				_tmp86_ = _tmp85_;
#line 484 "../lib/Widgets/DockWindow.vala"
				_element2_list = _tmp86_;
#line 484 "../lib/Widgets/DockWindow.vala"
				_tmp87_ = _element2_list;
#line 484 "../lib/Widgets/DockWindow.vala"
				_tmp88_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp87_);
#line 484 "../lib/Widgets/DockWindow.vala"
				_tmp89_ = _tmp88_;
#line 484 "../lib/Widgets/DockWindow.vala"
				_element2_size = _tmp89_;
#line 484 "../lib/Widgets/DockWindow.vala"
				_element2_index = -1;
#line 484 "../lib/Widgets/DockWindow.vala"
				while (TRUE) {
#line 2024 "DockWindow.c"
					gint _tmp90_;
					gint _tmp91_;
					PlankDockElement* element2 = NULL;
					GeeArrayList* _tmp92_;
					gpointer _tmp93_;
					PlankPositionManager* _tmp94_;
					PlankDockElement* _tmp95_;
					GdkRectangle _tmp96_ = {0};
					gboolean _tmp97_ = FALSE;
					gboolean _tmp98_ = FALSE;
					gboolean _tmp99_ = FALSE;
					GdkRectangle _tmp100_;
					PlankDockItem* _tmp106_;
					PlankDockElement* _tmp107_;
					PlankDockElement* _tmp108_;
#line 484 "../lib/Widgets/DockWindow.vala"
					_element2_index = _element2_index + 1;
#line 484 "../lib/Widgets/DockWindow.vala"
					_tmp90_ = _element2_index;
#line 484 "../lib/Widgets/DockWindow.vala"
					_tmp91_ = _element2_size;
#line 484 "../lib/Widgets/DockWindow.vala"
					if (!(_tmp90_ < _tmp91_)) {
#line 484 "../lib/Widgets/DockWindow.vala"
						break;
#line 2050 "DockWindow.c"
					}
#line 484 "../lib/Widgets/DockWindow.vala"
					_tmp92_ = _element2_list;
#line 484 "../lib/Widgets/DockWindow.vala"
					_tmp93_ = gee_abstract_list_get ((GeeAbstractList*) _tmp92_, _element2_index);
#line 484 "../lib/Widgets/DockWindow.vala"
					element2 = (PlankDockElement*) _tmp93_;
#line 485 "../lib/Widgets/DockWindow.vala"
					_tmp94_ = position_manager;
#line 485 "../lib/Widgets/DockWindow.vala"
					_tmp95_ = element2;
#line 485 "../lib/Widgets/DockWindow.vala"
					plank_position_manager_get_hover_region_for_element (_tmp94_, _tmp95_, &_tmp96_);
#line 485 "../lib/Widgets/DockWindow.vala"
					rect = _tmp96_;
#line 486 "../lib/Widgets/DockWindow.vala"
					_tmp100_ = rect;
#line 486 "../lib/Widgets/DockWindow.vala"
					if (y < _tmp100_.y) {
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp99_ = TRUE;
#line 2072 "DockWindow.c"
					} else {
						GdkRectangle _tmp101_;
						GdkRectangle _tmp102_;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp101_ = rect;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp102_ = rect;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp99_ = y >= (_tmp101_.y + _tmp102_.height);
#line 2082 "DockWindow.c"
					}
#line 486 "../lib/Widgets/DockWindow.vala"
					if (_tmp99_) {
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp98_ = TRUE;
#line 2088 "DockWindow.c"
					} else {
						GdkRectangle _tmp103_;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp103_ = rect;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp98_ = x < _tmp103_.x;
#line 2095 "DockWindow.c"
					}
#line 486 "../lib/Widgets/DockWindow.vala"
					if (_tmp98_) {
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp97_ = TRUE;
#line 2101 "DockWindow.c"
					} else {
						GdkRectangle _tmp104_;
						GdkRectangle _tmp105_;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp104_ = rect;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp105_ = rect;
#line 486 "../lib/Widgets/DockWindow.vala"
						_tmp97_ = x >= (_tmp104_.x + _tmp105_.width);
#line 2111 "DockWindow.c"
					}
#line 486 "../lib/Widgets/DockWindow.vala"
					if (_tmp97_) {
#line 487 "../lib/Widgets/DockWindow.vala"
						_g_object_unref0 (element2);
#line 487 "../lib/Widgets/DockWindow.vala"
						continue;
#line 2119 "DockWindow.c"
					}
#line 490 "../lib/Widgets/DockWindow.vala"
					_tmp106_ = drag_item;
#line 490 "../lib/Widgets/DockWindow.vala"
					_tmp107_ = element2;
#line 490 "../lib/Widgets/DockWindow.vala"
					if (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, PLANK_TYPE_DOCK_ELEMENT, PlankDockElement) == _tmp107_) {
#line 491 "../lib/Widgets/DockWindow.vala"
						_g_object_unref0 (element2);
#line 491 "../lib/Widgets/DockWindow.vala"
						break;
#line 2131 "DockWindow.c"
					}
#line 493 "../lib/Widgets/DockWindow.vala"
					_tmp108_ = element2;
#line 493 "../lib/Widgets/DockWindow.vala"
					plank_dock_window_set_hovered (self, PLANK_IS_DOCK_ITEM (_tmp108_) ? ((PlankDockItem*) _tmp108_) : NULL);
#line 494 "../lib/Widgets/DockWindow.vala"
					result = TRUE;
#line 494 "../lib/Widgets/DockWindow.vala"
					_g_object_unref0 (element2);
#line 494 "../lib/Widgets/DockWindow.vala"
					_g_object_unref0 (element);
#line 494 "../lib/Widgets/DockWindow.vala"
					return result;
#line 2145 "DockWindow.c"
				}
			}
#line 457 "../lib/Widgets/DockWindow.vala"
			_g_object_unref0 (element);
#line 2150 "DockWindow.c"
		}
	}
#line 498 "../lib/Widgets/DockWindow.vala"
	if (!found_hovered_provider) {
#line 499 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 2157 "DockWindow.c"
	}
#line 500 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_set_hovered (self, NULL);
#line 501 "../lib/Widgets/DockWindow.vala"
	result = FALSE;
#line 501 "../lib/Widgets/DockWindow.vala"
	return result;
#line 2165 "DockWindow.c"
}

/**
 * Sets the size of the dock window and repositions it if needed.
 */
void
plank_dock_window_update_size_and_position (PlankDockWindow* self)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	GdkRectangle win_rect = {0};
	PlankPositionManager* _tmp3_;
	GdkRectangle _tmp4_ = {0};
	gint width_current = 0;
	gint height_current = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
	GdkRectangle _tmp8_;
	gboolean needs_resize = FALSE;
	gboolean needs_reposition = FALSE;
#line 507 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 509 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 509 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 509 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 509 "../lib/Widgets/DockWindow.vala"
	position_manager = _tmp2_;
#line 511 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = position_manager;
#line 511 "../lib/Widgets/DockWindow.vala"
	plank_position_manager_get_dock_window_region (_tmp3_, &_tmp4_);
#line 511 "../lib/Widgets/DockWindow.vala"
	win_rect = _tmp4_;
#line 514 "../lib/Widgets/DockWindow.vala"
	gtk_widget_get_size_request ((GtkWidget*) self, &_tmp5_, &_tmp6_);
#line 514 "../lib/Widgets/DockWindow.vala"
	width_current = _tmp5_;
#line 514 "../lib/Widgets/DockWindow.vala"
	height_current = _tmp6_;
#line 515 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = win_rect;
#line 515 "../lib/Widgets/DockWindow.vala"
	if (_tmp8_.width != width_current) {
#line 515 "../lib/Widgets/DockWindow.vala"
		_tmp7_ = TRUE;
#line 2217 "DockWindow.c"
	} else {
		GdkRectangle _tmp9_;
#line 515 "../lib/Widgets/DockWindow.vala"
		_tmp9_ = win_rect;
#line 515 "../lib/Widgets/DockWindow.vala"
		_tmp7_ = _tmp9_.height != height_current;
#line 2224 "DockWindow.c"
	}
#line 515 "../lib/Widgets/DockWindow.vala"
	needs_resize = _tmp7_;
#line 517 "../lib/Widgets/DockWindow.vala"
	needs_reposition = TRUE;
#line 518 "../lib/Widgets/DockWindow.vala"
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
#line 2232 "DockWindow.c"
		gint x_current = 0;
		gint y_current = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GdkRectangle _tmp15_;
#line 520 "../lib/Widgets/DockWindow.vala"
		gtk_window_get_position ((GtkWindow*) self, &_tmp10_, &_tmp11_);
#line 520 "../lib/Widgets/DockWindow.vala"
		x_current = _tmp10_;
#line 520 "../lib/Widgets/DockWindow.vala"
		y_current = _tmp11_;
#line 521 "../lib/Widgets/DockWindow.vala"
		_tmp15_ = win_rect;
#line 521 "../lib/Widgets/DockWindow.vala"
		if (_tmp15_.x != x_current) {
#line 521 "../lib/Widgets/DockWindow.vala"
			_tmp14_ = TRUE;
#line 2253 "DockWindow.c"
		} else {
			GdkRectangle _tmp16_;
#line 521 "../lib/Widgets/DockWindow.vala"
			_tmp16_ = win_rect;
#line 521 "../lib/Widgets/DockWindow.vala"
			_tmp14_ = _tmp16_.y != y_current;
#line 2260 "DockWindow.c"
		}
#line 521 "../lib/Widgets/DockWindow.vala"
		if (_tmp14_) {
#line 521 "../lib/Widgets/DockWindow.vala"
			_tmp13_ = TRUE;
#line 2266 "DockWindow.c"
		} else {
			GdkRectangle _tmp17_;
#line 522 "../lib/Widgets/DockWindow.vala"
			_tmp17_ = win_rect;
#line 522 "../lib/Widgets/DockWindow.vala"
			_tmp13_ = _tmp17_.x != self->priv->requested_x;
#line 2273 "DockWindow.c"
		}
#line 521 "../lib/Widgets/DockWindow.vala"
		if (_tmp13_) {
#line 521 "../lib/Widgets/DockWindow.vala"
			_tmp12_ = TRUE;
#line 2279 "DockWindow.c"
		} else {
			GdkRectangle _tmp18_;
#line 522 "../lib/Widgets/DockWindow.vala"
			_tmp18_ = win_rect;
#line 522 "../lib/Widgets/DockWindow.vala"
			_tmp12_ = _tmp18_.y != self->priv->requested_y;
#line 2286 "DockWindow.c"
		}
#line 521 "../lib/Widgets/DockWindow.vala"
		needs_reposition = _tmp12_;
#line 2290 "DockWindow.c"
	}
#line 525 "../lib/Widgets/DockWindow.vala"
	if (needs_resize) {
#line 2294 "DockWindow.c"
		GdkRectangle _tmp19_;
		GdkRectangle _tmp20_;
		GdkRectangle _tmp21_;
		GdkRectangle _tmp22_;
		PlankDockController* _tmp23_;
		PlankDockRenderer* _tmp24_;
		PlankDockRenderer* _tmp25_;
#line 526 "../lib/Widgets/DockWindow.vala"
		_tmp19_ = win_rect;
#line 526 "../lib/Widgets/DockWindow.vala"
		_tmp20_ = win_rect;
#line 526 "../lib/Widgets/DockWindow.vala"
		plank_logger_verbose ("DockWindow.set_size_request (width = %i, height = %i)", _tmp19_.width, _tmp20_.height, NULL);
#line 527 "../lib/Widgets/DockWindow.vala"
		_tmp21_ = win_rect;
#line 527 "../lib/Widgets/DockWindow.vala"
		_tmp22_ = win_rect;
#line 527 "../lib/Widgets/DockWindow.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, _tmp21_.width, _tmp22_.height);
#line 528 "../lib/Widgets/DockWindow.vala"
		_tmp23_ = self->priv->_controller;
#line 528 "../lib/Widgets/DockWindow.vala"
		_tmp24_ = plank_dock_controller_get_renderer (_tmp23_);
#line 528 "../lib/Widgets/DockWindow.vala"
		_tmp25_ = _tmp24_;
#line 528 "../lib/Widgets/DockWindow.vala"
		plank_dock_renderer_reset_buffers (_tmp25_);
#line 530 "../lib/Widgets/DockWindow.vala"
		if (!needs_reposition) {
#line 531 "../lib/Widgets/DockWindow.vala"
			plank_dock_window_update_icon_regions (self);
#line 532 "../lib/Widgets/DockWindow.vala"
			plank_dock_window_set_struts (self);
#line 533 "../lib/Widgets/DockWindow.vala"
			plank_dock_window_set_hovered_provider (self, NULL);
#line 534 "../lib/Widgets/DockWindow.vala"
			plank_dock_window_set_hovered (self, NULL);
#line 2332 "DockWindow.c"
		}
	}
#line 538 "../lib/Widgets/DockWindow.vala"
	if (needs_reposition) {
#line 2337 "DockWindow.c"
		GdkRectangle _tmp26_;
		GdkRectangle _tmp27_;
		GdkRectangle _tmp28_;
		GdkRectangle _tmp29_;
		GdkRectangle _tmp30_;
		GdkRectangle _tmp31_;
#line 539 "../lib/Widgets/DockWindow.vala"
		_tmp26_ = win_rect;
#line 539 "../lib/Widgets/DockWindow.vala"
		_tmp27_ = win_rect;
#line 539 "../lib/Widgets/DockWindow.vala"
		plank_logger_verbose ("DockWindow.move (x = %i, y = %i)", _tmp26_.x, _tmp27_.y, NULL);
#line 540 "../lib/Widgets/DockWindow.vala"
		_tmp28_ = win_rect;
#line 540 "../lib/Widgets/DockWindow.vala"
		self->priv->requested_x = _tmp28_.x;
#line 541 "../lib/Widgets/DockWindow.vala"
		_tmp29_ = win_rect;
#line 541 "../lib/Widgets/DockWindow.vala"
		self->priv->requested_y = _tmp29_.y;
#line 542 "../lib/Widgets/DockWindow.vala"
		_tmp30_ = win_rect;
#line 542 "../lib/Widgets/DockWindow.vala"
		_tmp31_ = win_rect;
#line 542 "../lib/Widgets/DockWindow.vala"
		gtk_window_move ((GtkWindow*) self, _tmp30_.x, _tmp31_.y);
#line 544 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_update_icon_regions (self);
#line 545 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_struts (self);
#line 546 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 547 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 2372 "DockWindow.c"
	}
}

/**
 * Updates the icon regions for all items on the dock.
 */
void
plank_dock_window_update_icon_regions (PlankDockWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean use_hidden_region = FALSE;
#line 554 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 556 "../lib/Widgets/DockWindow.vala"
	plank_logger_verbose ("DockWindow.update_icon_regions ()", NULL);
#line 558 "../lib/Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 558 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = TRUE;
#line 2392 "DockWindow.c"
	} else {
		PlankDockController* _tmp1_;
		PlankHideManager* _tmp2_;
		PlankHideManager* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 558 "../lib/Widgets/DockWindow.vala"
		_tmp1_ = self->priv->_controller;
#line 558 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = plank_dock_controller_get_hide_manager (_tmp1_);
#line 558 "../lib/Widgets/DockWindow.vala"
		_tmp3_ = _tmp2_;
#line 558 "../lib/Widgets/DockWindow.vala"
		_tmp4_ = plank_hide_manager_get_Hidden (_tmp3_);
#line 558 "../lib/Widgets/DockWindow.vala"
		_tmp5_ = _tmp4_;
#line 558 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = _tmp5_;
#line 2411 "DockWindow.c"
	}
#line 558 "../lib/Widgets/DockWindow.vala"
	use_hidden_region = _tmp0_;
#line 2415 "DockWindow.c"
	{
		GeeArrayList* _item_list = NULL;
		PlankDockController* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeArrayList* _tmp8_;
		gint _item_size = 0;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _item_index = 0;
#line 560 "../lib/Widgets/DockWindow.vala"
		_tmp6_ = self->priv->_controller;
#line 560 "../lib/Widgets/DockWindow.vala"
		_tmp7_ = plank_dock_controller_get_VisibleItems (_tmp6_);
#line 560 "../lib/Widgets/DockWindow.vala"
		_tmp8_ = _tmp7_;
#line 560 "../lib/Widgets/DockWindow.vala"
		_item_list = _tmp8_;
#line 560 "../lib/Widgets/DockWindow.vala"
		_tmp9_ = _item_list;
#line 560 "../lib/Widgets/DockWindow.vala"
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 560 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = _tmp10_;
#line 560 "../lib/Widgets/DockWindow.vala"
		_item_size = _tmp11_;
#line 560 "../lib/Widgets/DockWindow.vala"
		_item_index = -1;
#line 560 "../lib/Widgets/DockWindow.vala"
		while (TRUE) {
#line 2446 "DockWindow.c"
			gint _tmp12_;
			gint _tmp13_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			PlankDockItem* _tmp16_;
			PlankApplicationDockItem* appitem = NULL;
			PlankDockItem* _tmp17_;
			gboolean _tmp18_ = FALSE;
			PlankApplicationDockItem* _tmp19_;
			GdkRectangle region = {0};
			PlankDockController* _tmp21_;
			PlankPositionManager* _tmp22_;
			PlankPositionManager* _tmp23_;
			PlankApplicationDockItem* _tmp24_;
			GdkRectangle _tmp25_ = {0};
			PlankApplicationDockItem* _tmp26_;
			BamfApplication* _tmp27_;
			BamfApplication* _tmp28_;
			GdkRectangle _tmp29_;
#line 560 "../lib/Widgets/DockWindow.vala"
			_item_index = _item_index + 1;
#line 560 "../lib/Widgets/DockWindow.vala"
			_tmp12_ = _item_index;
#line 560 "../lib/Widgets/DockWindow.vala"
			_tmp13_ = _item_size;
#line 560 "../lib/Widgets/DockWindow.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 560 "../lib/Widgets/DockWindow.vala"
				break;
#line 2477 "DockWindow.c"
			}
#line 560 "../lib/Widgets/DockWindow.vala"
			_tmp14_ = _item_list;
#line 560 "../lib/Widgets/DockWindow.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _item_index);
#line 560 "../lib/Widgets/DockWindow.vala"
			_tmp16_ = _g_object_ref0 ((PlankDockItem*) _tmp15_);
#line 560 "../lib/Widgets/DockWindow.vala"
			item = _tmp16_;
#line 561 "../lib/Widgets/DockWindow.vala"
			_tmp17_ = item;
#line 561 "../lib/Widgets/DockWindow.vala"
			appitem = PLANK_IS_APPLICATION_DOCK_ITEM (_tmp17_) ? ((PlankApplicationDockItem*) _tmp17_) : NULL;
#line 562 "../lib/Widgets/DockWindow.vala"
			_tmp19_ = appitem;
#line 562 "../lib/Widgets/DockWindow.vala"
			if (_tmp19_ == NULL) {
#line 562 "../lib/Widgets/DockWindow.vala"
				_tmp18_ = TRUE;
#line 2497 "DockWindow.c"
			} else {
				PlankApplicationDockItem* _tmp20_;
#line 562 "../lib/Widgets/DockWindow.vala"
				_tmp20_ = appitem;
#line 562 "../lib/Widgets/DockWindow.vala"
				_tmp18_ = !plank_application_dock_item_is_running (_tmp20_);
#line 2504 "DockWindow.c"
			}
#line 562 "../lib/Widgets/DockWindow.vala"
			if (_tmp18_) {
#line 563 "../lib/Widgets/DockWindow.vala"
				_g_object_unref0 (item);
#line 563 "../lib/Widgets/DockWindow.vala"
				continue;
#line 2512 "DockWindow.c"
			}
#line 565 "../lib/Widgets/DockWindow.vala"
			_tmp21_ = self->priv->_controller;
#line 565 "../lib/Widgets/DockWindow.vala"
			_tmp22_ = plank_dock_controller_get_position_manager (_tmp21_);
#line 565 "../lib/Widgets/DockWindow.vala"
			_tmp23_ = _tmp22_;
#line 565 "../lib/Widgets/DockWindow.vala"
			_tmp24_ = appitem;
#line 565 "../lib/Widgets/DockWindow.vala"
			plank_position_manager_get_icon_geometry (_tmp23_, _tmp24_, use_hidden_region, &_tmp25_);
#line 565 "../lib/Widgets/DockWindow.vala"
			region = _tmp25_;
#line 566 "../lib/Widgets/DockWindow.vala"
			_tmp26_ = appitem;
#line 566 "../lib/Widgets/DockWindow.vala"
			_tmp27_ = plank_application_dock_item_get_App (_tmp26_);
#line 566 "../lib/Widgets/DockWindow.vala"
			_tmp28_ = _tmp27_;
#line 566 "../lib/Widgets/DockWindow.vala"
			_tmp29_ = region;
#line 566 "../lib/Widgets/DockWindow.vala"
			plank_window_control_update_icon_regions (_tmp28_, &_tmp29_);
#line 560 "../lib/Widgets/DockWindow.vala"
			_g_object_unref0 (item);
#line 2538 "DockWindow.c"
		}
	}
}

/**
 * Updates the icon region for the given item.
 *
 + @param appitem the item to update the icon region for
 */
void
plank_dock_window_update_icon_region (PlankDockWindow* self,
                                      PlankApplicationDockItem* appitem)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean use_hidden_region = FALSE;
	GdkRectangle region = {0};
	PlankDockController* _tmp8_;
	PlankPositionManager* _tmp9_;
	PlankPositionManager* _tmp10_;
	GdkRectangle _tmp11_ = {0};
	BamfApplication* _tmp12_;
	BamfApplication* _tmp13_;
	GdkRectangle _tmp14_;
#line 575 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 575 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (appitem != NULL);
#line 577 "../lib/Widgets/DockWindow.vala"
	if (!plank_application_dock_item_is_running (appitem)) {
#line 578 "../lib/Widgets/DockWindow.vala"
		return;
#line 2572 "DockWindow.c"
	}
#line 580 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = plank_dock_element_get_Text ((PlankDockElement*) appitem);
#line 580 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = _tmp0_;
#line 580 "../lib/Widgets/DockWindow.vala"
	plank_logger_verbose ("DockWindow.update_icon_region ('%s')", _tmp1_, NULL);
#line 582 "../lib/Widgets/DockWindow.vala"
	if (plank_dock_window_menu_is_visible (self)) {
#line 582 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = TRUE;
#line 2584 "DockWindow.c"
	} else {
		PlankDockController* _tmp3_;
		PlankHideManager* _tmp4_;
		PlankHideManager* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 582 "../lib/Widgets/DockWindow.vala"
		_tmp3_ = self->priv->_controller;
#line 582 "../lib/Widgets/DockWindow.vala"
		_tmp4_ = plank_dock_controller_get_hide_manager (_tmp3_);
#line 582 "../lib/Widgets/DockWindow.vala"
		_tmp5_ = _tmp4_;
#line 582 "../lib/Widgets/DockWindow.vala"
		_tmp6_ = plank_hide_manager_get_Hidden (_tmp5_);
#line 582 "../lib/Widgets/DockWindow.vala"
		_tmp7_ = _tmp6_;
#line 582 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = _tmp7_;
#line 2603 "DockWindow.c"
	}
#line 582 "../lib/Widgets/DockWindow.vala"
	use_hidden_region = _tmp2_;
#line 583 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = self->priv->_controller;
#line 583 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_controller_get_position_manager (_tmp8_);
#line 583 "../lib/Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 583 "../lib/Widgets/DockWindow.vala"
	plank_position_manager_get_icon_geometry (_tmp10_, appitem, use_hidden_region, &_tmp11_);
#line 583 "../lib/Widgets/DockWindow.vala"
	region = _tmp11_;
#line 584 "../lib/Widgets/DockWindow.vala"
	_tmp12_ = plank_application_dock_item_get_App (appitem);
#line 584 "../lib/Widgets/DockWindow.vala"
	_tmp13_ = _tmp12_;
#line 584 "../lib/Widgets/DockWindow.vala"
	_tmp14_ = region;
#line 584 "../lib/Widgets/DockWindow.vala"
	plank_window_control_update_icon_regions (_tmp13_, &_tmp14_);
#line 2625 "DockWindow.c"
}

/**
 * If the popup menu is currently visible.
 */
gboolean
plank_dock_window_menu_is_visible (PlankDockWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkMenu* _tmp1_;
	gboolean result;
#line 590 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 592 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = self->priv->menu;
#line 592 "../lib/Widgets/DockWindow.vala"
	if (_tmp1_ != NULL) {
#line 2643 "DockWindow.c"
		GtkMenu* _tmp2_;
#line 592 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = self->priv->menu;
#line 592 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
#line 2649 "DockWindow.c"
	} else {
#line 592 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = FALSE;
#line 2653 "DockWindow.c"
	}
#line 592 "../lib/Widgets/DockWindow.vala"
	result = _tmp0_;
#line 592 "../lib/Widgets/DockWindow.vala"
	return result;
#line 2659 "DockWindow.c"
}

/**
 * Shows the popup menu.
 *
 * @param item the item to show a menu for, or NULL
 * @param event the event which triggerd this request
 */
static gboolean
plank_dock_window_show_menu (PlankDockWindow* self,
                             PlankDockItem* item,
                             GdkEventButton* event)
{
	GtkMenu* _tmp0_;
	GtkMenuPositionFunc position_func = NULL;
	gpointer position_func_target;
	GDestroyNotify position_func_target_destroy_notify;
	PlankPopupButton button = 0U;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp30_ = FALSE;
	GeeArrayList* _tmp31_;
	GtkMenu* _tmp35_;
	GtkMenu* _tmp36_;
	GtkMenu* _tmp37_;
	GtkMenu* _tmp38_;
	GeeBidirListIterator* iterator = NULL;
	GeeArrayList* _tmp39_;
	GeeBidirListIterator* _tmp40_;
	PlankDockController* _tmp41_;
	PlankDockPreferences* _tmp42_;
	PlankDockPreferences* _tmp43_;
	GtkPositionType _tmp44_;
	GtkPositionType _tmp45_;
	GtkMenu* _tmp62_;
	GtkMenuPositionFunc _tmp63_;
	gpointer _tmp63__target;
	gboolean result;
#line 601 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 601 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 603 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->menu;
#line 603 "../lib/Widgets/DockWindow.vala"
	if (_tmp0_ != NULL) {
#line 2705 "DockWindow.c"
		GtkMenu* _tmp1_;
		GList* _tmp2_;
		GtkMenu* _tmp5_;
		guint _tmp6_;
		GtkMenu* _tmp7_;
		guint _tmp8_;
		GtkMenu* _tmp9_;
#line 604 "../lib/Widgets/DockWindow.vala"
		_tmp1_ = self->priv->menu;
#line 604 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 2717 "DockWindow.c"
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
#line 604 "../lib/Widgets/DockWindow.vala"
			w_collection = _tmp2_;
#line 604 "../lib/Widgets/DockWindow.vala"
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 2725 "DockWindow.c"
				GtkWidget* w = NULL;
#line 604 "../lib/Widgets/DockWindow.vala"
				w = (GtkWidget*) w_it->data;
#line 2729 "DockWindow.c"
				{
					GtkMenu* _tmp3_;
					GtkWidget* _tmp4_;
#line 605 "../lib/Widgets/DockWindow.vala"
					_tmp3_ = self->priv->menu;
#line 605 "../lib/Widgets/DockWindow.vala"
					_tmp4_ = w;
#line 605 "../lib/Widgets/DockWindow.vala"
					gtk_container_remove ((GtkContainer*) _tmp3_, _tmp4_);
#line 2739 "DockWindow.c"
				}
			}
#line 604 "../lib/Widgets/DockWindow.vala"
			(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
#line 2744 "DockWindow.c"
		}
#line 607 "../lib/Widgets/DockWindow.vala"
		_tmp5_ = self->priv->menu;
#line 607 "../lib/Widgets/DockWindow.vala"
		g_signal_parse_name ("show", gtk_widget_get_type (), &_tmp6_, NULL, FALSE);
#line 607 "../lib/Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_dock_window_on_menu_show_gtk_widget_show, self);
#line 608 "../lib/Widgets/DockWindow.vala"
		_tmp7_ = self->priv->menu;
#line 608 "../lib/Widgets/DockWindow.vala"
		g_signal_parse_name ("hide", gtk_widget_get_type (), &_tmp8_, NULL, FALSE);
#line 608 "../lib/Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _plank_dock_window_on_menu_hide_gtk_widget_hide, self);
#line 609 "../lib/Widgets/DockWindow.vala"
		_tmp9_ = self->priv->menu;
#line 609 "../lib/Widgets/DockWindow.vala"
		gtk_menu_detach (_tmp9_);
#line 610 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->menu);
#line 610 "../lib/Widgets/DockWindow.vala"
		self->priv->menu = NULL;
#line 2766 "DockWindow.c"
	}
#line 613 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu_items);
#line 613 "../lib/Widgets/DockWindow.vala"
	self->priv->menu_items = NULL;
#line 614 "../lib/Widgets/DockWindow.vala"
	position_func = NULL;
#line 614 "../lib/Widgets/DockWindow.vala"
	position_func_target = NULL;
#line 614 "../lib/Widgets/DockWindow.vala"
	position_func_target_destroy_notify = NULL;
#line 615 "../lib/Widgets/DockWindow.vala"
	button = plank_popup_button_from_event_button (event);
#line 617 "../lib/Widgets/DockWindow.vala"
	if ((button & PLANK_POPUP_BUTTON_RIGHT) != 0) {
#line 2782 "DockWindow.c"
		gboolean _tmp11_ = FALSE;
#line 618 "../lib/Widgets/DockWindow.vala"
		if (item == NULL) {
#line 618 "../lib/Widgets/DockWindow.vala"
			_tmp11_ = TRUE;
#line 2788 "DockWindow.c"
		} else {
#line 618 "../lib/Widgets/DockWindow.vala"
			_tmp11_ = (event->state & GDK_CONTROL_MASK) != 0;
#line 2792 "DockWindow.c"
		}
#line 618 "../lib/Widgets/DockWindow.vala"
		_tmp10_ = _tmp11_;
#line 2796 "DockWindow.c"
	} else {
#line 617 "../lib/Widgets/DockWindow.vala"
		_tmp10_ = FALSE;
#line 2800 "DockWindow.c"
	}
#line 617 "../lib/Widgets/DockWindow.vala"
	if (_tmp10_) {
#line 2804 "DockWindow.c"
		PlankItemFactory* _tmp12_;
		PlankDockItem* _tmp13_;
		PlankDockItem* _tmp14_;
		GeeArrayList* _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 619 "../lib/Widgets/DockWindow.vala"
		_tmp12_ = plank_factory_item_factory;
#line 619 "../lib/Widgets/DockWindow.vala"
		_tmp13_ = plank_item_factory_get_item_for_dock (_tmp12_);
#line 619 "../lib/Widgets/DockWindow.vala"
		_tmp14_ = _tmp13_;
#line 619 "../lib/Widgets/DockWindow.vala"
		_tmp15_ = plank_dock_element_get_menu_items ((PlankDockElement*) _tmp14_);
#line 619 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->menu_items);
#line 619 "../lib/Widgets/DockWindow.vala"
		self->priv->menu_items = _tmp15_;
#line 619 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (_tmp14_);
#line 620 "../lib/Widgets/DockWindow.vala"
		if ((event->state & GDK_MOD1_MASK) != 0) {
#line 621 "../lib/Widgets/DockWindow.vala"
			_tmp16_ = (event->state & GDK_SHIFT_MASK) != 0;
#line 2828 "DockWindow.c"
		} else {
#line 620 "../lib/Widgets/DockWindow.vala"
			_tmp16_ = FALSE;
#line 2832 "DockWindow.c"
		}
#line 620 "../lib/Widgets/DockWindow.vala"
		if (_tmp16_) {
#line 2836 "DockWindow.c"
			GeeArrayList* _tmp17_;
			PlankDockController* _tmp18_;
			GeeArrayList* _tmp19_;
			GeeArrayList* _tmp20_;
#line 622 "../lib/Widgets/DockWindow.vala"
			_tmp17_ = self->priv->menu_items;
#line 622 "../lib/Widgets/DockWindow.vala"
			_tmp18_ = self->priv->_controller;
#line 622 "../lib/Widgets/DockWindow.vala"
			_tmp19_ = plank_dock_window_get_dock_debug_menu_items (_tmp18_);
#line 622 "../lib/Widgets/DockWindow.vala"
			_tmp20_ = _tmp19_;
#line 622 "../lib/Widgets/DockWindow.vala"
			gee_array_list_add_all (_tmp17_, (GeeCollection*) _tmp20_);
#line 622 "../lib/Widgets/DockWindow.vala"
			_g_object_unref0 (_tmp20_);
#line 2853 "DockWindow.c"
		}
#line 623 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 624 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 2859 "DockWindow.c"
	} else {
		gboolean _tmp21_ = FALSE;
		gboolean _tmp22_ = FALSE;
#line 625 "../lib/Widgets/DockWindow.vala"
		if (item != NULL) {
#line 625 "../lib/Widgets/DockWindow.vala"
			_tmp22_ = plank_dock_item_is_valid (item);
#line 2867 "DockWindow.c"
		} else {
#line 625 "../lib/Widgets/DockWindow.vala"
			_tmp22_ = FALSE;
#line 2871 "DockWindow.c"
		}
#line 625 "../lib/Widgets/DockWindow.vala"
		if (_tmp22_) {
#line 2875 "DockWindow.c"
			PlankPopupButton _tmp23_;
			PlankPopupButton _tmp24_;
#line 625 "../lib/Widgets/DockWindow.vala"
			_tmp23_ = plank_dock_element_get_Button ((PlankDockElement*) item);
#line 625 "../lib/Widgets/DockWindow.vala"
			_tmp24_ = _tmp23_;
#line 625 "../lib/Widgets/DockWindow.vala"
			_tmp21_ = (_tmp24_ & button) != 0;
#line 2884 "DockWindow.c"
		} else {
#line 625 "../lib/Widgets/DockWindow.vala"
			_tmp21_ = FALSE;
#line 2888 "DockWindow.c"
		}
#line 625 "../lib/Widgets/DockWindow.vala"
		if (_tmp21_) {
#line 2892 "DockWindow.c"
			GeeArrayList* _tmp25_;
			gboolean _tmp26_ = FALSE;
#line 626 "../lib/Widgets/DockWindow.vala"
			_tmp25_ = plank_dock_element_get_menu_items ((PlankDockElement*) item);
#line 626 "../lib/Widgets/DockWindow.vala"
			_g_object_unref0 (self->priv->menu_items);
#line 626 "../lib/Widgets/DockWindow.vala"
			self->priv->menu_items = _tmp25_;
#line 627 "../lib/Widgets/DockWindow.vala"
			if ((event->state & GDK_MOD1_MASK) != 0) {
#line 628 "../lib/Widgets/DockWindow.vala"
				_tmp26_ = (event->state & GDK_SHIFT_MASK) != 0;
#line 2905 "DockWindow.c"
			} else {
#line 627 "../lib/Widgets/DockWindow.vala"
				_tmp26_ = FALSE;
#line 2909 "DockWindow.c"
			}
#line 627 "../lib/Widgets/DockWindow.vala"
			if (_tmp26_) {
#line 2913 "DockWindow.c"
				GeeArrayList* _tmp27_;
				GeeArrayList* _tmp28_;
				GeeArrayList* _tmp29_;
#line 629 "../lib/Widgets/DockWindow.vala"
				_tmp27_ = self->priv->menu_items;
#line 629 "../lib/Widgets/DockWindow.vala"
				_tmp28_ = plank_dock_window_get_item_debug_menu_items (item);
#line 629 "../lib/Widgets/DockWindow.vala"
				_tmp29_ = _tmp28_;
#line 629 "../lib/Widgets/DockWindow.vala"
				gee_array_list_add_all (_tmp27_, (GeeCollection*) _tmp29_);
#line 629 "../lib/Widgets/DockWindow.vala"
				_g_object_unref0 (_tmp29_);
#line 2927 "DockWindow.c"
			}
#line 630 "../lib/Widgets/DockWindow.vala"
			(position_func_target_destroy_notify == NULL) ? NULL : (position_func_target_destroy_notify (position_func_target), NULL);
#line 630 "../lib/Widgets/DockWindow.vala"
			position_func = NULL;
#line 630 "../lib/Widgets/DockWindow.vala"
			position_func_target = NULL;
#line 630 "../lib/Widgets/DockWindow.vala"
			position_func_target_destroy_notify = NULL;
#line 630 "../lib/Widgets/DockWindow.vala"
			position_func = (GtkMenuPositionFunc) plank_dock_window_position_menu;
#line 630 "../lib/Widgets/DockWindow.vala"
			position_func_target = g_object_ref (self);
#line 630 "../lib/Widgets/DockWindow.vala"
			position_func_target_destroy_notify = g_object_unref;
#line 2943 "DockWindow.c"
		}
	}
#line 633 "../lib/Widgets/DockWindow.vala"
	_tmp31_ = self->priv->menu_items;
#line 633 "../lib/Widgets/DockWindow.vala"
	if (_tmp31_ == NULL) {
#line 633 "../lib/Widgets/DockWindow.vala"
		_tmp30_ = TRUE;
#line 2952 "DockWindow.c"
	} else {
		GeeArrayList* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
#line 633 "../lib/Widgets/DockWindow.vala"
		_tmp32_ = self->priv->menu_items;
#line 633 "../lib/Widgets/DockWindow.vala"
		_tmp33_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp32_);
#line 633 "../lib/Widgets/DockWindow.vala"
		_tmp34_ = _tmp33_;
#line 633 "../lib/Widgets/DockWindow.vala"
		_tmp30_ = _tmp34_ == 0;
#line 2965 "DockWindow.c"
	}
#line 633 "../lib/Widgets/DockWindow.vala"
	if (_tmp30_) {
#line 634 "../lib/Widgets/DockWindow.vala"
		result = FALSE;
#line 634 "../lib/Widgets/DockWindow.vala"
		(position_func_target_destroy_notify == NULL) ? NULL : (position_func_target_destroy_notify (position_func_target), NULL);
#line 634 "../lib/Widgets/DockWindow.vala"
		position_func = NULL;
#line 634 "../lib/Widgets/DockWindow.vala"
		position_func_target = NULL;
#line 634 "../lib/Widgets/DockWindow.vala"
		position_func_target_destroy_notify = NULL;
#line 634 "../lib/Widgets/DockWindow.vala"
		return result;
#line 2981 "DockWindow.c"
	}
#line 636 "../lib/Widgets/DockWindow.vala"
	_tmp35_ = (GtkMenu*) gtk_menu_new ();
#line 636 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp35_);
#line 636 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu);
#line 636 "../lib/Widgets/DockWindow.vala"
	self->priv->menu = _tmp35_;
#line 637 "../lib/Widgets/DockWindow.vala"
	_tmp36_ = self->priv->menu;
#line 637 "../lib/Widgets/DockWindow.vala"
	gtk_menu_attach_to_widget (_tmp36_, (GtkWidget*) self, NULL);
#line 638 "../lib/Widgets/DockWindow.vala"
	_tmp37_ = self->priv->menu;
#line 638 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp37_, "show", (GCallback) _plank_dock_window_on_menu_show_gtk_widget_show, self, 0);
#line 639 "../lib/Widgets/DockWindow.vala"
	_tmp38_ = self->priv->menu;
#line 639 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp38_, "hide", (GCallback) _plank_dock_window_on_menu_hide_gtk_widget_hide, self, 0);
#line 641 "../lib/Widgets/DockWindow.vala"
	_tmp39_ = self->priv->menu_items;
#line 641 "../lib/Widgets/DockWindow.vala"
	_tmp40_ = gee_abstract_bidir_list_bidir_list_iterator ((GeeAbstractBidirList*) _tmp39_);
#line 641 "../lib/Widgets/DockWindow.vala"
	iterator = _tmp40_;
#line 642 "../lib/Widgets/DockWindow.vala"
	_tmp41_ = self->priv->_controller;
#line 642 "../lib/Widgets/DockWindow.vala"
	_tmp42_ = plank_dock_controller_get_prefs (_tmp41_);
#line 642 "../lib/Widgets/DockWindow.vala"
	_tmp43_ = _tmp42_;
#line 642 "../lib/Widgets/DockWindow.vala"
	_tmp44_ = plank_dock_preferences_get_Position (_tmp43_);
#line 642 "../lib/Widgets/DockWindow.vala"
	_tmp45_ = _tmp44_;
#line 642 "../lib/Widgets/DockWindow.vala"
	if (_tmp45_ == GTK_POS_TOP) {
#line 3021 "DockWindow.c"
		GeeBidirListIterator* _tmp46_;
#line 643 "../lib/Widgets/DockWindow.vala"
		_tmp46_ = iterator;
#line 643 "../lib/Widgets/DockWindow.vala"
		gee_bidir_iterator_last ((GeeBidirIterator*) _tmp46_);
#line 3027 "DockWindow.c"
		{
			gboolean _tmp47_ = FALSE;
#line 644 "../lib/Widgets/DockWindow.vala"
			_tmp47_ = TRUE;
#line 644 "../lib/Widgets/DockWindow.vala"
			while (TRUE) {
#line 3034 "DockWindow.c"
				GtkMenuItem* menu_item = NULL;
				GeeBidirListIterator* _tmp49_;
				gpointer _tmp50_;
				GtkMenuItem* _tmp51_;
				GtkMenu* _tmp52_;
				GtkMenuItem* _tmp53_;
#line 644 "../lib/Widgets/DockWindow.vala"
				if (!_tmp47_) {
#line 3043 "DockWindow.c"
					GeeBidirListIterator* _tmp48_;
#line 648 "../lib/Widgets/DockWindow.vala"
					_tmp48_ = iterator;
#line 648 "../lib/Widgets/DockWindow.vala"
					if (!gee_bidir_iterator_previous ((GeeBidirIterator*) _tmp48_)) {
#line 648 "../lib/Widgets/DockWindow.vala"
						break;
#line 3051 "DockWindow.c"
					}
				}
#line 644 "../lib/Widgets/DockWindow.vala"
				_tmp47_ = FALSE;
#line 645 "../lib/Widgets/DockWindow.vala"
				_tmp49_ = iterator;
#line 645 "../lib/Widgets/DockWindow.vala"
				_tmp50_ = gee_iterator_get ((GeeIterator*) _tmp49_);
#line 645 "../lib/Widgets/DockWindow.vala"
				menu_item = (GtkMenuItem*) _tmp50_;
#line 646 "../lib/Widgets/DockWindow.vala"
				_tmp51_ = menu_item;
#line 646 "../lib/Widgets/DockWindow.vala"
				gtk_widget_show ((GtkWidget*) _tmp51_);
#line 647 "../lib/Widgets/DockWindow.vala"
				_tmp52_ = self->priv->menu;
#line 647 "../lib/Widgets/DockWindow.vala"
				_tmp53_ = menu_item;
#line 647 "../lib/Widgets/DockWindow.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp52_, _tmp53_);
#line 644 "../lib/Widgets/DockWindow.vala"
				_g_object_unref0 (menu_item);
#line 3074 "DockWindow.c"
			}
		}
	} else {
		GeeBidirListIterator* _tmp54_;
#line 650 "../lib/Widgets/DockWindow.vala"
		_tmp54_ = iterator;
#line 650 "../lib/Widgets/DockWindow.vala"
		gee_bidir_iterator_first ((GeeBidirIterator*) _tmp54_);
#line 3083 "DockWindow.c"
		{
			gboolean _tmp55_ = FALSE;
#line 651 "../lib/Widgets/DockWindow.vala"
			_tmp55_ = TRUE;
#line 651 "../lib/Widgets/DockWindow.vala"
			while (TRUE) {
#line 3090 "DockWindow.c"
				GtkMenuItem* menu_item = NULL;
				GeeBidirListIterator* _tmp57_;
				gpointer _tmp58_;
				GtkMenuItem* _tmp59_;
				GtkMenu* _tmp60_;
				GtkMenuItem* _tmp61_;
#line 651 "../lib/Widgets/DockWindow.vala"
				if (!_tmp55_) {
#line 3099 "DockWindow.c"
					GeeBidirListIterator* _tmp56_;
#line 655 "../lib/Widgets/DockWindow.vala"
					_tmp56_ = iterator;
#line 655 "../lib/Widgets/DockWindow.vala"
					if (!gee_iterator_next ((GeeIterator*) _tmp56_)) {
#line 655 "../lib/Widgets/DockWindow.vala"
						break;
#line 3107 "DockWindow.c"
					}
				}
#line 651 "../lib/Widgets/DockWindow.vala"
				_tmp55_ = FALSE;
#line 652 "../lib/Widgets/DockWindow.vala"
				_tmp57_ = iterator;
#line 652 "../lib/Widgets/DockWindow.vala"
				_tmp58_ = gee_iterator_get ((GeeIterator*) _tmp57_);
#line 652 "../lib/Widgets/DockWindow.vala"
				menu_item = (GtkMenuItem*) _tmp58_;
#line 653 "../lib/Widgets/DockWindow.vala"
				_tmp59_ = menu_item;
#line 653 "../lib/Widgets/DockWindow.vala"
				gtk_widget_show ((GtkWidget*) _tmp59_);
#line 654 "../lib/Widgets/DockWindow.vala"
				_tmp60_ = self->priv->menu;
#line 654 "../lib/Widgets/DockWindow.vala"
				_tmp61_ = menu_item;
#line 654 "../lib/Widgets/DockWindow.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp60_, _tmp61_);
#line 651 "../lib/Widgets/DockWindow.vala"
				_g_object_unref0 (menu_item);
#line 3130 "DockWindow.c"
			}
		}
	}
#line 658 "../lib/Widgets/DockWindow.vala"
	_tmp62_ = self->priv->menu;
#line 658 "../lib/Widgets/DockWindow.vala"
	_tmp63_ = position_func;
#line 658 "../lib/Widgets/DockWindow.vala"
	_tmp63__target = position_func_target;
#line 658 "../lib/Widgets/DockWindow.vala"
	gtk_menu_popup (_tmp62_, NULL, NULL, _tmp63_, _tmp63__target, event->button, event->time);
#line 660 "../lib/Widgets/DockWindow.vala"
	result = TRUE;
#line 660 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (iterator);
#line 660 "../lib/Widgets/DockWindow.vala"
	(position_func_target_destroy_notify == NULL) ? NULL : (position_func_target_destroy_notify (position_func_target), NULL);
#line 660 "../lib/Widgets/DockWindow.vala"
	position_func = NULL;
#line 660 "../lib/Widgets/DockWindow.vala"
	position_func_target = NULL;
#line 660 "../lib/Widgets/DockWindow.vala"
	position_func_target_destroy_notify = NULL;
#line 660 "../lib/Widgets/DockWindow.vala"
	return result;
#line 3156 "DockWindow.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 663 "../lib/Widgets/DockWindow.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 663 "../lib/Widgets/DockWindow.vala"
	return _data19_;
#line 3166 "DockWindow.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 663 "../lib/Widgets/DockWindow.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 663 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (_data19_->controller);
#line 663 "../lib/Widgets/DockWindow.vala"
		g_slice_free (Block19Data, _data19_);
#line 3180 "DockWindow.c"
	}
}

static void
__lambda52_ (Block19Data* _data19_)
{
	PlankSystem* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 673 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 673 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_config_folder (_data19_->controller);
#line 673 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 673 "../lib/Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp2_);
#line 3198 "DockWindow.c"
}

static void
___lambda52__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 672 "../lib/Widgets/DockWindow.vala"
	__lambda52_ (self);
#line 3207 "DockWindow.c"
}

static void
__lambda53_ (Block19Data* _data19_)
{
	PlankSystem* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockTheme* _tmp3_;
	PlankDockTheme* _tmp4_;
	GFile* _tmp5_;
#line 679 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 679 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_data19_->controller);
#line 679 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 679 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = plank_dock_renderer_get_theme (_tmp2_);
#line 679 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 679 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = plank_preferences_get_backing_file ((PlankPreferences*) _tmp4_);
#line 679 "../lib/Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp5_);
#line 3233 "DockWindow.c"
}

static void
___lambda53__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 678 "../lib/Widgets/DockWindow.vala"
	__lambda53_ (self);
#line 3242 "DockWindow.c"
}

static GeeArrayList*
plank_dock_window_get_dock_debug_menu_items (PlankDockController* controller)
{
	Block19Data* _data19_;
	PlankDockController* _tmp0_;
	GeeArrayList* debug_items = NULL;
	GeeArrayList* _tmp1_;
	GtkSeparatorMenuItem* _tmp2_;
	GtkSeparatorMenuItem* _tmp3_;
	GtkMenuItem* menu_item = NULL;
	GtkMenuItem* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GeeArrayList* result;
#line 663 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 663 "../lib/Widgets/DockWindow.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 663 "../lib/Widgets/DockWindow.vala"
	_data19_->_ref_count_ = 1;
#line 663 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = _g_object_ref0 (controller);
#line 663 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (_data19_->controller);
#line 663 "../lib/Widgets/DockWindow.vala"
	_data19_->controller = _tmp0_;
#line 665 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 665 "../lib/Widgets/DockWindow.vala"
	debug_items = _tmp1_;
#line 667 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 667 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 667 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = _tmp2_;
#line 667 "../lib/Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) debug_items, (GtkMenuItem*) _tmp3_);
#line 667 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 671 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open config folder");
#line 671 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 671 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 671 "../lib/Widgets/DockWindow.vala"
	menu_item = _tmp4_;
#line 672 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = menu_item;
#line 672 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp5_, "activate", (GCallback) ___lambda52__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 675 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = menu_item;
#line 675 "../lib/Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) debug_items, _tmp6_);
#line 677 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open current theme file");
#line 677 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 677 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 677 "../lib/Widgets/DockWindow.vala"
	menu_item = _tmp7_;
#line 678 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = menu_item;
#line 678 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp8_, "activate", (GCallback) ___lambda53__gtk_menu_item_activate, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 681 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = menu_item;
#line 681 "../lib/Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) debug_items, _tmp9_);
#line 683 "../lib/Widgets/DockWindow.vala"
	result = debug_items;
#line 683 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 683 "../lib/Widgets/DockWindow.vala"
	block19_data_unref (_data19_);
#line 683 "../lib/Widgets/DockWindow.vala"
	_data19_ = NULL;
#line 683 "../lib/Widgets/DockWindow.vala"
	return result;
#line 3330 "DockWindow.c"
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 686 "../lib/Widgets/DockWindow.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 686 "../lib/Widgets/DockWindow.vala"
	return _data20_;
#line 3340 "DockWindow.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 686 "../lib/Widgets/DockWindow.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 686 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (_data20_->dock_item_file);
#line 686 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (_data20_->item);
#line 686 "../lib/Widgets/DockWindow.vala"
		g_slice_free (Block20Data, _data20_);
#line 3356 "DockWindow.c"
	}
}

static void
__lambda54_ (Block20Data* _data20_)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
#line 698 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = _data20_->dock_item_file;
#line 698 "../lib/Widgets/DockWindow.vala"
	if (_tmp1_ != NULL) {
#line 3375 "DockWindow.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
#line 698 "../lib/Widgets/DockWindow.vala"
		_tmp2_ = _data20_->dock_item_file;
#line 698 "../lib/Widgets/DockWindow.vala"
		_tmp3_ = g_file_get_uri (_tmp2_);
#line 698 "../lib/Widgets/DockWindow.vala"
		_g_free0 (_tmp0_);
#line 698 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = _tmp3_;
#line 3386 "DockWindow.c"
	} else {
		gchar* _tmp4_;
#line 698 "../lib/Widgets/DockWindow.vala"
		_tmp4_ = g_strdup ("");
#line 698 "../lib/Widgets/DockWindow.vala"
		_g_free0 (_tmp0_);
#line 698 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = _tmp4_;
#line 3395 "DockWindow.c"
	}
#line 697 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = plank_dock_element_get_Text ((PlankDockElement*) _data20_->item);
#line 697 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = _tmp5_;
#line 697 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = plank_dock_item_get_Icon (_data20_->item);
#line 697 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = _tmp7_;
#line 697 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = plank_dock_item_get_Launcher (_data20_->item);
#line 697 "../lib/Widgets/DockWindow.vala"
	_tmp10_ = _tmp9_;
#line 697 "../lib/Widgets/DockWindow.vala"
	g_print ("DockItemFile: '%s'\nText = '%s'\nIcon = '%s'\nLauncher = '%s'\n", _tmp0_, _tmp6_, _tmp8_, _tmp10_);
#line 696 "../lib/Widgets/DockWindow.vala"
	_g_free0 (_tmp0_);
#line 3413 "DockWindow.c"
}

static void
___lambda54__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 696 "../lib/Widgets/DockWindow.vala"
	__lambda54_ (self);
#line 3422 "DockWindow.c"
}

static void
__lambda55_ (Block20Data* _data20_)
{
	PlankSystem* _tmp0_;
	GFile* _tmp1_;
#line 705 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 705 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = _data20_->dock_item_file;
#line 705 "../lib/Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp1_);
#line 3436 "DockWindow.c"
}

static void
___lambda55__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 704 "../lib/Widgets/DockWindow.vala"
	__lambda55_ (self);
#line 3445 "DockWindow.c"
}

static void
__lambda56_ (Block20Data* _data20_)
{
	PlankSystem* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 712 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = plank_system_get_default ();
#line 712 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_item_get_Launcher (_data20_->item);
#line 712 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 712 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 712 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 712 "../lib/Widgets/DockWindow.vala"
	plank_system_open (_tmp0_, _tmp4_);
#line 712 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 3470 "DockWindow.c"
}

static void
___lambda56__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 711 "../lib/Widgets/DockWindow.vala"
	__lambda56_ (self);
#line 3479 "DockWindow.c"
}

static GeeArrayList*
plank_dock_window_get_item_debug_menu_items (PlankDockItem* item)
{
	Block20Data* _data20_;
	PlankDockItem* _tmp0_;
	GeeArrayList* debug_items = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GtkSeparatorMenuItem* _tmp3_;
	GtkSeparatorMenuItem* _tmp4_;
	GtkMenuItem* menu_item = NULL;
	PlankDockItemPreferences* _tmp5_;
	PlankDockItemPreferences* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	GeeArrayList* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	GtkMenuItem* _tmp18_;
	GeeArrayList* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenuItem* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GeeArrayList* _tmp26_;
	GtkMenuItem* _tmp27_;
	GeeArrayList* result;
#line 686 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 686 "../lib/Widgets/DockWindow.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 686 "../lib/Widgets/DockWindow.vala"
	_data20_->_ref_count_ = 1;
#line 686 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = _g_object_ref0 (item);
#line 686 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (_data20_->item);
#line 686 "../lib/Widgets/DockWindow.vala"
	_data20_->item = _tmp0_;
#line 688 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 688 "../lib/Widgets/DockWindow.vala"
	debug_items = _tmp1_;
#line 690 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = debug_items;
#line 690 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 690 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 690 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = _tmp3_;
#line 690 "../lib/Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, (GtkMenuItem*) _tmp4_);
#line 690 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 694 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = plank_dock_item_get_Prefs (_data20_->item);
#line 694 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = _tmp5_;
#line 694 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = plank_preferences_get_backing_file ((PlankPreferences*) _tmp6_);
#line 694 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 694 "../lib/Widgets/DockWindow.vala"
	_data20_->dock_item_file = _tmp8_;
#line 695 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Print info to stdout");
#line 695 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 695 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 695 "../lib/Widgets/DockWindow.vala"
	menu_item = _tmp9_;
#line 696 "../lib/Widgets/DockWindow.vala"
	_tmp10_ = menu_item;
#line 696 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp10_, "activate", (GCallback) ___lambda54__gtk_menu_item_activate, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
#line 701 "../lib/Widgets/DockWindow.vala"
	_tmp11_ = debug_items;
#line 701 "../lib/Widgets/DockWindow.vala"
	_tmp12_ = menu_item;
#line 701 "../lib/Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 703 "../lib/Widgets/DockWindow.vala"
	_tmp13_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open dockitem file");
#line 703 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 703 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 703 "../lib/Widgets/DockWindow.vala"
	menu_item = _tmp13_;
#line 704 "../lib/Widgets/DockWindow.vala"
	_tmp14_ = menu_item;
#line 704 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp14_, "activate", (GCallback) ___lambda55__gtk_menu_item_activate, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
#line 707 "../lib/Widgets/DockWindow.vala"
	_tmp16_ = _data20_->dock_item_file;
#line 707 "../lib/Widgets/DockWindow.vala"
	if (_tmp16_ != NULL) {
#line 3588 "DockWindow.c"
		GFile* _tmp17_;
#line 707 "../lib/Widgets/DockWindow.vala"
		_tmp17_ = _data20_->dock_item_file;
#line 707 "../lib/Widgets/DockWindow.vala"
		_tmp15_ = g_file_query_exists (_tmp17_, NULL);
#line 3594 "DockWindow.c"
	} else {
#line 707 "../lib/Widgets/DockWindow.vala"
		_tmp15_ = FALSE;
#line 3598 "DockWindow.c"
	}
#line 707 "../lib/Widgets/DockWindow.vala"
	_tmp18_ = menu_item;
#line 707 "../lib/Widgets/DockWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, _tmp15_);
#line 708 "../lib/Widgets/DockWindow.vala"
	_tmp19_ = debug_items;
#line 708 "../lib/Widgets/DockWindow.vala"
	_tmp20_ = menu_item;
#line 708 "../lib/Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 710 "../lib/Widgets/DockWindow.vala"
	_tmp21_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Open launcher file");
#line 710 "../lib/Widgets/DockWindow.vala"
	g_object_ref_sink (_tmp21_);
#line 710 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 710 "../lib/Widgets/DockWindow.vala"
	menu_item = _tmp21_;
#line 711 "../lib/Widgets/DockWindow.vala"
	_tmp22_ = menu_item;
#line 711 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_data (_tmp22_, "activate", (GCallback) ___lambda56__gtk_menu_item_activate, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
#line 714 "../lib/Widgets/DockWindow.vala"
	_tmp23_ = menu_item;
#line 714 "../lib/Widgets/DockWindow.vala"
	_tmp24_ = plank_dock_item_get_Launcher (_data20_->item);
#line 714 "../lib/Widgets/DockWindow.vala"
	_tmp25_ = _tmp24_;
#line 714 "../lib/Widgets/DockWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, g_strcmp0 (_tmp25_, "") != 0);
#line 715 "../lib/Widgets/DockWindow.vala"
	_tmp26_ = debug_items;
#line 715 "../lib/Widgets/DockWindow.vala"
	_tmp27_ = menu_item;
#line 715 "../lib/Widgets/DockWindow.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 717 "../lib/Widgets/DockWindow.vala"
	result = debug_items;
#line 717 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (menu_item);
#line 717 "../lib/Widgets/DockWindow.vala"
	block20_data_unref (_data20_);
#line 717 "../lib/Widgets/DockWindow.vala"
	_data20_ = NULL;
#line 717 "../lib/Widgets/DockWindow.vala"
	return result;
#line 3646 "DockWindow.c"
}

/**
 * Called when the popup menu hides.
 */
static void
plank_dock_window_on_menu_hide (PlankDockWindow* self)
{
	PlankHideManager* hide_manager = NULL;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	PlankHideManager* _tmp3_;
	PlankHideManager* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 723 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 725 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_update_icon_regions (self);
#line 726 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 726 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 726 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 726 "../lib/Widgets/DockWindow.vala"
	hide_manager = _tmp2_;
#line 727 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = hide_manager;
#line 727 "../lib/Widgets/DockWindow.vala"
	plank_hide_manager_update_hovered (_tmp3_);
#line 728 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = hide_manager;
#line 728 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = plank_hide_manager_get_Hovered (_tmp4_);
#line 728 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = _tmp5_;
#line 728 "../lib/Widgets/DockWindow.vala"
	if (!_tmp6_) {
#line 729 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered_provider (self, NULL);
#line 730 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_hovered (self, NULL);
#line 3691 "DockWindow.c"
	}
#line 733 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu_items);
#line 733 "../lib/Widgets/DockWindow.vala"
	self->priv->menu_items = NULL;
#line 3697 "DockWindow.c"
}

/**
 * Called when the popup menu shows.
 */
static void
plank_dock_window_on_menu_show (PlankDockWindow* self)
{
	PlankDockController* _tmp0_;
	PlankHoverWindow* _tmp1_;
	PlankHoverWindow* _tmp2_;
	PlankDockController* _tmp3_;
	PlankDockRenderer* _tmp4_;
	PlankDockRenderer* _tmp5_;
#line 739 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 741 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_update_icon_regions (self);
#line 742 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 742 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_hover (_tmp0_);
#line 742 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 742 "../lib/Widgets/DockWindow.vala"
	gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 743 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = self->priv->_controller;
#line 743 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = plank_dock_controller_get_renderer (_tmp3_);
#line 743 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = _tmp4_;
#line 743 "../lib/Widgets/DockWindow.vala"
	plank_renderer_animated_draw ((PlankRenderer*) _tmp5_);
#line 3732 "DockWindow.c"
}

/**
 * Positions the popup menu.
 *
 * @param menu the popup menu to show
 * @param x the x location to show the menu
 * @param y the y location to show the menu
 * @param push_in if the menu should push into the screen
 */
static void
plank_dock_window_position_menu (GtkMenu* menu,
                                 gint* x,
                                 gint* y,
                                 gboolean* push_in,
                                 PlankDockWindow* self)
{
	gboolean _vala_push_in = FALSE;
	GtkRequisition requisition = {0};
	GtkRequisition _tmp0_ = {0};
	PlankDockController* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankPositionManager* _tmp3_;
	PlankDockItem* _tmp4_;
	GtkRequisition _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
#line 755 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 755 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (menu != NULL);
#line 758 "../lib/Widgets/DockWindow.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) menu, NULL, &_tmp0_);
#line 758 "../lib/Widgets/DockWindow.vala"
	requisition = _tmp0_;
#line 759 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = self->priv->_controller;
#line 759 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = plank_dock_controller_get_position_manager (_tmp1_);
#line 759 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = _tmp2_;
#line 759 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = self->priv->_HoveredItem;
#line 759 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = requisition;
#line 759 "../lib/Widgets/DockWindow.vala"
	plank_position_manager_get_menu_position (_tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 759 "../lib/Widgets/DockWindow.vala"
	*x = _tmp6_;
#line 759 "../lib/Widgets/DockWindow.vala"
	*y = _tmp7_;
#line 760 "../lib/Widgets/DockWindow.vala"
	_vala_push_in = FALSE;
#line 755 "../lib/Widgets/DockWindow.vala"
	if (push_in) {
#line 755 "../lib/Widgets/DockWindow.vala"
		*push_in = _vala_push_in;
#line 3790 "DockWindow.c"
	}
}

static gboolean
_cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                            const cairo_rectangle_int_t * s2)
{
#line 773 "../lib/Widgets/DockWindow.vala"
	if (s1 == s2) {
#line 773 "../lib/Widgets/DockWindow.vala"
		return TRUE;
#line 3802 "DockWindow.c"
	}
#line 773 "../lib/Widgets/DockWindow.vala"
	if (s1 == NULL) {
#line 773 "../lib/Widgets/DockWindow.vala"
		return FALSE;
#line 3808 "DockWindow.c"
	}
#line 773 "../lib/Widgets/DockWindow.vala"
	if (s2 == NULL) {
#line 773 "../lib/Widgets/DockWindow.vala"
		return FALSE;
#line 3814 "DockWindow.c"
	}
#line 773 "../lib/Widgets/DockWindow.vala"
	if (s1->x != s2->x) {
#line 773 "../lib/Widgets/DockWindow.vala"
		return FALSE;
#line 3820 "DockWindow.c"
	}
#line 773 "../lib/Widgets/DockWindow.vala"
	if (s1->y != s2->y) {
#line 773 "../lib/Widgets/DockWindow.vala"
		return FALSE;
#line 3826 "DockWindow.c"
	}
#line 773 "../lib/Widgets/DockWindow.vala"
	if (s1->width != s2->width) {
#line 773 "../lib/Widgets/DockWindow.vala"
		return FALSE;
#line 3832 "DockWindow.c"
	}
#line 773 "../lib/Widgets/DockWindow.vala"
	if (s1->height != s2->height) {
#line 773 "../lib/Widgets/DockWindow.vala"
		return FALSE;
#line 3838 "DockWindow.c"
	}
#line 773 "../lib/Widgets/DockWindow.vala"
	return TRUE;
#line 3842 "DockWindow.c"
}

static void
plank_dock_window_set_input_mask (PlankDockWindow* self)
{
	GdkRectangle cursor_rect = {0};
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	GdkRectangle _tmp3_ = {0};
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
#line 763 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 765 "../lib/Widgets/DockWindow.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 766 "../lib/Widgets/DockWindow.vala"
		return;
#line 3863 "DockWindow.c"
	}
#line 768 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 768 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 768 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 768 "../lib/Widgets/DockWindow.vala"
	plank_position_manager_get_cursor_region (_tmp2_, &_tmp3_);
#line 768 "../lib/Widgets/DockWindow.vala"
	cursor_rect = _tmp3_;
#line 770 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = cursor_rect;
#line 770 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (_tmp4_.width > 0);
#line 771 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = cursor_rect;
#line 771 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (_tmp5_.height > 0);
#line 773 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = cursor_rect;
#line 773 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = self->priv->input_rect;
#line 773 "../lib/Widgets/DockWindow.vala"
	if (_cairo_rectangle_int_equal (&_tmp6_, &_tmp7_) != TRUE) {
#line 3889 "DockWindow.c"
		GdkRectangle _tmp8_;
		GdkWindow* _tmp9_;
		GdkRectangle _tmp10_;
		cairo_rectangle_int_t _tmp11_;
		cairo_region_t* _tmp12_;
		cairo_region_t* _tmp13_;
#line 774 "../lib/Widgets/DockWindow.vala"
		_tmp8_ = cursor_rect;
#line 774 "../lib/Widgets/DockWindow.vala"
		self->priv->input_rect = _tmp8_;
#line 775 "../lib/Widgets/DockWindow.vala"
		_tmp9_ = gtk_widget_get_window ((GtkWidget*) self);
#line 775 "../lib/Widgets/DockWindow.vala"
		_tmp10_ = cursor_rect;
#line 775 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = (cairo_rectangle_int_t) _tmp10_;
#line 775 "../lib/Widgets/DockWindow.vala"
		_tmp12_ = cairo_region_create_rectangle (&_tmp11_);
#line 775 "../lib/Widgets/DockWindow.vala"
		_tmp13_ = _tmp12_;
#line 775 "../lib/Widgets/DockWindow.vala"
		gdk_window_input_shape_combine_region (_tmp9_, _tmp13_, 0, 0);
#line 775 "../lib/Widgets/DockWindow.vala"
		_cairo_region_destroy0 (_tmp13_);
#line 3914 "DockWindow.c"
	}
}

static void
plank_dock_window_set_struts (PlankDockWindow* self)
{
	GdkX11Display* gdk_display = NULL;
	GdkDisplay* _tmp0_;
	GdkX11Display* _tmp1_;
	GdkX11Window* gdk_window = NULL;
	GdkWindow* _tmp2_;
	GdkX11Window* _tmp3_;
	gulong* struts = NULL;
	gulong* _tmp4_;
	gint struts_length1;
	gint _struts_size_;
	PlankDockController* _tmp5_;
	PlankDockPreferences* _tmp6_;
	PlankDockPreferences* _tmp7_;
	PlankHideType _tmp8_;
	PlankHideType _tmp9_;
	gulong* first_struts = NULL;
	gulong* _tmp13_;
	gint first_struts_length1;
	gint _first_struts_size_;
	Display* display = NULL;
	GdkX11Display* _tmp20_;
	Display* _tmp21_;
	Window xid = 0;
	GdkX11Window* _tmp22_;
	GdkX11Display* _tmp23_;
	Display* _tmp24_;
	Display* _tmp25_;
	gulong* _tmp26_;
	gint _tmp26__length1;
	gulong* _tmp27_;
	gint _tmp27__length1;
	Display* _tmp28_;
	Display* _tmp29_;
	gulong* _tmp30_;
	gint _tmp30__length1;
	gulong* _tmp31_;
	gint _tmp31__length1;
	GdkX11Display* _tmp32_;
#line 779 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 781 "../lib/Widgets/DockWindow.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 782 "../lib/Widgets/DockWindow.vala"
		return;
#line 3965 "DockWindow.c"
	}
#line 784 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 784 "../lib/Widgets/DockWindow.vala"
	gdk_display = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp0_) : NULL;
#line 785 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = gdk_display;
#line 785 "../lib/Widgets/DockWindow.vala"
	if (_tmp1_ == NULL) {
#line 786 "../lib/Widgets/DockWindow.vala"
		return;
#line 3977 "DockWindow.c"
	}
#line 788 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 788 "../lib/Widgets/DockWindow.vala"
	gdk_window = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp2_) : NULL;
#line 789 "../lib/Widgets/DockWindow.vala"
	_tmp3_ = gdk_window;
#line 789 "../lib/Widgets/DockWindow.vala"
	if (_tmp3_ == NULL) {
#line 790 "../lib/Widgets/DockWindow.vala"
		return;
#line 3989 "DockWindow.c"
	}
#line 792 "../lib/Widgets/DockWindow.vala"
	_tmp4_ = g_new0 (gulong, PLANK_STRUTS_N_VALUES);
#line 792 "../lib/Widgets/DockWindow.vala"
	struts = _tmp4_;
#line 792 "../lib/Widgets/DockWindow.vala"
	struts_length1 = PLANK_STRUTS_N_VALUES;
#line 792 "../lib/Widgets/DockWindow.vala"
	_struts_size_ = struts_length1;
#line 794 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 794 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_prefs (_tmp5_);
#line 794 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 794 "../lib/Widgets/DockWindow.vala"
	_tmp8_ = plank_dock_preferences_get_HideMode (_tmp7_);
#line 794 "../lib/Widgets/DockWindow.vala"
	_tmp9_ = _tmp8_;
#line 794 "../lib/Widgets/DockWindow.vala"
	if (_tmp9_ == PLANK_HIDE_TYPE_NONE) {
#line 4011 "DockWindow.c"
		PlankDockController* _tmp10_;
		PlankPositionManager* _tmp11_;
		PlankPositionManager* _tmp12_;
#line 795 "../lib/Widgets/DockWindow.vala"
		_tmp10_ = self->priv->_controller;
#line 795 "../lib/Widgets/DockWindow.vala"
		_tmp11_ = plank_dock_controller_get_position_manager (_tmp10_);
#line 795 "../lib/Widgets/DockWindow.vala"
		_tmp12_ = _tmp11_;
#line 795 "../lib/Widgets/DockWindow.vala"
		plank_position_manager_get_struts (_tmp12_, &struts, (gint*) (&struts_length1));
#line 795 "../lib/Widgets/DockWindow.vala"
		_struts_size_ = struts_length1;
#line 4025 "DockWindow.c"
	}
#line 797 "../lib/Widgets/DockWindow.vala"
	_tmp13_ = g_new0 (gulong, PLANK_STRUTS_BOTTOM + 1);
#line 797 "../lib/Widgets/DockWindow.vala"
	first_struts = _tmp13_;
#line 797 "../lib/Widgets/DockWindow.vala"
	first_struts_length1 = PLANK_STRUTS_BOTTOM + 1;
#line 797 "../lib/Widgets/DockWindow.vala"
	_first_struts_size_ = first_struts_length1;
#line 4035 "DockWindow.c"
	{
		gint i = 0;
#line 798 "../lib/Widgets/DockWindow.vala"
		i = 0;
#line 4040 "DockWindow.c"
		{
			gboolean _tmp14_ = FALSE;
#line 798 "../lib/Widgets/DockWindow.vala"
			_tmp14_ = TRUE;
#line 798 "../lib/Widgets/DockWindow.vala"
			while (TRUE) {
#line 4047 "DockWindow.c"
				gulong* _tmp16_;
				gint _tmp16__length1;
				gulong* _tmp17_;
				gint _tmp17__length1;
				gulong* _tmp18_;
				gint _tmp18__length1;
				gulong _tmp19_;
#line 798 "../lib/Widgets/DockWindow.vala"
				if (!_tmp14_) {
#line 4057 "DockWindow.c"
					gint _tmp15_;
#line 798 "../lib/Widgets/DockWindow.vala"
					_tmp15_ = i;
#line 798 "../lib/Widgets/DockWindow.vala"
					i = _tmp15_ + 1;
#line 4063 "DockWindow.c"
				}
#line 798 "../lib/Widgets/DockWindow.vala"
				_tmp14_ = FALSE;
#line 798 "../lib/Widgets/DockWindow.vala"
				_tmp16_ = first_struts;
#line 798 "../lib/Widgets/DockWindow.vala"
				_tmp16__length1 = first_struts_length1;
#line 798 "../lib/Widgets/DockWindow.vala"
				if (!(i < _tmp16__length1)) {
#line 798 "../lib/Widgets/DockWindow.vala"
					break;
#line 4075 "DockWindow.c"
				}
#line 799 "../lib/Widgets/DockWindow.vala"
				_tmp17_ = first_struts;
#line 799 "../lib/Widgets/DockWindow.vala"
				_tmp17__length1 = first_struts_length1;
#line 799 "../lib/Widgets/DockWindow.vala"
				_tmp18_ = struts;
#line 799 "../lib/Widgets/DockWindow.vala"
				_tmp18__length1 = struts_length1;
#line 799 "../lib/Widgets/DockWindow.vala"
				_tmp19_ = _tmp18_[i];
#line 799 "../lib/Widgets/DockWindow.vala"
				_tmp17_[i] = _tmp19_;
#line 4089 "DockWindow.c"
			}
		}
	}
#line 801 "../lib/Widgets/DockWindow.vala"
	_tmp20_ = gdk_display;
#line 801 "../lib/Widgets/DockWindow.vala"
	_tmp21_ = gdk_x11_display_get_xdisplay (_tmp20_);
#line 801 "../lib/Widgets/DockWindow.vala"
	display = _tmp21_;
#line 802 "../lib/Widgets/DockWindow.vala"
	_tmp22_ = gdk_window;
#line 802 "../lib/Widgets/DockWindow.vala"
	xid = gdk_x11_window_get_xid (_tmp22_);
#line 804 "../lib/Widgets/DockWindow.vala"
	_tmp23_ = gdk_display;
#line 804 "../lib/Widgets/DockWindow.vala"
	gdk_x11_display_error_trap_push (_tmp23_);
#line 805 "../lib/Widgets/DockWindow.vala"
	_tmp24_ = display;
#line 805 "../lib/Widgets/DockWindow.vala"
	_tmp25_ = display;
#line 805 "../lib/Widgets/DockWindow.vala"
	_tmp26_ = struts;
#line 805 "../lib/Widgets/DockWindow.vala"
	_tmp26__length1 = struts_length1;
#line 805 "../lib/Widgets/DockWindow.vala"
	_tmp27_ = struts;
#line 805 "../lib/Widgets/DockWindow.vala"
	_tmp27__length1 = struts_length1;
#line 805 "../lib/Widgets/DockWindow.vala"
	XChangeProperty (_tmp24_, xid, XInternAtom (_tmp25_, "_NET_WM_STRUT_PARTIAL", FALSE), XA_CARDINAL, 32, (gint) PropModeReplace, (guchar*) _tmp26_, _tmp27__length1);
#line 807 "../lib/Widgets/DockWindow.vala"
	_tmp28_ = display;
#line 807 "../lib/Widgets/DockWindow.vala"
	_tmp29_ = display;
#line 807 "../lib/Widgets/DockWindow.vala"
	_tmp30_ = first_struts;
#line 807 "../lib/Widgets/DockWindow.vala"
	_tmp30__length1 = first_struts_length1;
#line 807 "../lib/Widgets/DockWindow.vala"
	_tmp31_ = first_struts;
#line 807 "../lib/Widgets/DockWindow.vala"
	_tmp31__length1 = first_struts_length1;
#line 807 "../lib/Widgets/DockWindow.vala"
	XChangeProperty (_tmp28_, xid, XInternAtom (_tmp29_, "_NET_WM_STRUT", FALSE), XA_CARDINAL, 32, (gint) PropModeReplace, (guchar*) _tmp30_, _tmp31__length1);
#line 809 "../lib/Widgets/DockWindow.vala"
	_tmp32_ = gdk_display;
#line 809 "../lib/Widgets/DockWindow.vala"
	if (gdk_x11_display_error_trap_pop (_tmp32_) != Success) {
#line 810 "../lib/Widgets/DockWindow.vala"
		g_critical ("DockWindow.vala:810: Error while setting struts");
#line 4141 "DockWindow.c"
	}
#line 779 "../lib/Widgets/DockWindow.vala"
	first_struts = (g_free (first_struts), NULL);
#line 779 "../lib/Widgets/DockWindow.vala"
	struts = (g_free (struts), NULL);
#line 4147 "DockWindow.c"
}

static PlankDockController*
plank_dock_window_get_controller (PlankDockWindow* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 33 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 33 "../lib/Widgets/DockWindow.vala"
	result = _tmp0_;
#line 33 "../lib/Widgets/DockWindow.vala"
	return result;
#line 4163 "DockWindow.c"
}

static void
plank_dock_window_set_controller (PlankDockWindow* self,
                                  PlankDockController* value)
{
	PlankDockController* old_value;
#line 33 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/Widgets/DockWindow.vala"
	old_value = plank_dock_window_get_controller (self);
#line 33 "../lib/Widgets/DockWindow.vala"
	if (old_value != value) {
#line 4177 "DockWindow.c"
		PlankDockController* _tmp0_;
#line 33 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->_controller);
#line 33 "../lib/Widgets/DockWindow.vala"
		self->priv->_controller = _tmp0_;
#line 33 "../lib/Widgets/DockWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_window_properties[PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY]);
#line 4187 "DockWindow.c"
	}
}

PlankDockItem*
plank_dock_window_get_HoveredItem (PlankDockWindow* self)
{
	PlankDockItem* result;
	PlankDockItem* _tmp0_;
#line 39 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItem;
#line 39 "../lib/Widgets/DockWindow.vala"
	result = _tmp0_;
#line 39 "../lib/Widgets/DockWindow.vala"
	return result;
#line 4204 "DockWindow.c"
}

static void
plank_dock_window_set_HoveredItem (PlankDockWindow* self,
                                   PlankDockItem* value)
{
	PlankDockItem* old_value;
#line 39 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 39 "../lib/Widgets/DockWindow.vala"
	old_value = plank_dock_window_get_HoveredItem (self);
#line 39 "../lib/Widgets/DockWindow.vala"
	if (old_value != value) {
#line 4218 "DockWindow.c"
		PlankDockItem* _tmp0_;
#line 39 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->_HoveredItem);
#line 39 "../lib/Widgets/DockWindow.vala"
		self->priv->_HoveredItem = _tmp0_;
#line 39 "../lib/Widgets/DockWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY]);
#line 4228 "DockWindow.c"
	}
}

PlankDockItemProvider*
plank_dock_window_get_HoveredItemProvider (PlankDockWindow* self)
{
	PlankDockItemProvider* result;
	PlankDockItemProvider* _tmp0_;
#line 44 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_HoveredItemProvider;
#line 44 "../lib/Widgets/DockWindow.vala"
	result = _tmp0_;
#line 44 "../lib/Widgets/DockWindow.vala"
	return result;
#line 4245 "DockWindow.c"
}

static void
plank_dock_window_set_HoveredItemProvider (PlankDockWindow* self,
                                           PlankDockItemProvider* value)
{
	PlankDockItemProvider* old_value;
#line 44 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 44 "../lib/Widgets/DockWindow.vala"
	old_value = plank_dock_window_get_HoveredItemProvider (self);
#line 44 "../lib/Widgets/DockWindow.vala"
	if (old_value != value) {
#line 4259 "DockWindow.c"
		PlankDockItemProvider* _tmp0_;
#line 44 "../lib/Widgets/DockWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 44 "../lib/Widgets/DockWindow.vala"
		_g_object_unref0 (self->priv->_HoveredItemProvider);
#line 44 "../lib/Widgets/DockWindow.vala"
		self->priv->_HoveredItemProvider = _tmp0_;
#line 44 "../lib/Widgets/DockWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY]);
#line 4269 "DockWindow.c"
	}
}

static PlankDockItem*
plank_dock_window_get_ClickedItem (PlankDockWindow* self)
{
	PlankDockItem* result;
	PlankDockItem* _tmp0_;
#line 50 "../lib/Widgets/DockWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_ClickedItem;
#line 50 "../lib/Widgets/DockWindow.vala"
	result = _tmp0_;
#line 50 "../lib/Widgets/DockWindow.vala"
	return result;
#line 4286 "DockWindow.c"
}

static void
plank_dock_window_set_ClickedItem (PlankDockWindow* self,
                                   PlankDockItem* value)
{
#line 50 "../lib/Widgets/DockWindow.vala"
	g_return_if_fail (self != NULL);
#line 50 "../lib/Widgets/DockWindow.vala"
	self->priv->_ClickedItem = value;
#line 4297 "DockWindow.c"
}

static GObject *
plank_dock_window_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDockWindow * self;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
#line 86 "../lib/Widgets/DockWindow.vala"
	parent_class = G_OBJECT_CLASS (plank_dock_window_parent_class);
#line 86 "../lib/Widgets/DockWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 86 "../lib/Widgets/DockWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 88 "../lib/Widgets/DockWindow.vala"
	gtk_window_set_accept_focus ((GtkWindow*) self, FALSE);
#line 89 "../lib/Widgets/DockWindow.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
#line 90 "../lib/Widgets/DockWindow.vala"
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
#line 91 "../lib/Widgets/DockWindow.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
#line 93 "../lib/Widgets/DockWindow.vala"
	gtk_window_stick ((GtkWindow*) self);
#line 95 "../lib/Widgets/DockWindow.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((((((GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK) | GDK_POINTER_MOTION_MASK) | GDK_SCROLL_MASK) | GDK_STRUCTURE_MASK));
#line 103 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 103 "../lib/Widgets/DockWindow.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 103 "../lib/Widgets/DockWindow.vala"
	_tmp2_ = _tmp1_;
#line 103 "../lib/Widgets/DockWindow.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::HideMode", (GCallback) _plank_dock_window_set_struts_g_object_notify, self, 0);
#line 86 "../lib/Widgets/DockWindow.vala"
	return obj;
#line 4339 "DockWindow.c"
}

static void
plank_dock_window_class_init (PlankDockWindowClass * klass,
                              gpointer klass_data)
{
#line 25 "../lib/Widgets/DockWindow.vala"
	plank_dock_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Widgets/DockWindow.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockWindow_private_offset);
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) plank_dock_window_real_button_press_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) plank_dock_window_real_button_release_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) plank_dock_window_real_enter_notify_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) plank_dock_window_real_leave_notify_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) plank_dock_window_real_motion_notify_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->drag_begin = (void (*) (GtkWidget*, GdkDragContext*)) plank_dock_window_real_drag_begin;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->scroll_event = (gboolean (*) (GtkWidget*, GdkEventScroll*)) plank_dock_window_real_scroll_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) plank_dock_window_real_configure_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) plank_dock_window_real_draw;
#line 25 "../lib/Widgets/DockWindow.vala"
	((GtkWidgetClass *) klass)->map_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) plank_dock_window_real_map_event;
#line 25 "../lib/Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_window_get_property;
#line 25 "../lib/Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_window_set_property;
#line 25 "../lib/Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_dock_window_constructor;
#line 25 "../lib/Widgets/DockWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_window_finalize;
#line 4378 "DockWindow.c"
	/**
	 * The controller for this dock.
	 */
#line 25 "../lib/Widgets/DockWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY, plank_dock_window_properties[PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 4384 "DockWindow.c"
	/**
	 * The currently hovered item (if any).
	 */
#line 25 "../lib/Widgets/DockWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY] = g_param_spec_object ("HoveredItem", "HoveredItem", "HoveredItem", PLANK_TYPE_DOCK_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4390 "DockWindow.c"
	/**
	 * The currently hovered item-provider (if any).
	 */
#line 25 "../lib/Widgets/DockWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY, plank_dock_window_properties[PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY] = g_param_spec_object ("HoveredItemProvider", "HoveredItemProvider", "HoveredItemProvider", PLANK_TYPE_DOCK_ITEM_PROVIDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4396 "DockWindow.c"
}

static void
plank_dock_window_instance_init (PlankDockWindow * self,
                                 gpointer klass)
{
#line 25 "../lib/Widgets/DockWindow.vala"
	self->priv = plank_dock_window_get_instance_private (self);
#line 58 "../lib/Widgets/DockWindow.vala"
	self->priv->hover_reposition_timer_id = 0U;
#line 60 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_timer_id = 0U;
#line 61 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_active = FALSE;
#line 62 "../lib/Widgets/DockWindow.vala"
	self->priv->long_press_button = 0U;
#line 67 "../lib/Widgets/DockWindow.vala"
	self->priv->window_position_retry = 0;
#line 4415 "DockWindow.c"
}

static void
plank_dock_window_finalize (GObject * obj)
{
	PlankDockWindow * self;
	GtkMenu* _tmp0_;
	PlankDockController* _tmp5_;
	PlankDockPreferences* _tmp6_;
	PlankDockPreferences* _tmp7_;
	guint _tmp8_;
	GQuark _tmp9_;
#line 25 "../lib/Widgets/DockWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 108 "../lib/Widgets/DockWindow.vala"
	_tmp0_ = self->priv->menu;
#line 108 "../lib/Widgets/DockWindow.vala"
	if (_tmp0_ != NULL) {
#line 4434 "DockWindow.c"
		GtkMenu* _tmp1_;
		guint _tmp2_;
		GtkMenu* _tmp3_;
		guint _tmp4_;
#line 109 "../lib/Widgets/DockWindow.vala"
		_tmp1_ = self->priv->menu;
#line 109 "../lib/Widgets/DockWindow.vala"
		g_signal_parse_name ("show", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 109 "../lib/Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_dock_window_on_menu_show_gtk_widget_show, self);
#line 110 "../lib/Widgets/DockWindow.vala"
		_tmp3_ = self->priv->menu;
#line 110 "../lib/Widgets/DockWindow.vala"
		g_signal_parse_name ("hide", gtk_widget_get_type (), &_tmp4_, NULL, FALSE);
#line 110 "../lib/Widgets/DockWindow.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _plank_dock_window_on_menu_hide_gtk_widget_hide, self);
#line 4451 "DockWindow.c"
	}
#line 113 "../lib/Widgets/DockWindow.vala"
	_tmp5_ = self->priv->_controller;
#line 113 "../lib/Widgets/DockWindow.vala"
	_tmp6_ = plank_dock_controller_get_prefs (_tmp5_);
#line 113 "../lib/Widgets/DockWindow.vala"
	_tmp7_ = _tmp6_;
#line 113 "../lib/Widgets/DockWindow.vala"
	g_signal_parse_name ("notify::HideMode", G_TYPE_OBJECT, &_tmp8_, &_tmp9_, TRUE);
#line 113 "../lib/Widgets/DockWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, _tmp9_, NULL, (GCallback) _plank_dock_window_set_struts_g_object_notify, self);
#line 115 "../lib/Widgets/DockWindow.vala"
	if (self->priv->hover_reposition_timer_id > 0U) {
#line 116 "../lib/Widgets/DockWindow.vala"
		g_source_remove (self->priv->hover_reposition_timer_id);
#line 117 "../lib/Widgets/DockWindow.vala"
		self->priv->hover_reposition_timer_id = 0U;
#line 4469 "DockWindow.c"
	}
#line 33 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->_controller);
#line 39 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->_HoveredItem);
#line 44 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->_HoveredItemProvider);
#line 55 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu);
#line 56 "../lib/Widgets/DockWindow.vala"
	_g_object_unref0 (self->priv->menu_items);
#line 25 "../lib/Widgets/DockWindow.vala"
	G_OBJECT_CLASS (plank_dock_window_parent_class)->finalize (obj);
#line 4483 "DockWindow.c"
}

/**
 * The main window for all docks.
 */
static GType
plank_dock_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockWindow), 0, (GInstanceInitFunc) plank_dock_window_instance_init, NULL };
	GType plank_dock_window_type_id;
	plank_dock_window_type_id = g_type_register_static (PLANK_TYPE_COMPOSITED_WINDOW, "PlankDockWindow", &g_define_type_info, 0);
	PlankDockWindow_private_offset = g_type_add_instance_private (plank_dock_window_type_id, sizeof (PlankDockWindowPrivate));
	return plank_dock_window_type_id;
}

GType
plank_dock_window_get_type (void)
{
	static volatile gsize plank_dock_window_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_window_type_id__once)) {
		GType plank_dock_window_type_id;
		plank_dock_window_type_id = plank_dock_window_get_type_once ();
		g_once_init_leave (&plank_dock_window_type_id__once, plank_dock_window_type_id);
	}
	return plank_dock_window_type_id__once;
}

static void
_vala_plank_dock_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	PlankDockWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 25 "../lib/Widgets/DockWindow.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY:
#line 25 "../lib/Widgets/DockWindow.vala"
		g_value_set_object (value, plank_dock_window_get_controller (self));
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 25 "../lib/Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY:
#line 25 "../lib/Widgets/DockWindow.vala"
		g_value_set_object (value, plank_dock_window_get_HoveredItem (self));
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 25 "../lib/Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY:
#line 25 "../lib/Widgets/DockWindow.vala"
		g_value_set_object (value, plank_dock_window_get_HoveredItemProvider (self));
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 4539 "DockWindow.c"
		default:
#line 25 "../lib/Widgets/DockWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 4545 "DockWindow.c"
	}
}

static void
_vala_plank_dock_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	PlankDockWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_WINDOW, PlankDockWindow);
#line 25 "../lib/Widgets/DockWindow.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_CONTROLLER_PROPERTY:
#line 25 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_controller (self, g_value_get_object (value));
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 25 "../lib/Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROPERTY:
#line 25 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_HoveredItem (self, g_value_get_object (value));
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 25 "../lib/Widgets/DockWindow.vala"
		case PLANK_DOCK_WINDOW_HOVERED_ITEM_PROVIDER_PROPERTY:
#line 25 "../lib/Widgets/DockWindow.vala"
		plank_dock_window_set_HoveredItemProvider (self, g_value_get_object (value));
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 4577 "DockWindow.c"
		default:
#line 25 "../lib/Widgets/DockWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/DockWindow.vala"
		break;
#line 4583 "DockWindow.c"
	}
}

